/******************** (borland=watcom) **************************/

#include "edecfunc.h"

/**************** allocate memory to buffers **********************/
void allocate_mem_buffers(void){
 char z;
  /*text buffers*/
  if ((textb=(char**)calloc(5,sizeof(char*)))
				  ==NULL) outof_memory(textb[0]);
  if ((textb[0]=(char *)calloc(150,sizeof(char)))
				  ==NULL) outof_memory(textb[0]);
  for (z=1;z<=4;z++){
     sprintf(textb[0],"textb[%d]",z);
     if ((textb[z]=(char *)calloc(80,sizeof(char)))
				   ==NULL) outof_memory(textb[0]);
  }
# if (__BORC__||__WATCOM__)
     if ((boximage=(void**)calloc(20,sizeof(void*)))
				   ==NULL) outof_memory("boximage");
				   
     if ((boximage_prompt=(void**)calloc(10,sizeof(void*)))
				   ==NULL) outof_memory("boximage_prompt");
# elif (__UNIX__)
     if ((boximage=calloc(kNumBoxImages,sizeof(Pixmap*)))==NULL)
     	outof_memory("boximage");
				   
     if ((boximage_prompt=calloc(kNumBoxPromptImages,sizeof(Pixmap*)))==NULL)
     	outof_memory("boximage_prompt");
# endif
  
  /*string input buffer*/
  if ((is=(char *)calloc(1024,sizeof(char)))
				   ==NULL) outof_memory("is");
  /*filename*/
  if ((filename=(char *)calloc(13,sizeof(char)))
				   ==NULL) outof_memory("filename");
  /*filename for data*/
  if ((filename_data=(char *)calloc(13,sizeof(char)))
				   ==NULL) outof_memory("filename_data");
  if ((old_dir=(char *)calloc(67,sizeof(char)))
				   ==NULL) outof_memory("old_dir");
  if ((path=(char *)calloc(81,sizeof(char)))
				   ==NULL) outof_memory("path");
  /*boorland <dir.h> MAXDIR+1=67, MAXPATH+1=81*/
  /*unix <sys/param.h> maxpathlen=? */
}

/**************** free memory to buffers **********************/
void free_mem_buffers(void){
 char z;
		for (z=0;z<=4;z++) free(textb[z]);
		free(textb);
		free(boximage);
		free(boximage_prompt);
		free(is);
		free(filename);
		free(filename_data);
		free(old_dir);
		free(path);
}

/************** allocate memory at cell 0 ***************************/
void allocate_mem_rule0(char thisnhood){
 signed short tablebytes;

   tablebytes=(signed short)ceil(pow(2,(double)thisnhood)/8);
   /*one rule only*/
   if ((carule=(char**)calloc(1,sizeof(char*)))
				       ==NULL) outof_memory("carule");
   if ((carule[0]=(char *)calloc(tablebytes,sizeof(char)))
				       ==NULL) outof_memory("carule[0]");
}

/*********** allocate memory rulemix except at cell 0 ******************/
void allocate_mem_rulemix(char thisnhood){
 signed short tablebytes;
 unsigned short zu;

    tablebytes=(signed short)ceil(pow(2,(double)thisnhood)/8);
    /*remainder of rules in rule mix*/
    if ((carule=(char**)realloc(carule,lineL*sizeof(char*)))
					 ==NULL) outof_memory("carule");
    for (zu=1;zu<=lineL-1;zu++){
       sprintf(textb[0],"carule[%d]",zu);
       if ((carule[zu]=(char *)calloc(tablebytes,sizeof(char)))
					==NULL) outof_memory(textb[0]);
    }
}

/************** re-allocate memory, rules ***************************/
void reallocate_mem_rulemix(char thisnhood,char increace){
 signed short tablebytes;
 char z;

    tablebytes=(signed short)ceil(pow(2,(double)thisnhood)/8);
    /*decreace*/
    if (increace<0){
       for (z=1;z<=abs(increace);z++) free(carule[L+z]);
    }
    if ((carule=(char**)realloc(carule,lineL*sizeof(char*)))
					 ==NULL) outof_memory("carule");
    /*increace*/
    if (increace>0){
       for (z=1;z<=increace;z++){
	  sprintf(textb[0],"carule[%d]",lineL-z);
	  if ((carule[lineL-z]=(char *)calloc(tablebytes,sizeof(char)))
					 ==NULL) outof_memory(textb[0]);
       }
    }
}

/*********** free memory rulemix, except cell 0 *****************/
void free_mem_rulemix(void){
  unsigned short zu;

	for (zu=1;zu<=lineL-1;zu++) free(carule[zu]);
}

/**************** free memory rule 0  **********************/
void free_mem_rule0(void){

	free(carule[0]);
	free(carule);
}

/************** allocate memory, totalistic code, at cell0 *************/
void allocate_mem_tcode0(char thisnhood){

   /*one code only*/
   if ((cacode=(char**)calloc(1,sizeof(char*)))
					==NULL) outof_memory("cacode");
   if ((cacode[0]=(char *)calloc((signed short)ceil((double)(thisnhood+1)/8),
			  sizeof(char)))==NULL)outof_memory("cacode[0]");
}

/************** allocate memory, totalistic codes *********************/
void allocate_mem_tcodemix(char thisnhood){
 unsigned short zu;

  /*remainder of rules in rule mix*/
  if ((cacode=(char**)realloc(cacode,lineL*sizeof(char*)))
					 ==NULL) outof_memory("cacode");
  for (zu=1;zu<=lineL-1;zu++){
     sprintf(textb[0],"cacode[%d]",zu);
     if ((cacode[zu]=
	 (char *)calloc((signed short)ceil((double)(thisnhood+1)/8),
			  sizeof(char)))==NULL) outof_memory(textb[0]);
  }
}

/************** re-allocate memory, totalistic codes *********************/
void reallocate_mem_tcodemix(char thisnhood,char increace){
 char z;

    if (increace<0){
       for (z=1;z<=abs(increace);z++) free(cacode[L+z]);
    }
    if ((cacode=(char**)realloc(cacode,lineL*sizeof(char*)))
					==NULL) outof_memory("cacode");
    /*increace*/
    if (increace>0){
       for (z=1;z<=increace;z++){
	  sprintf(textb[0],"carule[%d]",lineL-z);
	  if ((cacode[lineL-z]=
	       (char *)calloc((signed short)ceil((double)(thisnhood+1)/8),
			  sizeof(char)))==NULL) outof_memory(textb[0]);
       }
    }
}

/**************** free memory tcodemix, except cell 0 *********************/
void free_mem_tcodemix(void){
  unsigned short zu;
		for (zu=1;zu<=lineL-1;zu++) free(cacode[zu]);
}

/**************** free memory tcode 0  **********************/
void free_mem_tcode0(void){

	free(cacode[0]);
	free(cacode);
}

/***** allocate memory nodiffrules, rulemix selected from this set *****/
void allocate_mem_diffrules(char thisnhood,signed short nodiffrules){
signed short tablebytes;
unsigned short zu;

	tablebytes=(signed short)ceil(pow(2,(double)thisnhood)/8);
	/*the range of different rules in rule mix*/
	if ((diffrule=(char**)calloc(nodiffrules,sizeof(char*)))
					==NULL) outof_memory("diffrule");
	for (zu=0;zu<=nodiffrules-1;zu++){
		sprintf(textb[0],"diffrule[%d]",zu);
		if ((diffrule[zu]=(char *)calloc(tablebytes,sizeof(char)))
					==NULL) outof_memory(textb[0]);
	}
}
/*********** free memory diffrule *****************/
void free_mem_diffrules(signed short nodiffrules){
  unsigned short zu;

	for (zu=0;zu<=nodiffrules-1;zu++) free(diffrule[zu]);
	free(diffrule);
}

/***** allocate memory nodiffrules, rulemix selected from this set *****/
void allocate_mem_diffcodes(char thisnhood,signed short nodiffrules){
  unsigned short zu;

   /*the range of different codes in code mix*/
   if ((diffcode=(char**)calloc(nodiffrules,sizeof(char*)))
					==NULL) outof_memory("diffcode");
   for (zu=0;zu<=nodiffrules-1;zu++){
      sprintf(textb[0],"diffcode[%d]",zu);
      if ((diffcode[zu]=
	  (char *)calloc((signed short)ceil((double)(thisnhood+1)/8),
			  sizeof(char)))==NULL) outof_memory(textb[0]);
   }
}

/**************** free memory tcodemix, except cell 0 **********************/
void free_mem_diffcodes(signed short nodiffrules){
  unsigned short zu;

    for (zu=0;zu<=nodiffrules-1;zu++) free(diffcode[zu]);
    free(diffcode);
}

/****** allocate memory fo 2 rules consisting of all 0s and all 1s ********/
void allocate_mem_all_0s_all_1s_rules(char thisnhood){
 signed short  tablebytes=(signed short)ceil(pow(2,(double)thisnhood)/8);

   /*for cheching for same n-tupules in rbn pre-image algorithm*/
   sprintf(textb[0],"rule_all_0s");
   if ((rule_all_0s=(char *)calloc(tablebytes,sizeof(char)))
				   ==NULL) outof_memory("rule_all_0s");
   sprintf(textb[0],"rule_all_1s");
   if ((rule_all_1s=(char *)calloc(tablebytes,sizeof(char)))
				   ==NULL) outof_memory("rule_all_1s");
   memset(rule_all_1s, 255, tablebytes); /*set all bits to 1*/
}

/****** free memory fo 2 rules consisting of all 0s and all 1s ********/
void free_mem_all_0s_all_1s_rules(void){
		free(rule_all_0s);
		free(rule_all_1s);
}

/************** allocate memory nhood matrix *******************/
void allocate_mem_nhood_matrix(char thisnhood){
 char z;
 signed short  zz,tablebytes,outertable,temp,sod;

   if (thisnhood<=5) thisnhood=5;
   tablebytes=(signed short)ceil(pow(2,(double)thisnhood)/8);
   /*allocate mem to n=9 n'hood matrix*/
   if( (nm=(char**) calloc(thisnhood,sizeof(char*)))
					==NULL) outof_memory("nm");
   for (z=0;z<=thisnhood-1;z++){
      sprintf(textb[0],"nm[%d]",z);
      if ((nm[z]=(char *)calloc(tablebytes,sizeof(char)))
					==NULL) outof_memory(textb[0]);
   }
   /*set memory*/
   outertable=(signed short)pow(2,(double)thisnhood)-1;
   for (zz=outertable;zz>=0;zz--){
		sod=zz;
		for (z=thisnhood-1;z>=0;z--){
			temp=sod/(signed short)pow(2,(double)z);
			if (temp==1) {
				set_bit1(nm[z],zz);
				sod=sod-(signed short)pow(2,(double)z);
			}
			else set_bit0(nm[z],zz);
		}
   }

   /*canalyzing inputs are stored as bits in the 2 byte word, max nhood=16*/
   if ((canal=(char *)calloc(2,sizeof(char)))==NULL)
				     outof_memory("canal");
}

/**************** free memory for nhood matrix **********************/
void free_mem_nhood_matrix(char thisnhood){
 char z;

   if (thisnhood<=5) thisnhood=5;
   for (z=0;z<=thisnhood-1;z++) free(nm[z]);
   free(nm);
   free(canal);
}

/************** allocate memory nhood matrix *******************/
void allocate_mem_Z_parameter(void){

   sprintf(textb[0],"zparam");
   if ((zparam=(float*)calloc(3,sizeof(float)))
			    ==NULL) outof_memory("zparam");
}
/************** free memory nhood matrix *******************/
void free_mem_Z_parameter(void){

	free(zparam);
}

/********** allocate memory for equivalent codes, Oct 93 *****************/
void allocate_code_mem(void){
 signed short codemax,codespacebytes;

   /*set up code tick off - to avoid plotting equiv codes in graph*/
   codemax=(signed short)pow(2,(double)nhood+1)-1;/*max code dec*/
   codespacebytes=(signed short)ceil( (double) (codemax+1)/8 );
   /*code-space index set to 0, equivalent code ticked off by bit=1*/
   if ((codetickoff=(char *)calloc(codespacebytes,sizeof(char)))
			       ==NULL) outof_memory("codetickoff");
   /*set up temp pointer for equivalent codes*/
   sprintf(textb[0],"tempcode");
   if ((tempcode=(char *)calloc((signed short)ceil((double)(nhood+1)/8),
			 sizeof(char)))==NULL) outof_memory("tempcode");
   /*freed in main, and in drpara for lambda_z_graph*/
}

/**************** allocate memory to CA state arrays **********************/
void allocate_mem_CA_states(void){
 unsigned short zu;

   if ((nhd=(unsigned char *)calloc(lineL,sizeof(unsigned char)))
					==NULL) outof_memory("nhd");
   if ((bitseed=(char *)calloc(bytesL,sizeof(char)))
					==NULL) outof_memory("bitseed");
   if ((firstseed=(char *)calloc(bytesL,sizeof(char)))
					==NULL) outof_memory("firstseed");
   if ((A=(char *)calloc(bytesL,sizeof(char)))==NULL) outof_memory("A");
   if ((F=(char *)calloc(bytesL,sizeof(char)))==NULL) outof_memory("F");
   if ((all_0s=(char *)calloc(bytesL,sizeof(char)))
					==NULL) outof_memory("all_0s");
   if ((all_1s=(char *)calloc(bytesL,sizeof(char)))
					==NULL) outof_memory("all_1s");
   memset(all_1s, 255, bytesL); /*set all bits to 1*/
   /*set exess bits to 0*/
   for (zu=L+1;zu<=bytesL*8-1;zu++) set_bit0(all_1s,zu);
   if ((tempState=(char*)calloc(bytesL,sizeof(char)))
					==NULL) outof_memory("tempState");
   if ((tempState2=(char*)calloc(bytesL,sizeof(char)))
					==NULL) outof_memory("tempState2");
   /*to distinguish canalizing cells (genes)*/
   if ((iscanal=(char *)calloc(bytesL,sizeof(char)))
					==NULL) outof_memory("iscanal");
   /*for learning algorithms*/
   /*target state*/
   if ((tar=(char *)calloc(bytesL,sizeof(char)))
					==NULL) outof_memory("tar");
   /*aspiring pre-image state/s, initial alloc, will be re-alloced*/
   notolearn=1;
   if ((learn_pre=(char**)calloc(1,sizeof(char*)))
					==NULL) outof_memory("learn_pre");
   if ((learn_pre[0]=(char *)calloc(bytesL,sizeof(char)))
					==NULL) outof_memory("learn_pre[0]");
   /*for segment repeats,equivalent cycle states etc */
   if ((rot=(char *)calloc(bytesL,sizeof(char)))
					==NULL) outof_memory("rot");
   /*pratial pre-image histogram, rnd wiring*/
   if ((pp_hist=(unsigned short *)calloc(lineL,sizeof(unsigned short)))
					==NULL) outof_memory("pp_hist");
   /*pratial pre-image histogram total (to find average), rnd wiring*/
   if ((pp_hist_total=(unsigned long *)calloc(lineL,sizeof(unsigned long)))
					==NULL) outof_memory("pp_hist_total");
}

/**************** free memory to CA state arrays **********************/
void free_mem_CA_states(void){
    signed short z;
		free(nhd);
		free(bitseed);
		free(firstseed);
		free(A);
		free(F);
		free(all_0s);
		free(all_1s);
		free(tempState);
		free(tempState2);
		free(iscanal);
		free(tar);
		for (z=0;z<=notolearn-1;z++) free(learn_pre[z]);
		free(learn_pre);
		free(rot);

		free(pp_hist);
		free(pp_hist_total);
}

/*************** allocate memory for wiring scheme, Oct 93 **************/
void allocate_mem_wiring(void){
 unsigned short zu;
 char pnhood; /*max size of pseudo-nhood*/
 signed short z;

  pnhood=nhood;
  if ((wiring=(unsigned short**)calloc(lineL,sizeof(unsigned short*)))
					==NULL) outof_memory("**wiring");
  for (zu=0;zu<=lineL-1;zu++){
	sprintf(textb[0],"wiring[%d]",zu);
	if ((wiring[zu]=
	    (unsigned short*)calloc(pnhood,sizeof(unsigned short)))
					==NULL) outof_memory(textb[0]);
	/*set all values to Maxint=32767*/
	for (z=0;z<=pnhood-1;z++) wiring[zu][z]=Maxu;
  }
  if ((celloutfreq=(unsigned short*)calloc(lineL,sizeof(unsigned short)))
					==NULL) outof_memory("celloutfreq");
}

/*************** allocate memory for wiring scheme, Oct 93 **************/
void reallocate_mem_wiring(char increace){
 char pnhood,z; /*max size of pseudo-nhood*/

   pnhood=nhood;
   /*decreace*/
   if (increace<0){
      for (z=1;z<=abs(increace);z++) free(wiring[L+z]);
   }
   if ((wiring=
       (unsigned short**)realloc(wiring,lineL*sizeof(unsigned short*)))
					==NULL) outof_memory("**wiring");
   if (increace>0){
      for (z=1;z<=increace;z++){
	 sprintf(textb[0],"wiring[%d]",lineL-z);
	   if ((wiring[lineL-z]=
	    (unsigned short*)calloc(pnhood,sizeof(unsigned short)))
					==NULL) outof_memory(textb[0]);
      }
   }
   if ((celloutfreq=
       (unsigned short*)realloc(celloutfreq,lineL*sizeof(unsigned short)))
					==NULL) outof_memory("celloutfreq");
}

/*************** allocate memory for wiring scheme, Oct 93 **************/
void free_mem_wiring(void){
 unsigned short zu;

    for (zu=0;zu<=lineL-1;zu++) free(wiring[zu]);
    free(wiring);
    free(celloutfreq);
}
