
/***************** DRAW PARAMETERS (borland=watco) ***************/
#if __UNIX__
#  include <fcntl.h>
#endif

#include "edecfunc.h"

void draw_general_graph_frame(char draw_clear,
   signed short xstart,signed short ystart,
        signed short xsize,signed short ysize,
         signed short xmaxdiv,signed short ymaxdiv);

typedef struct D_prompts {
   char suppress_fuzz,
        show_details; 
   unsigned short 
        itlimit;
   signed short
        D_sample,
        Hamm_step;
} D_prompts;

void get_D_para(D_prompts *this);

/**************** scroll space time pattern, 13 May 1993 ************/
void select_pattern_scrolling(void){
 double temp,xbox;
 char *tempcode1,dontbias;
 unsigned short leftboxx,rightboxx,boxy;
   scrolling=0;
   show_maj=-1;
   wires_to_move=1;
   if (!twod){
      if (showbits_1d_as_2d==1) shownumbers=3;
   }
   /*sep=2->1 pix black div between cells, sep=1-> no div*/
   if (scale>vgax(3)) sep=2;
   else sep=1;
   /*run forwards only and compute nhood, for large 2-d arrays*/
   if (loc_twod_fonly){
      sprintf(textb[0],
	 "2d CA (%dx%d), forwards only, return to continue:",i2d,j2d);
      draw_prompt_box(1);
      myouttext(textb[0]);
      input_string(1,0);
      erase_prompt_box(1);
      direction='f';
      limitcheck=0;
      return;
   }

  start:
   acceptall=accept_from=forward_only=0;

   moveto(memory_box(0)+vgax(3),vgay(3));
   setcolor(lightred);
   outtext("output parameters");
   setcolor(white);

   if (!basinfield) sprintf(textb[0],
	  "accept all basin defaults-d, space-time pattern only-s");
   else sprintf(textb[0],
	  "accept all basin defaults-d");
   sprintf(textb[1],
	  "restore defaults: all-a, layout only-L");
   sprintf(textb[2],
	  "revise from: layout-l, display/data-p, mutation-m");
   sprintf(textb[3],
	  "revise from start-ret:");

   xbox=draw_prompt_box(4);
   outtext(textb[0]);
   moveto(xbox,gety+CHeight);
   outtext(textb[1]);
   moveto(xbox,gety+CHeight);
   outtext(textb[2]);
   moveto(xbox,gety+CHeight);
   myouttext(textb[3]);
   input_string(1,0);
   erase_prompt_box(4);

   if (is[0]=='q'){
#     if __UNIX__  /*erase "output parameters" box*/      
         leftboxx=(signed short)((float)Maxx)/3;
         rightboxx=((signed short)((float)Maxx)/2)-3;
         boxy=2;
         /*erase box*/
         setviewport(leftboxx,boxy,rightboxx,boxy+CHeight+vgay(6),1);
         clearviewport();
         setviewport(0, 0, Maxx, Maxy, 0);
#     elif __BORC__||__WATCOM__
         memory_box(1);
#     endif
      return;
   
   } 
   if (is[0]=='s' && !basinfield){
      forward_only=show_ss_matrixF=1;
      direction='f';
      limitcheck=0;
      return;
   }
   if (is[0]=='d') acceptall=1;
   if (is[0]=='l') accept_from=1;
   if (is[0]=='p') accept_from=2;
   if (is[0]=='m') accept_from=3;

   if (is[0]=='a' || is[0]=='A'|| is[0]=='L'){
      layout_notset=1;
      successive_basins=0;
      show_one_att_state=0;
      if (is[0]=='a'){
	 show_ss_matrix=show_ss_matrixF=0;
	 ss_m_att_only=0;
	 msize=200;
	 matrixcolor=10;
	 screensavedemo=0;
	 gd_z_graph=0;
	 stp=0;
	 scrolling=0;
	 pre_fansize_freq_hist=0;
         diff_plot=0;
	 /*reset nominal array for in-degree histogram*/
	 if (maxinhist>0){
	    free(pre_fan_freq);
	    maxinhist=0;
	    sprintf(textb[0],"pre_fan_freq");
	    if ((pre_fan_freq=
	       (unsigned long *)calloc(1,sizeof(unsigned long)))
					==NULL) outof_memory(textb[0]);
	 }
	 shownumbers=0;
	 hilight_learn=showbits_1d_as_2d=0;
	 labelsizefactor=0;
	 dontcompress=0;
	 dontcopytrees=0;
	 fieldpause=0;
	 datapause=0;
	 mutate='b';
	 mutantdontpause=0;
	 pdata=0;
      }
      goto start;
   }
   moveto(memory_box(0)+vgax(3),vgay(3));
   setcolor(lightred);
   outtext("accept defaults-d");
   setcolor(white);

  startmatrix:
   /*state space matrix plotted simult. with basins/space-time pattern*/
   if (matrixcolor==0) matrixcolor=10;
   if (acceptall==0  && accept_from==0){
      sprintf(textb[0],
        "VARIOUS: state space matrix: all states-m, attractor only-a");
      sprintf(textb[1],
        "show and change: matrix size-s, start color-c:");
      draw_prompt_box(2);
      outtext(textb[0]);
      moveto(xbox,gety+CHeight);
      myouttext(textb[1]);
      input_string(1,0);
      erase_prompt_box(2);
      if (is[0]=='q')  goto start;
      else if (is[0]=='d') acceptall=1;
      else if (is[0]=='m' || is[0]=='a'
	    || is[0]=='s' || is[0]=='c') show_ss_matrix=1;

      if (is[0]=='a') ss_m_att_only=1;
      else if (is[0]=='s'){
	 sprintf(textb[0],
	  "change matrix size: %% of 1/2 screen (default %.2f%%):",
					    100*(float)msize/(Maxx/2));
	 xbox=draw_prompt_box(1);
	 outtext(textb[0]);
	 input_string(3,0);
	 erase_prompt_box(1);
	 if (is[0]=='q') goto start;
	 else if (is[0]=='d') acceptall=1;
	 else if (is[0]!=13 && atof(is)>0) msize=atof(is);
      }
      else if (is[0]=='c'){
	 sprintf(textb[0],
	  "change start color (now %d): enter 1-15:",matrixcolor);
	 xbox=draw_prompt_box(1);
	 outtext(textb[0]);
	 input_string(2 ,0);
	 erase_prompt_box(1);
	 if (is[0]=='q') goto start;
	 else if (is[0]=='d') acceptall=1;
	 else if (is[0]!=13 && atof(is)>=1 && atof(is)<16)
						matrixcolor=atof(is);
	 goto startmatrix;
      }
   }
   /*show pre-image frequency histogram*/
   if (acceptall==0 && accept_from==0 && screensavedemo==0){
      sprintf(textb[0],"show pre-image frequency histogram-y:");
      draw_prompt_box(1);
      myouttext(textb[0]);
      input_string(1,0);
      erase_prompt_box(1);
      if (is[0]=='q') goto start;
      else if (is[0]=='d') acceptall=1;
      else if (is[0]=='y'){
	 if (maxinhist==0) maxinhist=200;
	 draw_prompt_box(1);
	 sprintf(textb[0],
	  "select cut-off in-degree bin (50-5000, default %d):",maxinhist);
	 myouttext(textb[0]);
	 input_string(5,0);
	 if (is[0]=='q') goto start;
	 if (is[0]==13 || is[0]=='d');
	 else if (atoi(is)>=50 && atoi(is)<=5000) maxinhist=atoi(is);
	 pre_fansize_freq_hist=1;
	 /*reset array for in-degree histogram*/
	 free(pre_fan_freq);
	 sprintf(textb[0],"pre_fan_freq");
	 if ((pre_fan_freq=
	       (unsigned long *)calloc(maxinhist+1,sizeof(unsigned long)))
					==NULL) outof_memory(textb[0]);
	 if (is[0]=='d') acceptall=1;
	 else{
	    show_maj=-1;
	    sprintf(textb[0],
		  "show/count states with majority of: 1s-1, 0s-0:");
	    draw_prompt_box(1);
	    myouttext(textb[0]);
	    input_string(1,0);
	    erase_prompt_box(1);
	    if (is[0]=='q')  goto start;
	    else if (is[0]=='d') acceptall=1;
	    else if (is[0]=='0') show_maj=0;
	    else if (is[0]=='1') show_maj=1;
	 }
      }
      else{
	 pre_fansize_freq_hist=0;
	 /*reset nominal array for in-degree histogram*/
	 if (maxinhist>0){
	    free(pre_fan_freq);
	    maxinhist=0;
	    sprintf(textb[0],"pre_fan_freq");
	    if ((pre_fan_freq=
	       (unsigned long *)calloc(1,sizeof(unsigned long)))
					==NULL) outof_memory(textb[0]);
	 }
      }
   }
   
    /*continuous demo of basins (random rules) ramdom positions*/
   screensavedemo=0;
   if (acceptall==0 && accept_from==0 && !pre_fansize_freq_hist){
      if (basinfield==0 && rangeL==0){
	 sprintf(textb[0],"screensave demo -s:");
	 draw_prompt_box(1);
	 myouttext(textb[0]);
	 input_string(1,0);
	 if (is[0]=='q')  goto start;
	 else if (is[0]=='d') acceptall=1;
	 else if (is[0]=='s') screensavedemo=1;
      }
   }

   /*draw g-of-E density<->Z/Lambda graph, and Z - Lambda graph*/
  startgraph:
   gd_z_graph=0;
   pause_show_code=0;
   if (!rulemix && acceptall==0 && accept_from==0 &&
		 screensavedemo==0 && pre_fansize_freq_hist==0){
      lambda_z_graph=totalgraphrules=0;
      sprintf(textb[0],
	"G-density graph: Z-parameter-1, and Lambda ratio-2:");
      sprintf(textb[1],
	"C-P data and Z-parameter -  Lambda ratio graph -L:");
      xbox=draw_prompt_box(2);
      outtext(textb[0]);
      moveto(xbox,gety+CHeight);
      myouttext(textb[1]);
      input_string(1,0);
      erase_prompt_box(2);
      if (is[0]=='q')  goto start;
      else if (is[0]=='d') acceptall=1;
      else if (atoi(is)>0 && atoi(is)<=2){
	 gd_z_graph=atoi(is);

	 if (!(nhood<=3 || totalistic)){
	    draw_prompt_box(1);
	    sprintf(textb[0],
	       "G-density graph, number of rules (default 1250):");
	    myouttext(textb[0]);
	    input_string(6,0);
	    if (is[0]==13) totalgraphrules=1250;
	    else if (atol(is)>1) totalgraphrules=atol(is);
	    else gd_z_graph=0;
	 }
	 else{
	    lowlimZ=.2;
	    highlimZ=1;
	    draw_prompt_box(1);
	    sprintf(textb[0],"set min Z (default 0.2):");
	    myouttext(textb[0]);
	    input_string(4,0);
	    if (is[0]=='q') goto startgraph;
	    else if ((isdigit(is[0]) || is[0]=='.') &&
		   atof(is)>=0 && atof(is)<=1) lowlimZ=(float)atof(is);

	    sprintf(textb[0]," max Z (default 1):");
	    myouttext(textb[0]);
	    input_string(4,0);
	    if (is[0]=='q') goto startgraph;
	    else if ((isdigit(is[0]) || is[0]=='.') &&
		   atof(is)>=0 && atof(is)<=1 && atof(is)>lowlimZ)
					highlimZ=(float)atof(is);
	 }
      }
      else if (is[0]=='L') {
	 lambda_z_graph=1;
	 codetypeonly='c';
	 pause_show_code=0;
	 if (nhood<=3 || totalistic){
	    totalgraphrules=1;
	    if (totalistic){
	       xbox=draw_prompt_box(2);
	       sprintf(textb[0],
		  "show only equivs-e all-a (default clusters):");
	       myouttext(textb[0]);
	       input_string(1,0);
	       if (is[0]=='q'){
		  erase_prompt_box(2);
		  goto startgraph;
	       }
	       else if (is[0]=='e') codetypeonly='e';
	       else if (is[0]=='a') codetypeonly='a';
	       moveto(xbox,gety+CHeight);
	       sprintf(textb[0],
		  "pause to show codes-p:");
	       myouttext(textb[0]);
	       input_string(1,0);
	       erase_prompt_box(2);
	       if (is[0]=='q') goto startgraph;
	       if (is[0]=='p') pause_show_code='1';
	    }
	 }
	 else {
	    dontbias=0;
	    xbox=draw_prompt_box(2);
	    sprintf(textb[0],
	       "lambda-Z graph, number of rules (default 2200):");
	    myouttext(textb[0]);
	    input_string(6,0);

	    if (is[0]==13) totalgraphrules=2200;
	    else if (atol(is)>1) totalgraphrules=atol(is);
	    moveto(xbox,gety+CHeight);
	    sprintf(textb[0],
	       "random rule sample will have lambda bias, dont bias-n");
	    myouttext(textb[0]);
	    input_string(1,0);
	    if (is[0]=='n') dontbias=1;
	    erase_prompt_box(2);
	 }
	 if (totalgraphrules>0){
	    gofE_z_graph();  /*draw and title the graph outline*/
	    if (totalistic){
	       mutate=5; /*decriment code no*/
	       allocate_code_mem();
	       sprintf(textb[0],"cacode[0]");
		if ((tempcode1=(char *)calloc
		    ((signed short)ceil((double)(nhood+1)/8),
			  sizeof(char)))==NULL)outof_memory(textb[0]);
	       memcpy(tempcode1,cacode[0],
			 (signed short)ceil((double)(nhood+1)/8));
	    }
	    else if (nhood<=3) mutate=3;   /*decriment rule no*/
	    else mutate=2;
	    memory_box(1);
	    draw_lambda_z_graph(dontbias);/*plot points*/
	    if (totalistic){
	       free(codetickoff);
	       free(tempcode);
	       memcpy(cacode[0],tempcode1,
			 (signed short)ceil((double)(nhood+1)/8));
	       free(tempcode1);
	    }
	    lambda_z_graph=0;
	    mutate='b'; /*restore default mutation*/
	    moveto(memory_box(0)+vgax(3),vgay(3));
	    setcolor(lightred);
	    outtext("accept defaults-d");
	    setcolor(white);
	    goto startgraph;
	 }
      }
   }
  start40:
   /*show/dont show space-time pattern*/
   if (stp==0 ){
      if (basinfield || gd_z_graph || screensavedemo==1) stp=0;
      else stp=1;
   }
   if (acceptall==0 && accept_from==0){
	      if (stp==0)sprintf(textb[0],"SHOW space-time pattern-y: ");
	      else sprintf(textb[0],"NO space-time pattern-n: ");
	      draw_prompt_box(1);
	      myouttext(textb[0]);
	      input_string(1,0);
	      erase_prompt_box(1);
	      if (is[0]=='q')  goto start;
	      if (is[0]=='d') acceptall=1;
	      if (stp==0){
		  if (is[0]=='y') stp=1;
      }
      else {
	 	if (is[0]=='n') stp=0;
      }
      if (acceptall==0 && stp==1){
		 sprintf(textb[0],"SCROLL space-time pattern-s: ");
		 draw_prompt_box(1);
		 myouttext(textb[0]);
		 input_string(1,0);
		 erase_prompt_box(1);
		 if (is[0]=='q')  goto start40;
		 else if (is[0]=='d') acceptall=1;
		 else if (is[0]=='s') scrolling=1;
      }
   }
   temp=(double)CHeight*1.2/(double)scale;
   textscale=ceil(temp);
   if (textscale==0) textscale=1;
   if (accept_from==0) accept_from=1;
}

/************** select scale and position of basin, 13 May 93 ************/
void setup_plot(void){

 float r,temp,oldpstartrad;
 signed short z,xbox;
 char acceptall_was_set=0,layout_learn=0,sn;

   if (twod) rangeL=0;

   /*get image below layout preview box, no outline or background*/
   if (acceptall==0  && accept_from==1) 
              draw_box(3,0,0,Maxx/2-vgax(4),Maxy/2,0,-1);
   setcolor(white);

   if (layout_notset==1){
      set_layout_defaults();
      layout_notset=0;
   }
   else{
      xspacing=startxspacing;
      yspacing=startyspacing;
   }
   /*draw layout preview in 1/4 screen*/
   if (acceptall==0 && accept_from==1){
      draw_layout_preview();
      moveto(memory_box(0)+vgax(3),vgay(3));
      setcolor(lightred);
      outtext("accept defaults-d");
      setcolor(white);
   }

  start10:
   oldpstartrad=pstartrad;
   layout_learn=0;
   if (acceptall==0 && accept_from==1){
      sprintf(textb[0],
	"LAYOUT: reset defaults: all-r, reset for learning-l");
      sprintf(textb[1],
       "select att rad, %% of 1/2 screen, x-axis (default %.3g):",pstartrad);
      xbox=draw_prompt_box(2);
      outtext(textb[0]);
      moveto(xbox,gety+CHeight);
      myouttext(textb[1]);
      input_string(4,0);
      erase_prompt_box(2);
      if (is[0]=='q'){
	 erase_prompt_box(2);
	 /*restore image below 1/4 screen preview*/
	 putimage(0,0,boximage[3],COPY_PUT);
	 freeimage(boximage[3]);
	 return;
      }
      if (is[0]=='r'){
	 layout_notset=1;
	 set_layout_defaults();
	 layout_notset=0;
	 draw_layout_preview();
	 moveto(memory_box(0)+vgax(3),vgay(3));
	 setcolor(lightred);
	 outtext("accept defaults-d");
	 setcolor(white);
	 goto start10;
      }
      else if (is[0]=='d') acceptall=acceptall_was_set=1;
      else if (is[0]=='l'){
	 temp=1;
	 if (lineL>6) temp=5.5/(6+((float)lineL-6)/2);
	 pstartrad=15*temp;
	 xoffset=-55;
	 yoffset=40;
	 xpspacing=60*temp;
	 ypspacing=45*temp;
	 rightborder=.4;
	 draw_layout_preview();
	 setcolor(white);
	 acceptall=acceptall_was_set=1;
	 layout_notset=0;
	 layout_learn=1;
	 hilight_learn=1;

	 if (shownumbers==-1) sn='n';
	 else if (shownumbers==0) sn='s';
	 else if (shownumbers==1 && lineL>32) sn='d';
	 else if (shownumbers==2) sn='h';
	 else if (shownumbers==3 && showbits_1d_as_2d==0) sn='b';
	 else if (shownumbers==3 && showbits_1d_as_2d==1) sn='B';
	 else sn='h';

	 if (!twod){
	   if (lineL>32) sprintf(textb[0],
	      "nodes: none-n 2d-B 1d-b hex-h spot-s (default-%c):",sn);
	    else sprintf(textb[0],
	      "nodes: none-n 2d-B 1d-b hex-h dec-c spot-s (default-%c):",sn);
	 }
	 else{
	    if (lineL>32) sprintf(textb[0],
	      "nodes: none-n 2d-b hex-h spot-s (default-%c):",sn);
	    else sprintf(textb[0],
	      "nodes: none-n 2d-b hex-h dec-c spot-s (default-%c):",sn);
	 }

	 draw_prompt_box(1);
	 myouttext(textb[0]);
	 input_string(1,0);
	 if (is[0]=='q') goto start10;
	 else if (is[0]=='d') acceptall=1;

	 if (!shownumbers=='3' || twod) showbits_1d_as_2d=0;
	 if (is[0]=='s') shownumbers=0;
	 else if (is[0]=='c') shownumbers=1;
	 else if (is[0]=='h') shownumbers=2;
	 else if (is[0]=='b' || (is[0]=='B' && twod)){
	    hilight_learn=showbits_1d_as_2d=0;
	    shownumbers=3;
	 }
	 else if (is[0]=='B'){
	    shownumbers=3;
	    showbits_1d_as_2d=1;
	    for (z=(signed short)ceil(pow((double)lineL,.5));z>=1;z--){
	       if (lineL%z==0) break;
	    }
	    j2d=z;
	    i2d=(signed short)ceil((double)lineL/j2d);
	 }
	 else if (is[0]=='s') shownumbers=0;
	 else if (is[0]=='n') shownumbers=-1;

	 sprintf(textb[0],"now %dx%d, reset i-axis (acceptall=%d shb=%d:"
			  ,i2d,j2d,acceptall,showbits_1d_as_2d);
	    draw_prompt_box(1);
	    myouttext(textb[0]);
	    input_string(1,0);

	 if (showbits_1d_as_2d==1){
	    sprintf(textb[0],"now %dx%d, reset i-axis:",i2d,j2d);
	    draw_prompt_box(1);
	    myouttext(textb[0]);
	    input_string(3,0);
	    if (is[0]=='q') goto start10;
	    else if (is[0]=='d') acceptall=1;
	    else if (is[0]==13);
	    else if (atoi(is)>0 && atoi(is)<=lineL){
	       i2d=atoi(is);
	       j2d=(signed short)ceil((double)lineL/i2d);
	    }
	 }
      }
      else if (is[0]!=13 && atof(is)>0) pstartrad=atof(is);
   }

   startrad=(signed short) (((float)Maxx/2)*(pstartrad/100 ));

   /*set up array of levels*/
   for (z=1;z<=lastlevel;z++){    /*lastindex=lastlevel-1*/
      if (z==1) r=startrad;
      else r += startrad/log(pow(z,2));
      rad[z-1]=r;
   }

  start20:
   /*set centre of first basin*/
   if (acceptall==0 && accept_from==1){
      xbox=draw_prompt_box(3);
      sprintf(textb[0],"start position, %% offset from screen centre");
      outtext(textb[0]);
      moveto(xbox,gety+CHeight);
      sprintf(textb[0],"x (default %.3g):",xoffset);
      myouttext(textb[0]);
      input_string(3,0);
      if (is[0]=='q'){
	 erase_prompt_box(3);
	 goto start10;
      }
      if (is[0]=='d'){
	 acceptall=acceptall_was_set=1;
	 erase_prompt_box(3);
      }
      else if (is[0]!=13) xoffset=atof(is);

      if (acceptall==0){
	 moveto(getx+10,gety);
	 sprintf(textb[0],"y (default %.3g):",yoffset);
	 myouttext(textb[0]);
	 input_string(3,0);
	 if (is[0]=='q'){
	    erase_prompt_box(3);
	    goto start20;
	 }
	 else if (is[0]=='d'){
	    acceptall=acceptall_was_set=1;
	    erase_prompt_box(3);
	 }
	 else if (is[0]!=13) yoffset=atof(is);
	 if (acceptall==0 && !rangeL && basinfield){
	    successive_basins=0;
	    moveto(xbox,gety+CHeight);
	    myouttext("show field as successive single basins-s:");
	    input_string(1,0);
	    if (is[0]=='q'){
	       erase_prompt_box(3);
	       goto start20;
	    }
	    else if (is[0]=='d') acceptall=acceptall_was_set=1;
	    else if (is[0]=='s'){
	       successive_basins=1;
	       datapause=1;
	    }
	 }
      }
      erase_prompt_box(3);
   }
   fox=ox=(signed short) (((float)Maxx/2)*(1+xoffset/100 ));
   foy=oy=(signed short) (((float)Maxy/2)*(1-yoffset/100 ));

  start30:
   /*change default spacing in proportion to rad*/
   if (!layout_learn){
      xpspacing*=pstartrad/oldpstartrad;
      ypspacing*=pstartrad/oldpstartrad;
   }
   /*specify spacing between basins*/
   if (successive_basins==0 && (basinfield || rangeL || gd_z_graph)){
      if (acceptall==0 && accept_from==1){
	 xbox=draw_prompt_box(3);
	 sprintf(textb[0],"basin spacing, %% of 1/2 screen");
	 myouttext(textb[0]);
	 moveto(xbox,gety+CHeight);
	 sprintf(textb[0],"x spacing (default %.3g):",xpspacing);
	 myouttext(textb[0]);
	 input_string(3,0);
	 if (is[0]=='q'){
	    erase_prompt_box(2);
	    goto start20;
	 }
	 else if (is[0]=='d'){
	    acceptall=acceptall_was_set=1;
	    erase_prompt_box(3);
	 }
	 else if (is[0]!=13) xpspacing=atof(is);
	 if (acceptall==0){
	    moveto(getx+10,gety);
	    sprintf(textb[0],"y spacing (default %.3g):",ypspacing);
	    myouttext(textb[0]);
	    input_string(3,0);
	    if (is[0]=='q'){
	       erase_prompt_box(3);
	       goto start30;
	    }
	    if (is[0]=='d'){
	       acceptall=acceptall_was_set=1;
	       erase_prompt_box(2);
	    }
	    else if (is[0]!=13) ypspacing=atof(is);
	    /*erase_prompt_box(2);*/
	 }
	 startxspacing=xspacing=
		  (signed short) (((float)Maxx/2)*(xpspacing/100 ));
	 startyspacing=yspacing=
		  (signed short) (((float)Maxy/2)*(ypspacing/100 ));


	 /*min right border, then new row*/
	 sprintf(textb[0],
	    "select right border as %% of x spacing (default %.1f):",
				       rightborder*100);
	 moveto(xbox,gety+CHeight);
	 myouttext(textb[0]);
	 input_string(4,0);
	 if (is[0]=='q') goto start30;

	 else if (is[0]=='d'){
	       acceptall=acceptall_was_set=1;
	       erase_prompt_box(3);
	 }
	 else if (is[0]!=13) rightborder=(float)atof(is)/100 ;
	 erase_prompt_box(3);
      }

     start40:
      /*select spacing increase*/
      if (rangeL){
	 if (acceptall==0 && accept_from==1){
	    xbox=draw_prompt_box(2);
	    sprintf(textb[0],
	      "select %% increace in spacing for successive network size,");
	    myouttext(textb[0]);
	    moveto(xbox,gety+CHeight);
	    sprintf(textb[0],"x increace (default %.3g):",xpspacefact);
	    myouttext(textb[0]);
	    input_string(3,0);
	    if (is[0]=='q'){
	       erase_prompt_box(2);
	       goto start30;
	    }
	    else if (is[0]=='d'){
	       acceptall=acceptall_was_set=1;
	       erase_prompt_box(2);
	    }
	    else if (is[0]!=13) xpspacefact=atof(is);
	    if (acceptall==0){
	       moveto(getx+10,gety);
	       sprintf(textb[0],"y increase (default %.3g):",ypspacefact);
	       myouttext(textb[0]);
	       input_string(3,0);
	       if (is[0]=='q'){
		  erase_prompt_box(2);
		  goto start40;
	       }
	       else if (is[0]=='d'){
		  acceptall=acceptall_was_set=1;
		  erase_prompt_box(2);
	       }
	       else if (is[0]!=13) ypspacefact=atof(is);
	       erase_prompt_box(2);
	    }
	 }
	 xspacefact=1+(xpspacefact/100);
	 yspacefact=1+(ypspacefact/100);
      }
   }

   if (acceptall==0 && accept_from==1){
      /*draw layout preview in 1/4 screen*/
      draw_layout_preview();
      moveto(memory_box(0)+vgax(3),vgay(3));
      setcolor(lightred);
      outtext("accept defaults-d");
      setcolor(white);

      sprintf(textb[0],
       "layout; revise-q, accept-ret:");
      draw_prompt_box(1);
      myouttext(textb[0]);
      input_string(1,0);

      if (is[0]=='q'){
	 erase_prompt_box(1);
	 goto start10;
      }
      if (is[0]=='d') acceptall=acceptall_was_set=1;
   }

   if (acceptall_was_set==1 || (acceptall==0 && accept_from==1)){
      /*restore image below 1/4 screen preview*/
      putimage(0,0,boximage[3],COPY_PUT);
      freeimage(boximage[3]);
   }
   if (accept_from==1) accept_from=2;
}

/********************* amemd basin layout ********************/
void amend_layout(void){
  unsigned short xbox;
  char newpos_was_set=0;

   /*set centre of next basin*/
  start20:
   erase_prompt_box(2);
   xbox=draw_prompt_box(1);
   sprintf(textb[0],"amend next pos-p, or just spacing-ret:");
   outtext(textb[0]);
   input_string(1,0);
   if (is[0]=='q') return;

   if (is[0]=='p'){
      start15:
      xbox=draw_prompt_box(2);
      sprintf(textb[0],
	"(start=%.3g,%.3g) amend next pos, %% offset from screen centre",
				     xoffset,yoffset);
      outtext(textb[0]);
      moveto(xbox,gety+CHeight);
      sprintf(textb[0],"x (default %.3g):",
			(((float)(ox+xspacing)/(Maxx/2)-1)*100));
      myouttext(textb[0]);
      input_string(3,0);
      if (is[0]=='q'){
	 erase_prompt_box(2);
	 goto start20;
      }
      else if (is[0]!=13) xoffset=atof(is);
      else xoffset=(((float)(ox+xspacing)/(Maxx/2)-1)*100);
      moveto(getx+10,gety);
      sprintf(textb[0],"y pos (default %.3g):",
				   (((float)oy/(Maxy/2)-1)*100));
      myouttext(textb[0]);
      input_string(3,0);
      if (is[0]=='q') goto start15;
      else if (is[0]!=13) yoffset=atof(is);
      else yoffset=-(((float)oy/(Maxy/2)-1)*100);
      erase_prompt_box(2);
      ox=firstox=(signed short) (((float)Maxx/2)*(1+xoffset/100 ));
      oy=(signed short) (((float)Maxy/2)*(1-yoffset/100 ));
      newpos_was_set=1;
   }
  start30:
   /*specify spacing between basins*/
   get_prompt_box(1,3);
   xbox=draw_prompt_box(3);
   sprintf(textb[0],"ammend basin spacing, %% of 1/2 screen");
   myouttext(textb[0]);
   moveto(xbox,gety+CHeight);
   sprintf(textb[0],"x spacing (default %.3g):",xpspacing);
   myouttext(textb[0]);
   input_string(3,0);
   if (is[0]=='q'){
      erase_prompt_box(3);
      goto start20;
   }
   else if (is[0]!=13) xpspacing=atof(is);
   moveto(getx+10,gety);
   sprintf(textb[0],"y spacing (default %.3g):",ypspacing);
   myouttext(textb[0]);
   input_string(3,0);
   if (is[0]=='q') goto start30;
   else if (is[0]!=13) ypspacing=atof(is);
   xspacing=(signed short) (((float)Maxx/2)*(xpspacing/100 ));
   yspacing=(signed short) (((float)Maxy/2)*(ypspacing/100 ));
   if (newpos_was_set==1) ox-=xspacing;
   /*min right border, then new row*/
   sprintf(textb[0],
	    "select right border as %% of x spacing (default %.1f):",
				       rightborder*100);
   moveto(xbox,gety+CHeight);
   myouttext(textb[0]);
   input_string(4,0);
   if (is[0]=='q') goto start30;
   else if (is[0]!=13) rightborder=(float)atof(is)/100 ;
   putimage((signed short)((float)Maxx)/2,2,boximage_prompt[1],COPY_PUT);
   freeimage(boximage_prompt[1]);
}

/********************* set layout defaults ************************/
void set_layout_defaults(void){
 float r;
 signed short z;

   /*scale of basins, specify attractor radius*/

   if (gd_z_graph){
      if (basinfield) pstartrad=2;
      else pstartrad=4;
   }
   else if (screensavedemo==1) pstartrad=4.5;
   else if (basinfield && rangeL) pstartrad=3;
   else if (basinfield || rangeL) pstartrad=6;
   else pstartrad=12;

   startrad=(signed short) (((float)Maxx/2)*(pstartrad/100 ));

   /*specify basin start position, % of 1/2 screen*/
   if (gd_z_graph){
      if (basinfield){
	    xoffset=-80;
	    yoffset=60;
      }
      else{
	 xoffset=-70;
	 yoffset=50;
      }
      if (stp) xoffset=
	     (signed short)((((float)lineL*scale)/(Maxx/2))*100)-100+30;
   }
   else if (basinfield || rangeL){
      if (stp) xoffset=-70;
      else xoffset=-80;
      if (basinfield){
	 if (rangeL) yoffset=70;
	 else yoffset=50;
      }
      if (!basinfield) yoffset=50;
   }
   else{
      if (stp) xoffset=30;
      else xoffset=0;
      yoffset=0;
   }
   fox=ox=(signed short) (((float)Maxx/2)*(1+xoffset/100 ));
   foy=oy=(signed short) (((float)Maxy/2)*(1-yoffset/100 ));

   /*specify spacing between basins*/
   if (basinfield || rangeL || gd_z_graph){
      if (gd_z_graph){
#        if __BORC__||__UNIX__
	    xpspacing=6;
	    ypspacing=6;
#        elif __WATCOM__
	    xpspacing=13;
	    ypspacing=10;
#        endif
      }
      else{
	 xpspacing=30;
	 ypspacing=30;
	 if (rangeL){
	    if (basinfield){
	       xpspacing=15;
	       ypspacing=15;
	    }
	    else{
	       xpspacing=20;
	       ypspacing=35;
	    }
	 }
      }
      rightborder=.45;
   }
   startxspacing=xspacing=
	      (signed short) (((float)Maxx/2)*(xpspacing/100 ));
   startyspacing=yspacing=
	      (signed short) (((float)Maxy/2)*(ypspacing/100 ));
   /*select spacing increase*/
   if (rangeL){
      if (basinfield){
	 xpspacefact=10;
	 ypspacefact=10;
      }
      else{
	 xpspacefact=6;
	 ypspacefact=4;
      }
   }
   xspacefact=1+(xpspacefact/100);
   yspacefact=1+(ypspacefact/100);
   /*set up array of levels*/
   for (z=1;z<=lastlevel;z++){    /*lastindex=lastlevel-1*/
      if (z==1) r=startrad;
      else r += startrad/log(pow(z,2));
      rad[z-1]=r;
   }
}

/***************  draw layout preview in 1/4 screen *********************/
void draw_layout_preview(void){
 float start,finish,az,
       showox,showoy,showxspacing,showyspacing;
 signed short z,zz,stemp,
	      bno,fno,fstart,fend,turns,Mx,My;

     ox=fox;
     oy=foy;
     showox=ox/2;
     showoy=oy/2;
     showxspacing=xspacing/2;
     showyspacing=yspacing/2;
     Mx=Maxx/2-vgax(4);
     My=Maxy/2;      
     draw_box(-1,0,0,Mx,My,1,0);
     setviewport(0,0,Mx,My,1);
     /*draw layout in 1/4 screen preview*/
     for (z=1;z<=lastlevel;z++){    /*lastindex=lastlevel-1*/
	 turns=0;
	 if (z%20==0 || z<=4) setcolor(yellow);
	 else setcolor(darkgray);
	 /*to display spacing of levels*/
	 start = PI/2;
	 finish = .1+(PI/2)+(PI*2);
	 angle = deg * 3;
	 /*draw first*/
	 for (az=start;az<=finish;az+=angle){
	    turns+=1;
	    cx = rad[z-1] * cos(az)/2+showox;
	    cy = rad[z-1] * sin(az)/2+showoy;
	    if (az==start) moveto(cx,cy);
	    else lineto(cx,cy);
	    if (turns==80) putpixel(rad[z-1]*cos(az-angle)/2+showox,
				    rad[z-1]*sin(az-angle)/2+showoy,white);
	 }
     }

     if (successive_basins==0 && (basinfield || rangeL)){
	fstart=startL;
	fend=endL;
	if (basinfield) bno=30;
	else bno=1;

	for (fno=fstart-1;fno<=fend-1;fno++){
	   if (gety>Maxy) break;
	   if (basinfield && rangeL) bno=fno+1;
	   else{
	      if (fno>fstart-1) showox+=showxspacing;
	   }
	   setcolor(yellow);
	   for (zz=1;zz<=bno;zz++){
	      if (gety>Maxy) break;
	      if (zz>1) showox+=showxspacing;
	      /*start new line*/
	      if ((Mx-showox)<showxspacing*rightborder){
		 if (basinfield && rangeL) break;
		 showox=ox/2;
		 showoy+=showyspacing;
	      }
	      for (z=1;z<=4;z++){
		 for (az=start;az<=finish;az+=angle){
		    cx = rad[z-1] * cos(az)/2+showox;
		    cy = rad[z-1] * sin(az)/2+showoy;
		    if (az==start) moveto(cx,cy);
		    else lineto(cx,cy);
		 }
	      }
	   }
	   showxspacing*=xspacefact;
	   showyspacing*=yspacefact;
	   if (basinfield){
	      showox=ox/2;
	      showoy+=showyspacing;
	   }
	   else if (rangeL){
	      if (basinfield) showox+=showxspacing;
	      /*start new line*/
	      if ((Mx-showox)<showxspacing*rightborder){
		 showox=ox/2;
		 showoy+=showyspacing;
	      }
	   }
	}
     }
     setcolor(yellow);
     stemp=textwidth("y=+100")+vgax(4);
     draw_box(-1,Mx/2+2,2,
		  Mx/2+stemp,CHeight+vgay(6)+2, 1,0);
     outtext("y=+100");
     draw_box(-1,Mx/2+2,My-CHeight-vgay(6)-2,
		  Mx/2+stemp,My-2, 1,0);
     outtext("y=-100");
     draw_box(-1,2,My/2-CHeight-vgay(6)-2,
		  stemp,My/2-2, 1,0);
     outtext("x=-100");
     draw_box(-1,Mx-stemp,My/2-CHeight-vgay(6)-2,
		  Mx-2,My/2-2, 1,0);
     outtext("x=+100");

     stemp=textwidth("basin layout preview")+vgax(4);
     draw_box(-1,Mx-stemp,My-CHeight-vgay(6)-2,
		  Mx-2,My-2, 1,0);
     outtext("basin layout preview");

     setcolor(lightred);
     line(0,My/2,Mx,My/2);
     line(Mx/2,0,Mx/2,My);
     rectangle(0,0,Mx,My);
     setviewport(0,0,Maxx,Maxy,1);
     setcolor(white);

}

/************ set various basin drawing choises, 13 May 1993 ***************/
void format_draw(void){
 signed short xbox,fid,z;
 char file_ret,sn;

   moveto(memory_box(0)+vgax(3),vgay(3));
   setcolor(lightred);
   outtext("accept defaults-d");
   setcolor(white);
   setcolor(white);

   /********* equivilent trees/basins **************/
  select10:
   if (acceptall==0 && accept_from==2){
      if ((nonlocal==0 || regular2d) && !rulemix){
	 if (nonlocal==0)
	    sprintf(textb[0],
	       "DISPLAY/DATA: regular 1-d CA, nhood=%d, size=%d",
							nhood,lineL);
	 if (regular2d)
	    sprintf(textb[0],
	       "DISPLAY/DATA: regular 2-d CA, nhood=%d, size=%dx%d",
						       nhood,i2d,j2d);
	 sprintf(textb[1],"suppress compression in basins and fields-s:");
	 xbox=draw_prompt_box(2);
	 outtext(textb[0]);
	 moveto(xbox,gety+CHeight);
	 myouttext(textb[1]);
	 input_string(1,0);
	 erase_prompt_box(2);

	 if (is[0]=='q') return;
	 else if (is[0]=='d') acceptall=1;
	 dontcompress=0;
	 if (is[0]=='s') dontcompress=1;

	 if (acceptall==0 && dontcompress==0){
	    sprintf(textb[0],
	    "suppress copies of trees (& sub-trees from all 0s,1s");
	    sprintf(textb[1],
	    "all-3, show g-of-E nodes-2, reduce g-of-E nodes-1:");
	    xbox=draw_prompt_box(2);
	    outtext(textb[0]);
	    moveto(xbox,gety+CHeight);
	    myouttext(textb[1]);
	    input_string(1,0);
	    erase_prompt_box(2);

	    if (is[0]=='q') goto select10;
	    else if (is[0]=='d') acceptall=1;
	    dontcopytrees=0;
	    if (is[0]=='1') dontcopytrees=1;
	    else if (is[0]=='2') dontcopytrees=2;
	    else if (is[0]=='3') dontcopytrees=3;
	 }
      }
   }
   /*********select node type**************/
  select15:
   if (acceptall==0 && accept_from==2){

      if (shownumbers==-1) sn='n';
      else if (shownumbers==0) sn='s';
      else if (shownumbers==1 && lineL>32) sn='d';
      else if (shownumbers==2) sn='h';
      else if (shownumbers==3 && showbits_1d_as_2d==0) sn='b';
      else if (shownumbers==3 && showbits_1d_as_2d==1) sn='B';
      else sn='h';

      if (!((nonlocal==0 || regular2d) && !rulemix)){
	 xbox=draw_prompt_box(2);
	 outtext("DISPLAY/DATA");
	 moveto(xbox,gety+CHeight);
      }
      else draw_prompt_box(1);
      if (!twod){
	 if (lineL>32) sprintf(textb[0],
	      "nodes: none-n 2d-B 1d-b hex-h spot-s (default-%c):",sn);
	 else sprintf(textb[0],
	      "nodes: none-n 2d-B 1d-b hex-h dec-c spot-s (default-%c):",sn);
      }
      else{
	 if (lineL>32) sprintf(textb[0],
	    "nodes: none-n 2d-b hex-h spot-s (default-%c):",sn);
	 else sprintf(textb[0],
	    "nodes: none-n 2d-b hex-h dec-c spot-s (default-%c):",sn);
      }
      myouttext(textb[0]);
      input_string(1,0);
      if (is[0]=='q'){
	 if (!((nonlocal==0 || regular2d) && !rulemix)) erase_prompt_box(2);
	 if ((nonlocal==0 || regular2d) && !rulemix) goto select10;
	 else return;
      }
      else if (is[0]=='d'){
	 acceptall=1;
	 if (!((nonlocal==0 || regular2d) && !rulemix)) erase_prompt_box(2);
      }
      if (!shownumbers=='3' || twod) showbits_1d_as_2d=0;
      if (is[0]=='c' && lineL<=32) shownumbers=1;
      else if (is[0]=='h') shownumbers=2;
      else if (is[0]=='b' || (is[0]=='B' && twod)){
	 hilight_learn=showbits_1d_as_2d=0;
	 shownumbers=3;
      }
      else if (is[0]=='B'){
	 shownumbers=3;
	 showbits_1d_as_2d=1;
	 for (z=(signed short)ceil(pow((double)lineL,.5));z>=1;z--){
	    if (lineL%z==0) break;
	 }
	 j2d=z;
	 i2d=(signed short)ceil((double)lineL/j2d);
      }
      else if (is[0]=='s') shownumbers=0;
      else if (is[0]=='n') shownumbers=-1;
      if (!((nonlocal==0 || regular2d) && !rulemix)) erase_prompt_box(2);

      if (acceptall==0 && shownumbers==3 && showbits_1d_as_2d==1){
	 sprintf(textb[0],"now %dx%d, reset i-axis:",i2d,j2d);
	 draw_prompt_box(1);
	 myouttext(textb[0]);
	 input_string(3,0);
	 if (is[0]=='q') goto select15;
	 else if (is[0]=='d') acceptall=1;
	 else if (is[0]==13);
	 else if (atoi(is)>0 && atoi(is)<=lineL){
	    i2d=atoi(is);
	    j2d=(signed short)ceil((double)lineL/i2d);
	 }
      }
   }
   if (shownumbers>0){
      if (labelsizefactor==0) labelsizefactor=1;
      if (acceptall==0 && accept_from==2){
	 /*state as dec or hex*/
	 if (shownumbers<3){
	    sprintf(textb[0],"alter default node label size, enter factor:");
	    draw_prompt_box(1);
	    myouttext(textb[0]);
	    input_string(3,0);
	    if (is[0]=='q') goto select15;
	    else if (is[0]=='d') acceptall=1;
	    else if (is[0]!=13 && atof(is)>0) labelsizefactor=atof(is);
	 }
	 /*state as black and white cells*/
	 else{
	    sprintf(textb[0],"alter cell size, now %d pixels:",scale);
	    draw_prompt_box(1);
	    myouttext(textb[0]);
	    input_string(2,0);
	    if (is[0]=='q') goto select15;
	    else if (is[0]=='d') acceptall=1;
	    else if (is[0]!=13 && atoi(is)>0) scale=atoi(is);
	 }
      }
   }
   if (acceptall==0 && accept_from==2){
      show_one_att_state=0;
      sprintf(textb[0],
	    "highlight one state in each attractor as bit pattern-b:");
      draw_prompt_box(1);
      myouttext(textb[0]);
      input_string(1,0);
      if (is[0]=='q') goto select15;
      if (is[0]=='d') acceptall=1;
      else if (is[0]=='b') show_one_att_state=1;
   }
   /***pause to see data ***/
  select20:
   /***pause to see data, fields***/
   if (rangeL==1 && basinfield){
      if (acceptall==0 && accept_from==2){
	 sprintf(textb[0],
	    "pause after each field-y, don't pause-default:");
	 draw_prompt_box(1);
	 myouttext(textb[0]);
	 input_string(1,0);
	 if (is[0]=='q') goto select15;
	 fieldpause=0;
	 if (is[0]=='d') acceptall=1;
	 if (is[0]=='y') fieldpause=1;
      }
   }

   /***pause to see data, trees and basins***/
   if ((rangeL==1 && basinfield && fieldpause==1) ||
	  (!rangeL && basinfield && fieldpause==0) || !basinfield){
      if (acceptall==0 && accept_from==2){
	 if (successive_basins==1) datapause=1;
	 else datapause=0;
	 if (successive_basins==1)
	    sprintf(textb[0],"pause for data: tree-2, none-0, basin-ret:");
	 else sprintf(textb[0],"pause for data: tree-2, basin-1, none-ret:");
	 draw_prompt_box(1);
	 myouttext(textb[0]);
	 input_string(1,0);
	 if (is[0]=='q') goto select15;
	 else if (is[0]=='d') acceptall=1;
	 else if (is[0]=='0') datapause=0;
	 else if (is[0]=='1') datapause=1;
	 else if (is[0]=='2') datapause=2;
      }
   }
   /*** select data to printer ***/
  select30:
   pdata=0;
   if (acceptall==0 && accept_from==2){
      sprintf(textb[0],"print data to printer");
      sprintf(textb[1],"basin data only-1, and tree data-2:");
      xbox=draw_prompt_box(2);
      outtext(textb[0]);
      moveto(xbox,gety+CHeight);
      myouttext(textb[1]);
      input_string(1,0);
      erase_prompt_box(2);
      if (is[0]=='q') goto select20;
      if (is[0]=='d') acceptall=1;
      else {
	 if (is[0]=='1') pdata=1;
	 else if (is[0]=='2') pdata=2;
#        if __BORC__||__WATCOM__
            if (pdata){
	       prn_putc(ESC); /*initialise printer*/
	       prn_putc('@');
	    }
#        endif
      }
   }
   /*** select data saved to file ***/
  select40:
   filedata=0;
   if (acceptall==0 && accept_from==2){
      sprintf(textb[0],"save data to file");
      sprintf(textb[1],"basin data only-1, and tree data-2:");
      xbox=draw_prompt_box(2);
      outtext(textb[0]);
      moveto(xbox,gety+CHeight);
      myouttext(textb[1]);
      input_string(1,0);
      erase_prompt_box(2);
      if (is[0]=='q') goto select30;
      if (is[0]=='d') acceptall=1;
      else {
	 if (is[0]=='1') filedata=1;
	 else if (is[0]=='2') filedata=2;
	 if (filedata){
	    file_ret=select_filename("SAVE","DATA","*.dat","my_data");
	    if (file_ret=='q') goto select40;
	    memcpy(filename_data,filename,13);
#           if __BORC__||__WATCOM__
	       if ((fid=open(filename_data,
		  O_RDWR|O_CREAT|O_TRUNC|O_TEXT,
			      S_IREAD|S_IWRITE) )==-1){
	          sprintf(textb[0],"%s, RETURN-continue",
                                        sys_errlist[errno]);
#           elif __UNIX__
               if ((fid=open(filename_data,		  
                  O_RDWR|O_CREAT|O_TRUNC,S_IREAD|S_IWRITE) )==-1){      
                  sprintf(textb[0],"file error, RETURN-continue");
#           endif
	       draw_prompt_box(1);
	       outtext(textb[0]);
	       input_string(1,0);
	       erase_prompt_box(1);
	       input_string(1,0);
	    }
	    close(fid);
	 }
      }
   }
   if (accept_from==2) accept_from=3;
}
/************** specify mutation for next network ***********************/
void set_mutation(void){
  signed short xbox;
  char which;

  select50:
   which=0;
   mutate='b';
   bits_to_flip=1;
   if (totalistic) mutate=4;       /*random code*/
   if (gd_z_graph || screensavedemo==1){
      if (totalistic==0) mutate=2; /*random rule*/
      if (gd_z_graph){
	 if (nhood<=3) mutate=3;   /*decriment rule no*/
	 if (totalistic) mutate=5; /*decriment code no*/
      }
   }

   if (acceptall==0 && accept_from==3){

      sprintf(textb[0],"MUTATION: for next basin/s");
      if (loc_twod_fonly) sprintf(textb[1],
	      "rule:special-s, set bits-b, single bit (default):");
      else sprintf(textb[1],
	     "wiring-w, rule:special-s, set bits-b, single bit (default):");

      xbox=draw_prompt_box(2);
      outtext(textb[0]);
      moveto(xbox,gety+CHeight);
      myouttext(textb[1]);
      input_string(1,0);
      erase_prompt_box(2);
      if (is[0]=='q') return;
      if (is[0]=='d') acceptall=1;

      if (is[0]=='w'){
	 mutate='w';
	 nonlocal=1;
	 wire_move('s',0); /*specify wire moves*/
	 if (is[0]=='q') goto select50;
      }
      else if (is[0]=='b'){
	 mutate='b';
	 set_bit_flips();
	 if (is[0]=='q') goto select50;
      }

      else if (is[0]=='s'){
	 mutate=2;
	 sprintf(textb[0],"specify rule mutation");
	 if (totalistic){
	    if (nhood<=5){
	       sprintf(textb[1],
	       "codeno-5 randcode-4 ruleno-3 randrule-2,");
	       which=4;
	    }
	    if (nhood>5){
	       sprintf(textb[1],"codeno-5 randcode-4 randrule-2,");
	       which=3;
	    }
	 }
	 else{
	    if (nhood<=5){
	       sprintf(textb[1],"ruleno-3 randrule-2,");
	       which=2;
	    }
	    if (nhood>5){
	       sprintf(textb[1],"randrule-2,");
	       which=1;
	    }
	 }
	 if (!nhood_mixed){
	    sprintf(textb[2],
	      "bitflip from left: cumulative-1 single-0 (default %d):",
								mutate);
	 }
	 xbox=draw_prompt_box(3);
	 outtext(textb[0]);
	 moveto(xbox,gety+CHeight);
	 myouttext(textb[1]);
	 moveto(xbox,gety+CHeight);
	 myouttext(textb[2]);
	 input_string(1,0);
	 erase_prompt_box(3);
	 if (is[0]=='q'){
	    if (loc_twod_fonly) return;
	    else goto select50;
	 }
	 if (is[0]=='d') acceptall=1;
	 else if (is[0]!=13 && atoi(is)<6 && atoi(is)>-1) mutate=atoi(is);
	 if (mutate<=3) totalistic=0;
	 if (which==3 && is[0]=='3') mutate=0;
	 if (which==2 && (is[0]=='5'||is[0]=='4')) mutate=0;
	 if (which==1 && (is[0]=='5'||is[0]=='4'||is[0]=='3')) mutate=0;

	 /*** specify start and end bitflip position ***/
	 if (mutate==1 || mutate==0){
	    startmut=(signed short)pow(2,(double)nhood)-1;
	    endmut=0;
	    if (acceptall==0 && accept_from==3){
	       xbox=draw_prompt_box(2);
	       sprintf(textb[0],
		"specify start - end position of bitflip (countdown)");
	       myouttext(textb[0]);
	       moveto(xbox,gety+CHeight);
	       sprintf(textb[0],"start position (default %d):",startmut);
	       myouttext(textb[0]);
	       input_string(4,0);
	       if (is[0]=='q'){
		  erase_prompt_box(2);
		  goto select50;
	       }
	       if (is[0]=='d'){
		  acceptall=1;
		  erase_prompt_box(2);
	       }
	       else if (is[0]!=13) startmut=atoi(is);
	       if (acceptall==0){
		  moveto(getx+10,gety);
		  sprintf(textb[0],"end position (default %d):",endmut);
		  myouttext(textb[0]);
		  input_string(4,0);
		  erase_prompt_box(2);
		  if (is[0]=='q') return;
		  if (is[0]=='d') acceptall=1;
		  else if (is[0]!=13) endmut=atoi(is);
	       }
	    }
	 }
      }
   }
   /*** pause to see data, trees and basins ***/
   if (datapause==0){
      mutantdontpause=0;
      if (gd_z_graph || screensavedemo==1) mutantdontpause=1;
      if (acceptall==0 && accept_from==3){
	 if (mutantdontpause==0) sprintf(textb[0],
	      "dont pause after mutant graphics-y:");
	 else sprintf(textb[0],
	      "pause after mutant graphics enter-y:");
	 draw_prompt_box(1);
	 myouttext(textb[0]);
	 input_string(1,0);
	 erase_prompt_box(1);
	 if (is[0]=='q') goto select50;
	 else if (is[0]=='d') acceptall=1;
	 else if (is[0]=='y') mutantdontpause=abs(mutantdontpause-1);
      }
   }
}

/****************** move one or more wires   ******************/
void set_bit_flips(void){
 signed short xbox,tablemax;
 unsigned short poss;
 signed long tb;

   tablemax=(signed short)pow(2,(double)nhood)-1;
   if (!rulemix) tb=tablemax+1;
   else{
      if (bits_to_flip==0) bits_to_flip=1;
      tb=0;/*total bits*/
      if (!nhood_mixed) tb=(tablemax+1)*lineL;
      else{
	 for (poss=0;poss<=lineL-1;poss++){
	    tablemax=(signed short)pow(2,(double)nhoodm[poss])-1;
	    tb+=(tablemax+1);
	 }
      }
   }
  start:
   sprintf(textb[0],
     "bits to flip=%d/%d=%.3g%%: all-a number-n percentage-p:",
	      (unsigned short)bits_to_flip,(unsigned short)tb,
			    100*(double)bits_to_flip/tb);
   xbox=draw_prompt_box(2);
   myouttext(textb[0]);
   input_string(1,0);
   moveto(xbox,gety+CHeight);
   if (is[0]=='q') return;
   if (is[0]=='a') bits_to_flip=-1;
   else if (is[0]=='p'){
      myouttext("percentage of total bits:");
      input_string(3,1);
      if (is[0]=='q') goto start;
      if (is[0]!=13 && atoi(is)>0 && atoi(is)<100)
			      bits_to_flip=atoi(is)*tb/100;
   }
   else if (is[0]=='n'){
      myouttext("number of bits:");
      input_string(6,1);
      if (is[0]=='q') goto start;
      if (is[0]!=13 && atoi(is)>0 && atoi(is)<tb) bits_to_flip=atoi(is);
   }
   erase_prompt_box(2);
}

/****************** move one or more wires   ******************/
unsigned char wire_move(char what,unsigned char color1){
  signed short tempx,tempy,xbox;
  unsigned short poss,wire;
  signed long tw;

   if (wires_to_move==0) wires_to_move=1;
   tw=0;/*total wires*/
   if (!nhood_mixed) tw=nhood*lineL;
   else{
      for (poss=0;poss<=lineL-1;poss++) tw+=nhoodm[poss];
   }

   if (what=='M' || what=='s'){ /*s=set only from set_mutation*/
     start:
      tempx=getx;
      tempy=gety;
      draw_prompt_box(2);
      sprintf(textb[0],
      "wires to move=%d/%d=%.3g%%: all-a number-n percentage-p:",
	     (unsigned short)wires_to_move,(unsigned short)tw,
			    100*(double)wires_to_move/tw);
      xbox=draw_prompt_box(2);
      myouttext(textb[0]);
      input_string(1,0);
      moveto(xbox,gety+CHeight);
      if (is[0]=='q') return(color1);
      if (is[0]=='a') wires_to_move=-1;
      else if (is[0]=='p'){
	 myouttext("percentage of total wires:");
	 input_string(3,1);
	 if (is[0]=='q') goto start;
	 if (is[0]!=13 && atoi(is)>0 && atoi(is)<100)
					  wires_to_move=atoi(is)*tw/100;
      }
      else if (is[0]=='n'){
	 myouttext("number of wires:");
	 input_string(4,1);
	 if (is[0]=='q') goto start;
	 if (is[0]!=13 && atoi(is)>0 && atoi(is)<tw) wires_to_move=atoi(is);

      }
      erase_prompt_box(2);
      moveto(tempx,tempy);
   }
   /*move one or more wires at random*/
   if (what!='s'){
      if (wires_to_move==-1){
	 for (poss=lineL-1;poss!=Maxu;poss--)
			   randomly_wire_cell(poss,lineL-1);
      }
      else{
	 for (wire=1;wire<=wires_to_move;wire++){
	    poss=myrand()%lineL;
	    wiring[poss][myrand()%nhoodm[poss]]=myrand()%lineL;
	 }
      }
      if (ncolor==0){
	 if (color1==white) color1=yellow;
	 else if (color1==yellow) color1=white;
      }
   }
   return(color1);
}

/************* run CA forwards or backwards, 19 June 1993 ***************/
void select_foreward_back(void){
 signed short xbox;

   moveto(memory_box(0)+vgax(3),vgay(3));
   setcolor(lightred);
   outtext("accept defaults-d");
   setcolor(white);


  start:
   exhaustive_testing=0;
   show_ss_matrixF=0;
   limitcheck=10000;
   direction='f';
   setcolor(white);
   sprintf(textb[0],"run network backward-b, forward (default):");
   draw_prompt_box(1);
   myouttext(textb[0]);
   input_string(1,0);
   if (is[0]=='q' || is[0]=='d') return;
   if (is[0]=='b') direction='b';   /*backward, sub-tree only*/
   else{
      direction='f';   /*forward*/
      xbox=draw_prompt_box(3);
      outtext("(default repeat check limit=10,000 steps)");
      moveto(xbox,gety+CHeight);
      outtext("draw basin-ret (or enter revised limit)");
      moveto(xbox,gety+CHeight);
      outtext("space-time pattern only (no basin)-s:");
      input_string(31,0);
      erase_prompt_box(3);
      if (is[0]=='d') return;
      if (is[0]=='q') goto start;
      if (is[0]=='s'){
	 limitcheck=0;
	  show_ss_matrixF=1;
      }
      else if (is[0]==13) limitcheck=10000; 
      else limitcheck=atoi(is);

      if (limitcheck>0){
	 see_ppstack=0;
	 sprintf(textb[3],"%s","");
	 if (lineL<limitL) /*borc<19 watcom<33*/
	    sprintf(textb[3],"exh testing-e, rand graph-r");
	 if (nonlocal){
	    sprintf(textb[2],"(non-local)");
	    sprintf(textb[1],"view partial pre-image stack-1, fan pause-2:");
	 }
	 else{
	    sprintf(textb[2],"(local)");
	    sprintf(textb[1],"view partial pre-image stack-1:");
	 }
	 if (rangeL) sprintf(textb[0],"single basin %s L=%d-%d, %s,",
			  textb[2],startL,endL,textb[3]);
	 else sprintf(textb[0],"single basin %s L=%d, %s,",
		  textb[2],lineL,textb[3]);
	 xbox=draw_prompt_box(2);
	 outtext(textb[0]);
	 moveto(xbox,gety+CHeight);
	 myouttext(textb[1]);
	 input_string(1,0);
	 if (is[0]=='d'){
	    erase_prompt_box(2);
	    return;
	 }
	 if (is[0]=='q'){
	    erase_prompt_box(2);
	    goto start;
	 }

	 if (is[0]=='1') see_ppstack=1;
	 else if (is[0]=='2') see_ppstack=2;
	 else if (lineL<limitL){ /*borc<19 watcom<33*/
	    if (is[0]=='e') exhaustive_testing=1;
	    else if (is[0]=='r') exhaustive_testing=2;
         }
	 erase_prompt_box(2);
      }
   }
   if (direction=='f' && limitcheck==0) forward_only_para();
   if (is[0]=='q') goto start;
}

/****************** forward only parameters ********************/
void forward_only_para(void){
   signed short xbox;
   char dup_net;
     start:
      rand_seed_percent=100; /*fully random seed setting, % can be revised*/
      exhaustive_testing=0;
      moveto(memory_box(0)+vgax(3),vgay(3)); 
      setcolor(lightred);
      outtext("accept defaults-d");
      setcolor(white);

      gens=10;
      frozen_gens=20;
      stpgraph=2;  /*default show look-up frequency*/
      if (nhood_mixed) stpgraph=1;
      if (twod) stpgraph=0;
      ncolor=1;  /*colors acc to nhoods*/
      stppause=0;
      show_ss_matrixF=0;

      stp=1; /*show space-time pattern*/
      sprintf(textb[0],
	"FORWARD ONLY: color cells by value-v (default by nhood):");
      draw_prompt_box(1);
      myouttext(textb[0]);
      input_string(1,0);
      if (is[0]=='q' || is[0]=='d') return;
      if (is[0]=='v') ncolor=0;
      if (twod!=2){
	 sprintf(textb[0],"PAUSE on space-time screen full-p:");
	 draw_prompt_box(1);
	 myouttext(textb[0]);
	 input_string(1,0);
	 if (is[0]=='q') goto start;
	 else if (is[0]=='d') return;
	 else if (is[0]=='p') stppause=1;
      }
      if (!twod){
         scrolling=0;
         sprintf(textb[0],"SCROLL space-time pattern-s: ");
         draw_prompt_box(1);
         myouttext(textb[0]);
         input_string(1,0);
         erase_prompt_box(1);
         if (is[0]=='q')  goto start;
         else if (is[0]=='d') return;
         else if (is[0]=='s') scrolling=1;
      }

      sprintf(textb[0],
	 "enter new 'frozen' generation size (now %d):",frozen_gens);
      draw_prompt_box(1);
      myouttext(textb[0]);
      input_string(3,0);

      if (is[0]=='q') goto start;
      else if (is[0]=='d') return;
      else if (is[0]!=13 && atoi(is)>0) frozen_gens=atoi(is);

      if (lineL<limitL){ /*borc<19 watcom<33*/
	 sprintf(textb[0],"random map-r:");
	 draw_prompt_box(1);
	 myouttext(textb[0]);
	 input_string(1,0);
	 if (is[0]=='q')  goto start;
	 else if (lineL<limitL && is[0]=='r'){ /*borc<19 watcom<33*/
	    exhaustive_testing=2;
	    stpgraph=0;
	 }
      }

      if (scrolling==0 && !twod && exhaustive_testing!=2){
	 if (!nhood_mixed){
	    sprintf(textb[0],
	      "analysis: none-0, pattern density-1,");
	    sprintf(textb[1],
	      "look-up frequency/entropy: graph-3, histogram (default):");
	    xbox=draw_prompt_box(2);
	 }
	 else{
	    sprintf(textb[0],
	      "MIXED N'HOODS");
	    sprintf(textb[1],
	      "analysis: none-0, pattern density (default):");
	    xbox=draw_prompt_box(2);
	 } erase_prompt_box(2);
         xbox=draw_prompt_box(2);
	 myouttext(textb[0]);
	 moveto(xbox,gety+CHeight);
	 myouttext(textb[1]);
	 input_string(1,0);
	 erase_prompt_box(2);
	 if (is[0]=='q') goto start;
	 else if (is[0]=='d') return;
	 else if (is[0]!=13 && atoi(is)<4) stpgraph=atoi(is);
	 if (nhood_mixed && stpgraph>1) stpgraph=1;
	 erase_prompt_box(2);

	 if (stpgraph>0){
	    sprintf(textb[0],
	      "enter new 'analysis' generation size (now %d):",gens);
	    draw_prompt_box(1);
	    myouttext(textb[0]);
	    input_string(3,0);
	    if (is[0]=='q') goto start;
	    else if (is[0]=='d') return;
	    else if (is[0]!=13 && atoi(is)>0) gens=atoi(is);
	 }
      }
      /*plot the derrida for a large set of initial state pairs*/
      draw_prompt_box(1);
      outtext("Derrida plot-D:");
      input_string(1,0);
      if (is[0]=='D') draw_Derrida_plot();
      if (is[0]=='q') goto start;      
      else if (is[0]=='d') return;
      
      /*show difference betwwen two equal size/shape  networks*/
      /*if even length 1d or even width 2d*/
      
      diff_plot=0;
      xbox=draw_prompt_box(2);
      outtext("show difference between 2 networks");
      moveto(xbox,gety+CHeight);
      outtext("damage: keep-f, dont keep-F, show stats-s:");
      input_string(1,0);
      erase_prompt_box(2);
      if (is[0]=='q') goto start;
      if (is[0]=='f') diff_plot=2;
      else if (is[0]=='s') diff_plot=3;
      else if (is[0]=='F') diff_plot=1;

      if (lineL<(unsigned short)(255*255)/2 && !loc_twod_fonly){
         dup_net=0;
	 draw_prompt_box(1);
	 outtext("duplicale network and seed-y:");
	 input_string(1,0);	   
	 erase_prompt_box(1);
	 if (is[0]=='q') goto start;
	 if (is[0]=='y'){
	    dup_net=1;
	    duplicate_net();
	 }
	 else if (is[0]=='d') return;
      }

      if ((!twod && lineL%2!=0) || (twod==2 && i2d%2!=0)){
	 if (diff_plot&& dup_net==0){
            draw_prompt_box(1);
	    outtext("cant divide odd width network, cont-ret:");
	    input_string(1,0);	
            diff_plot=0;
         }
      }
      if (scrolling==0){
	 sprintf(textb[0],"show state space matrix-m:");
	 draw_prompt_box(1);
	 myouttext(textb[0]);
	 input_string(1,0);
	 if (is[0]=='q')  goto start;
	 if (is[0]=='m') show_ss_matrixF=1;
      }
}

/******* duplicate 1d or 2d network in network twice the size **********/ 
void duplicate_net(void){		
 signed short tablebytes,
              wire,ii,jj,wirejj;
 unsigned short zu;
 char *nhoodm_temp,**carule_temp,*bitseed_temp;
 unsigned short **wiring_temp;
     
	 /*double the network by making identical copy*/
         /*copy existing network architecture to temp arrays*/
         /**********************allocate and copy nhood mix**********/
	 if ((nhoodm_temp=(char *)calloc(lineL,sizeof(char)))
				   ==NULL) outof_memory("nhoodm_temp");
         memcpy(nhoodm_temp,nhoodm,lineL*sizeof(char));

         /************** allocate and copy rulemix  ******************/
         /*note: single rule networks have only carule[0] allocated*/
         tablebytes=(signed short)ceil(pow(2,(double)nhood)/8);
         /*one rule only*/
         if ((carule_temp=(char**)calloc(1,sizeof(char*)))
				   ==NULL) outof_memory("carule_temp");
         if ((carule_temp[0]=(char *)calloc(tablebytes,sizeof(char)))
				   ==NULL) outof_memory("carule_temp[0]");
         memcpy(carule_temp[0],carule[0],tablebytes);
         if (rulemix){
            if ((carule_temp=(char**)realloc(carule_temp,
               lineL*sizeof(char*)))==NULL) outof_memory("carule_temp");
            for (zu=1;zu<=lineL-1;zu++){
               sprintf(textb[0],"carule_temp[%d]",zu);
               if ((carule_temp[zu]=(char *)calloc(tablebytes,sizeof(char)))
					==NULL) outof_memory(textb[0]);
               memcpy(carule_temp[zu],carule[zu],tablebytes);
            }            
         }
         /*************** allocate and copy wiring  **************/  
         /*note: homogenious wiring networks still have all wiring
           specified, except "loc_twod_fonly" */       
         if ((wiring_temp=(unsigned short**)
                     calloc(lineL,sizeof(unsigned short*)))
					==NULL) outof_memory("**wiring");
         for (zu=0;zu<=lineL-1;zu++){
	    sprintf(textb[0],"wiring_temp[%d]",zu);
	    if ((wiring_temp[zu]=
	       (unsigned short*)calloc(nhood,sizeof(unsigned short)))
					==NULL) outof_memory(textb[0]);
	     memcpy(wiring_temp[zu],wiring[zu],
                                    nhood*sizeof(unsigned short));
         }
         /*************** allocate and copy seed  **************/
         if ((bitseed_temp=(char *)calloc(bytesL,sizeof(char)))
					==NULL) outof_memory("bitseed");
         memcpy(bitseed_temp,bitseed,bytesL);

         /******* free current network *********/
         free(nhoodm);      
	 if (rulemix){
	    free_mem_rulemix();
	    free_mem_tcodemix();
	 }
	 free_mem_rule0();
	 free_mem_tcode0();
	 free_mem_wiring();
	 free_mem_CA_states();
	 /*************** double network size  ************/
	 lineL*=2;
	 L=lineL-1;
	 if (twod) i2d*=2;
	 /*no of bytes required to contain lineL bits*/
	 bytesL=(signed short)ceil((double)lineL/8);

	 /*************** allocale double network ************/
	 if ((nhoodm=(char *)calloc(lineL,sizeof(char)))
				   ==NULL) outof_memory("nhoodm");
	 allocate_mem_rule0(nhood);
	 allocate_mem_tcode0(nhood);
	 if (rulemix){
	    allocate_mem_rulemix(nhood);
	    allocate_mem_tcodemix(nhood);
         }
	 allocate_mem_wiring();
	 allocate_mem_CA_states();
	 /*********** copy nhood mix **********/
	 if (!nhood_mixed){
	    for (zu=0; zu<=lineL-1;zu++) nhoodm[zu]=nhood;
	 }
         else{
            if (!twod){	    
	       memcpy(nhoodm+lineL/2,nhoodm_temp,
                              (lineL/2)*sizeof(char));
               memcpy(nhoodm,nhoodm_temp,(lineL/2)*sizeof(char));	      
            }
            else{
               for (jj=j2d-1;jj>=0;jj--){
                  for (ii=i2d/2-1;ii>=0;ii--){
		     nhoodm[jj*i2d+i2d/2+ii]=nhoodm_temp[jj*i2d/2+ii];
                     nhoodm[jj*i2d+ii]=nhoodm_temp[jj*i2d/2+ii];
                  }	
               }  
            }
         }
         /**************** copy wiring *****************/     
         nonlocal=1;
         if (!twod){
	    for (zu=lineL/2-1;zu!=Maxu;zu--){
	       for (wire=nhoodm_temp[zu];wire>=0;wire--){       
		   wiring[zu+lineL/2][wire]=
                               wiring_temp[zu][wire]+lineL/2;
                   wiring[zu][wire]=wiring_temp[zu][wire];
               }
	    }
         }         
         else{
            for (jj=j2d-1;jj>=0;jj--){
	       for (ii=i2d/2-1;ii>=0;ii--){
		  for(wire=nhoodm_temp[jj*i2d/2+ii];wire>=0;wire--){
                     wirejj=wiring_temp[jj*i2d/2+ii][wire]/(i2d/2);
                     wiring[jj*i2d+i2d/2+ii][wire] = 
                          wiring_temp[jj*i2d/2+ii][wire]+(wirejj+1)*i2d/2;
                     wiring[jj*i2d+ii][wire] = 
                          wiring_temp[jj*i2d/2+ii][wire]+wirejj*i2d/2;
                  }
	       }		        
	    }
         }
         for (zu=0;zu<=lineL/2-1;zu++) free(wiring_temp[zu]);
         free(wiring_temp);   
         free(nhoodm_temp);   
         /***** realloc and recalculate cell out degree frequency ****/
         if ((celloutfreq=(unsigned short*)realloc
		     (celloutfreq,lineL*sizeof(unsigned short)))
                        ==NULL) outof_memory("celloutfreq");
         cell_out_freq();
         /************ copy rule or rulemix ************/ 
         tablebytes=(signed short)ceil(pow(2,(double)nhood)/8);
	 if (rulemix==0) memcpy(carule[0],carule_temp[0],tablebytes);
         else{
            if (!twod){
               for (zu=lineL/2-1;zu!=Maxu;zu--){
                  memcpy(carule[zu+lineL/2],carule_temp[zu],tablebytes);
                  memcpy(carule[zu],carule_temp[zu],tablebytes);
	       }
            }
            else{
               for (jj=j2d-1;jj>=0;jj--){
                  for (ii=i2d/2-1;ii>=0;ii--){
		     memcpy(carule[jj*i2d+i2d/2+ii],
                         carule_temp[jj*i2d/2+ii],tablebytes);
                     memcpy(carule[jj*i2d+ii], 
                         carule_temp[jj*i2d/2+ii],tablebytes);
                  }	
               }               
	    }
	 }
         if (rulemix){
	    for (zu=1;zu<=lineL/2-1;zu++) free(carule_temp[zu]);
         }
         free(carule_temp[0]);
	 free(carule_temp);
         /***** show duplicated rule-wiring scheme ************/
         show_w_r_scheme();
         /******************** copy state *******************/
         if (!twod){
            for (zu=lineL/2-1;zu!=Maxu;zu--){
                set_bit(bitseed,zu+lineL/2,
			    get_bit(bitseed_temp,zu));
		set_bit(bitseed,zu,get_bit(bitseed_temp,zu));
            }
         }
         else{
            for (jj=j2d-1;jj>=0;jj--){
	       for (ii=i2d/2-1;ii>=0;ii--){
                   set_bit(bitseed,jj*i2d+i2d/2+ii,
                         get_bit(bitseed_temp,jj*i2d/2+ii));
                   set_bit(bitseed,jj*i2d+ii,
                         get_bit(bitseed_temp,jj*i2d/2+ii)); 
	       }		        
            }
         }
         free(bitseed_temp);
         /*see/ammend result*/
         moveto(vgax(50),gety);
         select_seed(bitseed,"SEED",0);     
}
/********************* draw Derrida plot *******************/
/*draw Derrida plot - 
  set randomly pairs of initial states with given 
  Hamming distance, plot H(t0)-H(t1) for a large set of pairs,
  repeat for all possible values H(t0)*/

void draw_Derrida_plot(void){      
 signed short xbox,u,z,i,temp,
              Dt0,Dt1,
              xstart,ystart,xsize,ysize;
              

 unsigned short    n,zu,zu1,Hamm,Hamm_reached,
                   bitno,itcount;
 char              test,D_was_drawn=0,
                   interrupt_run,Hamm_step_changed,   
                   **Dseed, **Dnextseed,*temppoint, 
                   *firstA, *compA, *firstcompA;
 D_prompts         Dp;
 
 unsigned char     tempcolor;
 unsigned short      *pnhood;
 signed short      sample,temp_Hamm_step;
 float             totalDt1,*buff_average_Dt1;
 /*for canalyzing data*/  
 unsigned short    poss,cgenenet;
 unsigned long     inputtotal,cinputnet;
 float             cinputfreq,cgenefreq;                          
     
           
      xstart=Maxx/2;
      ystart=Maxy-vgax(50);
      xsize=vgax(300);
      ysize=vgay(300); 

#     if __BORC__
           draw_box(-1,xstart-vgax(30),ystart-ysize-vgay(10),

	             xstart+xsize+vgax(10),ystart+vgax(20),0,0);	   
#     elif __WATCOM__||__UNIX__
         draw_box(11,xstart-vgax(30),ystart-ysize-vgay(10),
	             xstart+xsize+vgax(10),ystart+vgax(20),0,0);	  
#     endif

     start0:              
      /*memory for pseudo-nhood*/
      sprintf(textb[0],"pnhood");
      if ((pnhood=(unsigned short *)calloc(nhood,sizeof(unsigned short)))
			      ==NULL) outof_memory(textb[0]);
      /*memory for seed - successor pairs*/
      sprintf(textb[0],"mem for Derrida plot");
      if ((buff_average_Dt1=(float*)calloc(lineL,sizeof(float)))
				    ==NULL) outof_memory(textb[0]);
      if ( (Dseed =(char**) calloc(2,sizeof(char*)))
				 ==NULL) outof_memory(textb[0]);
      if ( (Dnextseed =(char**) calloc(2,sizeof(char*)))
				 ==NULL) outof_memory(textb[0]);
      for (z=0;z<=1;z++){
         if ((Dseed[z]=(char*)calloc(bytesL,sizeof(char)))
				    ==NULL) outof_memory(textb[0]);
         if ((Dnextseed[z]=(char*)calloc(bytesL,sizeof(char)))
				    ==NULL) outof_memory(textb[0]);
      }
      if ((firstA=(char*)calloc(bytesL,sizeof(char)))
				    ==NULL) outof_memory(textb[0]);      
      if ((compA=(char*)calloc(bytesL,sizeof(char)))
				    ==NULL) outof_memory(textb[0]);
      
      if ((firstcompA=(char*)calloc(bytesL,sizeof(char)))
				    ==NULL) outof_memory(textb[0]);
    prompts:
      Dp.D_sample=25;
      Dp.Hamm_step=1;
      Dp.itlimit=1; 
      D_was_drawn=0;
     
      xbox=draw_prompt_box(3);
      if (D_was_drawn) sprintf(textb[0],
	 "Derrida plot: redraw (no fuzz)-r, load-l quit-q:");
      else sprintf(textb[0],"Derrida plot: load-l quit-q:");
            
      outtext(textb[0]);
      input_string(5,0);	
      if (is[0]=='q') return;            
      
      if (is[0]=='r' && D_was_drawn){ 
         /*redraw graph*/
         draw_general_graph_frame(1,xstart,ystart,xsize,ysize,10,10);
         /*draw red diagonal*/
         setcolor(lightred);          
         line(xstart,ystart,xstart+xsize,ystart-ysize);
        
         /*draw average curve*/      
         setcolor(white);
         if (Hamm_reached==0) Hamm_reached=lineL;
         for (Hamm=0;Hamm<=Hamm_reached-1;Hamm++){      
                  line(xstart+((float)(Hamm)/lineL)*(float)xsize, 
                     ystart-buff_average_Dt1[Hamm]*(float)ysize,
                        xstart+((float)(Hamm+1)/lineL)*(float)xsize, 
                           ystart-buff_average_Dt1[Hamm+1]*(float)ysize);
         }
         goto forward_skip;
      }    

      moveto(xbox,gety+CHeight);
      get_D_para(&Dp);
      if (is[0]=='q') goto prompts;     
      tempcolor=getcolor();
      
      xbox=draw_prompt_box(2);
      sprintf(textb[0],
	 "plotting Derrida, sample size=%d, iteration limit=%d",
                                                 Dp.D_sample,Dp.itlimit);
      sprintf(textb[1],
	 "Hamming step=%d, quit/pause to see average-q",Dp.Hamm_step);
      outtext(textb[0]);
      moveto(xbox,gety+CHeight);
      outtext(textb[1]);
     
      Hamm_reached=0;
      draw_general_graph_frame(1,xstart,ystart,xsize,ysize,10,10);
      /*draw red diagonal*/
      setcolor(lightred);          
      line(xstart,ystart,xstart+xsize,ystart-ysize);
      setcolor(white); 

      moveto(xstart,ystart-ysize+2);
     
      if (nhood_mixed) sprintf(textb[0],"  k-mix=%d-%d",nhood_lb,nhood_ub);
      else sprintf(textb[0]," k=%d",nhood);
      outtext(textb[0]);
      if (twod) sprintf(textb[0]," network size= %dx%d",
                                      i2d,j2d);
      else  sprintf(textb[0]," network size= %d",lineL);
      outtext(textb[0]);

      moveto(xstart,gety+CHeight);
      if (!nonlocal) outtext(" one-d CA wiring");
      else if (regular2d) outtext(" two-d CA wiring");
      else if (twod) outtext(" random two-d wiring");
      else outtext(" random one-d wiring");
      if (nonlocal && !regular2d){
	  if (twod){
             if ((signed short)zonesize==i2d) outtext(" no limit");
             else{
                 sprintf(textb[0]," zone=%d",zonesize);
                 outtext(textb[0]);
             }
          }
	  else{
             if (zonesize==lineL) outtext(" no limit");
             else{
                 sprintf(textb[0]," zone=%d",zonesize);
                 outtext(textb[0]);
             }
	  }
      }
      moveto(xstart,gety+CHeight);
      inputtotal=cinputnet=cgenenet=0;
      if (rulemix){/*check canalyzing gene/input %*/         
         for (poss=lineL-1;poss!=Maxu;poss--){
            if (nhood_mixed) inputtotal+=nhoodm[poss];
            canalyzing(nhoodm[poss],0,carule[poss]);
            if (canaltotal>0){
	       cinputnet+=canaltotal;
	       cgenenet+=1;
	    }
         }
      
         if (!nhood_mixed) inputtotal=lineL*nhood;
         cinputfreq=(float)cinputnet/inputtotal;
         cgenefreq=(float)cgenenet/lineL;
	 sprintf(textb[0],
	   " rulemix: canalyzing inputs=%lu/%lu=%.1f%%",
			cinputnet,inputtotal,cinputfreq*100);
	 outtext(textb[0]);
	 moveto(xstart,gety+CHeight);
	 sprintf(textb[0],
	   "          genes=%d/%d=%.1f%%",
			   cgenenet,lineL,cgenefreq*100);
	 outtext(textb[0]);
      }
      else outtext(" homogeneous CA rule");

      Hamm_step_changed=0;
      for (Hamm=1;Hamm<=lineL;Hamm+=Dp.Hamm_step){
          totalDt1=0;
          if (interrupt_run==1 && is[0]=='q'){ 
             is[0]=0;  
             Hamm_reached=Hamm-Dp.Hamm_step;  
             break;
	  }          
          interrupt_run=0;
         
          for (sample=1;sample<=Dp.D_sample;sample++){
             if (event_ready()){
                if (is[0]=='q'){                    
                   interrupt_run=1;   
                  start_int:
                   xbox=draw_prompt_box(4);                          
                   sprintf(textb[0],                                 
	              "interrupted at Hamm=%f, quit now-q, cont-ret:",
                                         (float)(Hamm-1)/lineL);
                   outtext(textb[0]);                                  
                   moveto(xbox,gety+CHeight);
                   outtext("image:print-p, save-s, save data-D:");
                   input_string(1,0);                             

                   switch (is[0]){  
		     case 'q':                   
                      Hamm-=Dp.Hamm_step;  
                      break;                 
         
                     case 'p':	
#                     if __BORC__||__WATCOM__
                         printimage('L',0,0,0,0,getmaxx(),getmaxy());
#                     elif __UNIX__
                         printimage();
#                     endif
                      goto start_int;
                     case 's':	
	              save_screen();
	              goto start_int;
                   }
                   moveto(xbox,gety+CHeight);                    
                   temp_Hamm_step=Dp.Hamm_step;
                   get_D_para(&Dp);                              
                   if (temp_Hamm_step!=Dp.Hamm_step) Hamm_step_changed=1; 
                   Hamm-=Dp.Hamm_step;
                   erase_prompt_box(4);

                   xbox=draw_prompt_box(2);
                   sprintf(textb[0],
	             "plotting Derrida, sample size=%d, iteration limit=%d",
                                                 Dp.D_sample,Dp.itlimit);
                   sprintf(textb[1],
	             "Hamming step=%d, quit/pause to see average-q",
                                       Dp.Hamm_step);
                   outtext(textb[0]);
                   moveto(xbox,gety+CHeight);
                   outtext(textb[1]);

                   break;              
                }         
             }

             for (z=0;z<=1;z++){
                if (z==0){
                   /*set a random seed*/
                   for (zu1=L;zu1!=Maxu;zu1--) 
                       set_bit(A,zu1,((myrand()%100)/50));
                   memcpy(firstA,A,bytesL);
                   memcpy(Dseed[z],A,bytesL); 
	        }
                /*set pair seed at random Ham Hamming distance from first*/
                else if (z==1){
                   /*flip bits if Hamm <= lineL/2*/               
                   if (Hamm<=lineL/2){                       
                      bitno=0;
                      while(1){
                         bitno+=1;
                         zu1=myrand()%lineL; 
                         /*flip a bit at random position*/
                         set_bit(firstA,zu1,abs(get_bit(firstA,zu1)-1));
                         /*restore flip if not different*/
                         if (get_bit(firstA,zu1)==get_bit(Dseed[0],zu1)){ 
                             set_bit(firstA,zu1,abs(get_bit(firstA,zu1)-1));
                             bitno-=1;
                         } 
                         memcpy(A,firstA,bytesL);
                         memcpy(Dseed[z],firstA,bytesL); 
                         if (bitno==Hamm) break;
                      } 	           
                      memcpy(Dseed[z],firstA,bytesL); 

	           }
                   else if (Hamm>=lineL/2+1){
                      /*restore bits in compliment if Hamm >= lineL/2 + 1*/  
                      for (zu1=L;zu1!=Maxu;zu1--) 
                           set_bit(compA,zu1,abs(get_bit(Dseed[0],zu1)-1));
                      memcpy(firstcompA,compA,bytesL);
                      bitno=0;
                      while(1){
                         if (Hamm==lineL) break;
                         bitno+=1;
                         zu1=myrand()%lineL; 
                         /*flip a bit at random position in compliment*/
                         set_bit(compA,zu1,abs(get_bit(compA,zu1)-1))
                         /*restore flip*/
			  if (get_bit(compA,zu1)==get_bit(firstcompA,zu1)){
                                set_bit(compA,zu1,abs(get_bit(compA,zu1)-1));
                                bitno-=1;
                          }
                          if (bitno==lineL-Hamm) break;
                      } 	           
                      memcpy(A,compA,bytesL);
                      memcpy(Dseed[z],compA,bytesL); 
	           }
                }              
                itcount=0;
	        while(1){
                   itcount++;
                   for (n=L; n!=Maxu; n--){
	              /*local nhood with periodic boundary conditions*/
	              if (nonlocal==0){
	                 /*i.e. for nhood=9 lineL=3 to work*/
	                 if (L<nhoodm[n]/2){
		            for (i=0;i<=nhoodm[n]-1;i++){
		               temp=lineL+n-(nhoodm[n]/2)+i;
		               if (temp<0) temp+=lineL;
		               pnhood[i]=abs(temp)%lineL;
		            }
	                 }
	                 else{
		            for (i=0;i<=nhoodm[n]-1;i++)
			       pnhood[i]=(lineL+n-(nhoodm[n]/2)+i)%lineL;
	                 }
	              }    
	              /*set local 2d wiring*/
	              else if (loc_twod_fonly)
		                       set_local_2d_wiring(n,pnhood);
	              /*nonlocal=1, get psuedo-nhood from wiring scheme*/
	              else{
	                 for (i=0;i<=nhoodm[n]-1;i++) 
                                      pnhood[i]=wiring[n][i];
	              }
                      u=0; /*find dec value of actual or pseudo-nhood*/
	              for (i=nhoodm[n]-1;i>=0;i--)
	                 u+=(get_bit(A,
                            pnhood[i])*(signed short)pow(2,(double)i));
	              /*set cell next line according to rule look-up table*/       
                      if (!rulemix){
		         set_bit(F,n,get_bit(carule[0],u));
	              }
	              else set_bit(F,n,get_bit(carule[n],u));      
	           }/*for loop*/            
                   if (itcount==Dp.itlimit){
                       itcount=0;
                       memcpy(Dnextseed[z],F,bytesL);
                       break;
                   }                                  
                   temppoint=A; /*copy F to A*/
	           A=F;
	           F=temppoint;                 
	        } /*while loop*/             
             }/*next z*/ 
	    
             Dt0=Hamm;
             Dt1=0;
             /*check Hamming distance*/
             for (zu=0;zu<=lineL-1;zu++){
                 /*if (get_bit(Dseed[0],zu)!=get_bit(Dseed[1],zu)) Dt0+=1;*/
                 if (get_bit(Dnextseed[0],zu)!=
                            get_bit(Dnextseed[1],zu)) Dt1+=1;   
             }                           
             /*draw pixels for sample*/             
             if (Dp.suppress_fuzz==0){
                putpixel(xstart+
                  ((float)Dt0/lineL)*(float)xsize,
		      ystart-((float)Dt1/lineL)*(float)ysize,yellow);
             }
             totalDt1+=(float)Dt1/lineL;
             
             /*see whats happening for small networks*/
             if (Dp.show_details){                
                if (lineL<=50){
                   xbox=draw_prompt_box(3);
                   print_layered_bitstring(64,Dseed[0],L,scale,sep,0,0);
                   moveto(getx+vgax(10),gety);
                   print_layered_bitstring(64,Dseed[1],L,scale,sep,0,0);
                   moveto(xbox,gety+CHeight);
                   print_layered_bitstring(64,Dnextseed[0],L,scale,sep,0,0);
                   moveto(getx+vgax(10),gety);
                   print_layered_bitstring(64,Dnextseed[1],L,scale,sep,0,0);
                   moveto(xbox,gety+CHeight);
		}
                else draw_prompt_box(1);
                sprintf(textb[0],"H=%d sample=%d (%d,%d)",Hamm,sample,Dt0,Dt1);
                outtext(textb[0]);
                input_string(1,0);
             }       
          }/*next sample*/
          if (interrupt_run==0){
             buff_average_Dt1[Hamm]=totalDt1/Dp.D_sample;

             /*plot average*/
             setcolor(white);
             
             if (Hamm>1 && Hamm_step_changed==0){
                line(xstart+((float)(Hamm-Dp.Hamm_step)/lineL)*(float)xsize, 
                   ystart-buff_average_Dt1[Hamm-Dp.Hamm_step]*(float)ysize,
                     xstart+((float)(Hamm)/lineL)*(float)xsize, 
                       ystart-buff_average_Dt1[Hamm]*(float)ysize);
             }            
	  }
          {/*to skip average plot if Hamm_step changed*/
	  if (Hamm_step_changed)
             if (Hamm_step_changed==2) Hamm_step_changed=0; 
             else if (Hamm_step_changed==1) Hamm_step_changed=2; 
          }
          
      }/*next Hamm*/  

    forward_skip:
       D_was_drawn=1;
      /*draw red diagonal*/
      setcolor(lightred);          
      line(xstart,ystart,xstart+xsize,ystart-ysize);
          
      if (Dp.show_details) erase_prompt_box(3);   
     start:
      setcolor(white);
      xbox=draw_prompt_box(2);   
      sprintf(textb[0],
	 "Derrida_plot complete, sample size %d for each H setting, reset-r"
                                                      ,Dp.D_sample);

      outtext(textb[0]);
      moveto(xbox,gety+CHeight);
      outtext("image:print-p, save-s, load-l, save data-D:");
      input_string(1,0);
    
      switch (is[0]){     

        case 'r':
         setcolor(tempcolor);
         is[0]=0;
         goto start0;
        case 'p':	
#        if __BORC__||__WATCOM__
            printimage('L',0,0,0,0,getmaxx(),getmaxy());
#        elif __UNIX__
            printimage();
#        endif
         goto start;
        case 's':	
	 save_screen();
	 goto start;
        case 'l':
         load_screen();
	 test=0;
#        if __BORC__||__WATCOM__
	 while (!(test=='q' || test==13)) /*pause to grab screen*/
	     test=keycheck(0);
#        elif __UNIX__
             while(!(test=='q' || test==13)){
                 if (XCheckWindowEvent(D,W,KeyPressMask,&Event)){
                    if (Event.type == KeyPress){                    
                       button='k';
                       test=keycheck(0);   
                    }		
	         }
	      }
#        endif
	 goto start;
       }
       for (z=0;z<=1;z++){
         free(Dseed[z]);
         free(Dnextseed[z]);
       }
       free(Dseed);
       free(Dnextseed);
       free(firstA);
       free(compA);
       free(firstcompA);
       free(pnhood);
       free(buff_average_Dt1);
       setcolor(tempcolor);
       erase_prompt_box(2);
       /*delete or restore box*/
#    if __BORC__
        draw_box(-1,xstart-vgax(30),ystart-ysize-vgay(10),
	            xstart+xsize+vgax(10),ystart+vgax(20),0,0);
#    elif __WATCOM__||__UNIX__
	putimage(xstart-vgax(30),ystart-ysize-vgay(10),
                                      boximage[11],COPY_PUT);
	freeimage(boximage[11]);
#    endif

}

/******************** Derreda Prompts *******************/
void get_D_para(D_prompts *this){
   signed short xbox;

      xbox=getx;

      sprintf(textb[0],"sample (now %d):",this->D_sample);
      outtext(textb[0]);
      input_string(4,0);	
      if (is[0]=='q') return;     
      if (is[0]!=13 && atoi(is)>0) this->D_sample=atoi(is);
     
      moveto(getx+CWidth*2,gety);
      this->suppress_fuzz=0;
      outtext("suppress fuzz-c:"); 
      input_string(1,0);	
      if (is[0]=='q') return;     
      if (is[0]=='c') this->suppress_fuzz=1;

      moveto(getx+CWidth*2,gety);
      this->show_details=0;
      outtext("show_details-s:"); 
      input_string(1,0);	
      if (is[0]=='q') return;     
      if (is[0]=='s') this->show_details=1;
 
      moveto(xbox,gety+CHeight);
      sprintf(textb[0],"reset iterations (now %d):",this->itlimit);
      outtext(textb[0]); 
      input_string(3,0);	
      if (is[0]=='q') return;               
      if (is[0]!=13 && atoi(is)>0) this->itlimit=atoi(is);
      
      moveto(getx+CWidth*2,gety);     
      sprintf(textb[0],
           "reset Hamming steps (now=%d net=%d):",this->Hamm_step, lineL);
      outtext(textb[0]); 
      input_string(4,0);	
      if (is[0]=='q') return;               
      if (is[0]!=13 && (atoi(is)>0 && atoi(is)<lineL)) 
                                  this->Hamm_step=atoi(is);      

      erase_prompt_box(3);           

      
}

/****************** draw_general_graph_frame *********************/
void draw_general_graph_frame(char draw_clear,
   signed short xstart,signed short ystart,
        signed short xsize,signed short ysize,
         signed short xmaxdiv,signed short ymaxdiv){
  signed short tempx,tempy, tempx1,tempy1,z;
  unsigned char existcolor;
 
      tempx=getx;
      tempy=gety;

      /*clear space*/
      draw_box(-1,xstart-vgax(10),ystart-ysize,
	             xstart+xsize,ystart+vgax(10),0,0);

      if (draw_clear==0){
	 moveto(tempx,tempy);
	 return;
      }

      existcolor=getcolor();
      setcolor(lightred);
      
      draw_box(-1,xstart,ystart-ysize,
	             xstart+xsize,ystart,1,0);

      /*draw x axis divisions*/
      moveto(xstart,ystart);         
      tempx1=getx;
      tempy1=gety;

      for (z=1;z<=xmaxdiv-1;z++){
	 moveto(getx+xsize/10,tempy1);
	 linerel(0,vgay(3));
      }
      /*draw y axis divisions*/
      moveto(xstart,ystart);
      tempx1=getx;
      for (z=1;z<=ymaxdiv-1;z++){
	 moveto(tempx1,gety-ysize/10);
	 linerel(-vgax(3),0);
      }

      /*label x axis*/
      moveto(xstart,ystart+CWidth/2);
      outtext("0");
      moveto(xstart+xsize/3,ystart+vgax(5));      
      outtext("Hamming distance (t)");
      moveto(xstart+xsize-CWidth/2,ystart+CWidth/2);
      outtext("1");
      /*set vertical text*/
#     if __BORC__
	 settextstyle(2,VERT_DIR , 0);
	 moveto(xstart-vgax(5),ystart);
#     elif __WATCOM__
	 _settextorient(0,1);
         moveto(xstart-vgax(7),ystart);
#     endif
      /*label y axis*/
      moveto(xstart-CHeight,ystart-CHeight);
      outtext("0");
      moveto(xstart-vgax(30),ystart-ysize/2);
      outtext("H(t+1)");
      moveto(xstart-CWidth,ystart-ysize);
      outtext("1");

#     if __BORC__
	 settextstyle(2, HORIZ_DIR, 0);
#     elif __WATCOM__
	 _settextorient(1,0);
#     endif

      setcolor(existcolor);
      moveto(tempx,tempy);
}


/***** if running backward, run forward n steps first, 13 May 93 ********/
void select_stepforward(void){
 unsigned long lz;
 signed short xbox;

   exhaustive_testing=0;
   setcolor(white);
   if (direction=='b'){
     start:
      sprintf(textb[0],"forward before backwards?");
      sprintf(textb[1],"how many steps (default 0, max(");
      xbox=draw_prompt_box(2);
      outtext(textb[0]);
      moveto(xbox,gety+CHeight);
      myouttext(textb[1]);
      if (L<31)    lz=pow( (pow( 2,(double)L)),.5);
      else         lz=pow( (pow( 2,       31)),.5);
      sprintf (textb[0],"%lu):",lz);
      myouttext(textb[0]);
      input_string(5,1);
      erase_prompt_box(2);
      if (is[0]=='q'){
	 erase_prompt_box(2);
	 return;
      }
      if (is[0]==13) stepforward=0;
      else stepforward=atol(is);

      see_ppstack=0;
      sprintf(textb[3],"%s","");
      if (lineL<limitL) /*borc<19 watcom<33*/
	 sprintf(textb[3],"exh testing-e, random map-r");

      if (nonlocal){
	 sprintf(textb[2],"(non-local)");
	 sprintf(textb[1],"view partial pre-image stack-1, fan pause-2:");
      }
      else{
	 sprintf(textb[2],"(local)");
	 sprintf(textb[1],"view partial pre-image stack-1:");
      }
      if (rangeL) sprintf(textb[0],"sub-tree %s L=%d-%d, %s,",
				       textb[2],startL,endL,textb[3]);
      else sprintf(textb[0],"sub-tree %s L=%d, %s,",
				       textb[2],lineL,textb[3]);
      xbox=draw_prompt_box(2);
      outtext(textb[0]);
      moveto(xbox,gety+CHeight);
      myouttext(textb[1]);
      input_string(1,0);
      if (is[0]=='q'){
	 erase_prompt_box(2);
	 goto start;
      }

      if (is[0]=='1') see_ppstack=1;
      else if (is[0]=='2') see_ppstack=2;
      else if (lineL<limitL){ /*borc<19 watcom<33*/
	 if (is[0]=='e') exhaustive_testing=1;
	 else if (is[0]=='r') exhaustive_testing=2;
      }
   }
}



