/************** input from keyboard or mouse Sept 1995 ********************/
#include "edecfunc.h"

#define kCursorFlash 8000

/******************** check event *******************/
char event_ready(){
#   if (__BORC__||__WATCOM__)
      if( (is[0]=keycheck(0))!=0) return(1);
      else return(0);
#   elif (__UNIX__)
      /*if (XEventsQueued(D,QueuedAfterFlush)>0){*/ 
      if (XCheckMaskEvent(D,KeyPressMask|ButtonPressMask,&Event)){
         if (Event.type == ButtonPress) {
            /*left button*/
	     if (Event.xbutton.button==1){
                button='l'; /*left mouse button pressed*/
             }
             /*right button*/
	     else if (Event.xbutton.button==3){
                 button='r'; /*right mouse button pressed*/
             }
         }          
         else if (Event.type == KeyPress) button='k';
         is[0]=keycheck(0);   
         return(1);
       }
      else return(0);
#   endif

}

/*********** check key press April 93, mouse Aug 94 ****************/
signed short keycheck(signed short incount){
  unsigned char test[16],something_pressed=0;     
  KeySym key;
    
      memset(test,0,16);
      /*XNextEvent(D, &Event);*/
      /*XCheckWindowEvent(D,W,KeyPressMask|ButtonPressMask, &Event);*/
      
     if (button=='l'){
		 test[0]=13; /*left mouse button = return*/
		 button=0;
		 something_pressed=1;
     }
     else if (button=='r')
	 {
		 if (incount==0) test[0]='q'; /*right mouse button stepback*/
		 else test[0]=8;              /*               or backspace*/
		 button=0;
		 something_pressed=1;
	  }      
      else if (button=='k'){ 
            XLookupString(&Event.xkey, test, 16, &key, NULL);
            something_pressed=2;  
            if (key>=0xff51 && key<=0xff54)
            {  /*arrow keys*/
		       if (key==0xff51) test[0]=     LeftArrow;
		       else if (key==0xff52) test[0]=UpArrow;
		       else if (key==0xff53) test[0]=RightArrow;
		       else if (key==0xff54) test[0]=DownArrow;
		    }
            else if (key==0xffff) test[0]=8;   /*delete key*/
            
            button=0;
      }         
      /* see data on key or button press*/
      /*
      if (something_pressed){
         tempx=getx;
	 tempy=gety;
         draw_prompt_box(1);
         
         if (something_pressed==1){  //mouse
            if (test[0]==13)  
              sprintf(textb[0],"left button(1) ascii=%d",test[0]);
            if (test[0]==8)  
              sprintf(textb[0],"right button(3) ascii=%d",test[0]);
             outtext(textb[0]);
         }
	 else if (something_pressed==2){  //key 
     	    if (test[0]==128+75)   
	       sprintf(textb[0],"left arrow=%d keysym= %x ",test[0]-128,key);
            else if (test[0]==128+72)  
	       sprintf(textb[0],"up arrow=%d keysym= %x ",test[0]-128,key);
            else if (test[0]==128+77)  
	       sprintf(textb[0],"right arrow=%d keysym= %x ",test[0]-128,key);
            else if (test[0]==128+80)
	       sprintf(textb[0],"down arrow=%d keysym= %x ",test[0]-128,key);
            else if (test[0]!=0)
               sprintf(textb[0],"char= %d = %c keysym= %x ",test[0],test[0],key);
         
            else sprintf(textb[0],"keysym= %x ",key);
            outtext(textb[0]); 
	 }
         moveto(tempx,tempy);
      }
      */
      return(test[0]);
}

/****** create flashing cursor - and check for mouse button press *******/ 
void flashing_cursor(signed short startx,signed short endx,
      signed short starty,signed short endy,
      signed short xl,signed short yt,signed short xr,signed short yb, 
                             unsigned char cursecolor){    
	unsigned short tempy;
	short	got_event = 0;
	short	bartop, barbottom, barleft, barright;
	unsigned long	last_flash = 0;
	short	cursor_visible = 0;
	
	
   tempy=gety;
   moverel(0,vgay(4));
  
   button=button_not_rel=0;
   
   inside_rect=0;
   
   XSetFunction(D,Gc,GXxor);
   
   /*Get the cursor bounds*/
   bartop = gety + yt;
   barleft = getx + xl;
   barbottom = gety + yb - 1;
   barright = getx + xr - 1;
   
   cursor_visible = 1;
   setfillstyle(SOLID_FILL,cursecolor);
   bar(barleft, bartop, barright, barbottom);
   
   while (!got_event){   		
		if (endx-startx>0 && endy-starty>0){
			if (mouse_x>=startx && mouse_y>=starty
			&& mouse_x<=endx && mouse_y<=endy){
			/*draw_prompt_box(1);
			outtext("cursor in rectangle");*/
				if (inside_rect==0){
					XDefineCursor(D,W,leftCursor);
					inside_rect=1;
				}
			}
			else if (inside_rect==1){
				XDefineCursor(D,W,rightCursor);
				inside_rect=0;
			}
		}

		if (XCheckWindowEvent(D,W,
			PointerMotionMask|KeyPressMask|ButtonPressMask|
			StructureNotifyMask | ExposureMask, &Event)){
		
			switch (Event.type)
			{	
				case MotionNotify:
					mouse_x=Event.xmotion.x;
					mouse_y=Event.xmotion.y;
					/* show co-ordinates*/
					/*sprintf(textb[0],"x=%d y=%d",mouse_x,mouse_y);
					draw_hint_box(0,textb[0],500);*/
					break;
				
				case ButtonPress:
					mouse_x=Event.xbutton.x;
					mouse_y=Event.xbutton.y;
					/*left button*/
					if (Event.xbutton.button==1){                
						button='l'; /*left mouse button pressed*/
					}
					/*right button*/
					else if (Event.xbutton.button==3){
						button='r'; /*right mouse button pressed*/
					}
					got_event = 1;
					break;
				
				case KeyPress:
					button='k';
					got_event = 1;
					break;
				
				case ConfigureNotify:
					/*first, erase the cursor if it is showing*/
					if (cursor_visible == 1)
		 				bar(barleft, bartop, barright, barbottom);
		 						 			                                        /*now handle the window resize*/
					resize_window();
					got_event = 1;
					break;
				
				case Expose:
					/*Do nothing*/
					break;
				
				default:
				/*Do nothing*/
			}	
		}		/*if got event*/
		
		last_flash ++;
		
		/*Flash the damn cursor*/
		if (last_flash == kCursorFlash)
		{
			bar(barleft, bartop, barright, barbottom);
			cursor_visible = ! cursor_visible;
			last_flash = 0;
		}
	
	}		/*While loop*/
	
	if (cursor_visible == 1)
		 bar(barleft, bartop, barright, barbottom);
	
	XSetFunction(D,Gc,GXcopy);
	
	setfillstyle(SOLID_FILL,black);
	 
	moverel(0,-vgay(4));
	/*free(existimage);
	free(curseimage);  */
	inside_rect=0;
}

/************************ input data  ************************************/
signed short input_string(char stringlength, char stringtype){    
 signed short incount=0,backwidth; 
 signed short tempx,tempy;
 unsigned char test,cursecolor;

 /*if (bground=='w') cursecolor=green;
   else if (bground=='b') cursecolor=lightmagenta;*/
   cursecolor=green;
   while(incount < 1024){
      start:  
         flashing_cursor(0,0,0,0,0,-1,CWidth,1+CHeight / 2,cursecolor);
            
         test=keycheck(incount);
         /*show keypress info*/
         /*
         tempx=getx;
         tempy=gety;
         xbox=memory_box(0);
         moveto(xbox,2);
         sprintf(textb[0],"key =%d=%c",test);
         outtext(textb[0]);
         moveto(tempx,tempy);
	 */
         if (test=='@'){  /*printout with @ key*/
            tempx=getx;
            tempy=gety;
            printimage();
            goto start;
            moveto(tempx,tempy); 
         }
         if (test=='q' && incount==0){
	    is[0]='q';
	    return(0);          /*to stepback in setup*/
         }
         /*arrows:128+  75=left,77=right,72=up,80=down*/
         if (stringtype==-1 && incount==0 &&
                 (test==LeftArrow||test==RightArrow||
			 test==UpArrow||test== DownArrow)){	    
            is[0]=test;
	       return(0);            
         }
         
         if (test==13){
            is[incount]=13;
            break;
	 	}
         /*arrows to terminate input only if stringtype==-1*/
         if (stringtype==-1 && (test==LeftArrow||test==RightArrow||
	    test==UpArrow||test==DownArrow)){  /*arrows*/
	    is[incount]=13;
	    is[20]=test;
	    break;
         }
         /*back space*/
         else if (test==8 &&  incount>0){      
             if (fonttype==0) backwidth=CWidth;
             else  backwidth=XTextWidth(propfont,is+incount-1,1);
             /*is[incount-1]=0;*/
             moverel(-backwidth,0); 
	     	setfillstyle(SOLID_FILL,black);
             bar(getx,gety,getx+backwidth,gety+CHeight);
             /*XFillRectangle(D,W,Gc,getx,gety,CWidth,CHeight);*/
             
             incount--; 
         }          
         else if (stringtype==1 && incount<stringlength) {  
             /*test for digit*/  
            if (isdigit(test) || test=='.' || test=='-' ){ 
               /*XSetForeground(D,Gc,white);*/
               sprintf(textb[0],"%c", test);
               outtext(textb[0]);
               is[incount]=test;
               incount++;
	    }
         } 
         else if (stringtype<1 && incount<stringlength){ 
            /* test for any printing character*/ 
            if ( isalpha(test) || 
                    isdigit(test) || test=='.' || test=='-'
                     || test=='_' || test=='?' ){ 
               /*XSetForeground(D,Gc,white);*/
               sprintf(textb[0],"%c",test);
               outtext(textb[0]);
               is[incount]=test;
               incount++;
	    }
         } 
         XFlush(D);
  }  
  return(incount);
}




