/************************* save_load_image ****************************/
#include "edecfunc.h"

#if (__BORC__)
   #include <dir.h>
   #include <direct.h>
#elif (__WATCOM__)
   #include <sys\types.h>
#elif (__UNIX__)
   #include <fcntl.h>
   #include <dirent.h>
   #include <sys/dirent.h>
#endif
/************** select filename, drive, dir ***************************/
char select_filename(char *load_save,char *title,
			  char *extention,char *defname){
 unsigned short xbox,leftbox,topbox;
 char len;

  get_prompt_box(0,3); /*get the prompt box with basin data*/

 startfilename:
# if (__BORC__)
     getcurdir(0,old_dir);
# elif (__BORC__||__WATCOM__)
     getcwd(path,81);
# endif
  
  sprintf(textb[0],
     "%s %s-filename (no ext) %s will be added",
					 load_save,title,extention+1);
# if (__BORC__||__WATCOM__)
     sprintf(textb[1],"(change: drive-1, dir-2) %s:", path);
# endif
  sprintf(textb[2],"list-?, quit-q, default %s:",defname);

  xbox=draw_prompt_box(3);
  outtext(textb[0]);
  moveto(xbox,gety+CHeight);
# if (__BORC__||__WATCOM__)
     outtext(textb[1]);
# endif
  moveto(xbox,gety+CHeight);
  myouttext(textb[2]);
  len=input_string(8,0);

# if (__BORC__)
     if (is[0]=='1' || is[0]=='2'){
	change_drive_dir(is[0]);
	goto startfilename;
     }
# elif (__WATCOM__)
     if (is[0]=='d' && is[1]==13){
	change_drive_dir(is[0]);
	goto startfilename;
     }
# endif

  if (is[0]=='?'){
	leftbox=Maxx-vgax(75);
	topbox=vgay(40);
	len=select_list_files(extention,leftbox,topbox);
	if (len==0) goto startfilename;
	else{
		/*sprintf(filename,"%s%s",is,extention+1);*/
		memcpy(filename,is,len);
		memcpy(filename+len,extention+1,4);
		filename[len+4]='\0';
	}
  }
  else if (is[0]=='q'){
	/*restore basin data in prompt box*/
	putimage(Maxx/2,2,boximage_prompt[0],COPY_PUT);
	freeimage(boximage_prompt[0]);
	return('q');
  }
  else if (is[0]==13 || isdigit(is[0]))
			 sprintf(filename,"%s%s",defname,extention+1);
  else{
	memcpy(filename,is,len);
	memcpy(filename+len,extention+1,4);
	filename[len+4]='\0';
  }

  /*confirm filename*/
  moveto(xbox,gety);
  setfillstyle(SOLID_FILL,black);
  bar(getx,gety+vgay(2),Maxx-vgax(3),gety+CHeight+vgay(2));
  sprintf(textb[0],"filename=%s",filename);
  outtext(textb[0]);
  if (memcmp(load_save,"LOAD",4)==0 && memcmp(extention,"*.nat",5)==0)
		       outtext(" REVISE-q keepscreen-k cont-ret:");
  else outtext(" REVISE-q cont-ret");
  input_string(1,0);
  if (is[0]=='q') goto startfilename;

  putimage(Maxx/2,2,boximage_prompt[0],COPY_PUT);
  freeimage(boximage_prompt[0]);

  return(0);
}

/********************* save screen image, sept 93 ********************/
void load_save_exhaustive(char load_save){

  signed short tempx,tempy,fid;
  char file_ret,wrong_file=0;
  unsigned long state_space,memreq,filebytes;

  tempx=getx;
  tempy=gety;

  if (load_save=='l') sprintf(textb[4],"LOAD ");
  if (load_save=='s') sprintf(textb[4],"SAVE ");
  file_ret=select_filename(textb[4],"EXHAUSTIVE","*.exh","my_exhau");

  if (file_ret=='q'){
	moveto(tempx,tempy);
	is[0]='q';
	return;
  }
  state_space=(unsigned long)(pow(2,(double)lineL));
  memreq=state_space*bytesL*sizeof(char);

  if (load_save=='l'){
#    if (__BORC__||__WATCOM__)
        fid=open(filename,O_RDWR|O_BINARY);
#    elif (__UNIX__)
        fid=open(filename,O_RDWR);
#    endif
     filebytes= filelength(fid);
     if (fid != -1){
	if (filebytes!=memreq){
	   sprintf(textb[1],"filelength=%lu != bufreq=%lu",filebytes,memreq);
	   wrong_file=1;
	   fid=-1;
	}
     }
  }
  if (load_save=='s'){
#    if (__BORC__||__WATCOM__)	      
        fid=open(filename,O_RDWR|O_CREAT|O_TRUNC|O_BINARY,
  					 S_IREAD|S_IWRITE);
#    elif (__UNIX__)
         fid=open(filename,O_RDWR|O_CREAT|O_TRUNC,
  					 S_IREAD|S_IWRITE);  
#    endif 
  }
  if (fid==-1 || (filebytes!=memreq && load_save=='l')){
	draw_prompt_box(1);
	if (wrong_file==1){
	   sprintf(textb[0],"%s (wrong file) cont-ret",textb[1]);
	}
	else{
#          if (__BORC__||__WATCOM__)	
	      sprintf(textb[0],"%s, cont-ret",sys_errlist[errno]);
#          elif (__UNIX__)
              sprintf(textb[0],"%s, file error, cont-ret",filename);
#          endif
	}
	outtext(textb[0]);
	input_string(1,0);
	is[0]='q';
	close(fid);
	return;
  }
  if (load_save=='s') write(fid,exh_pairs,memreq);
  if (load_save=='l') read(fid,exh_pairs,memreq);

  close(fid);
  moveto(tempx,tempy);
}

/********************* save screen image, sept 93 ********************/
unsigned short load_save_nhoodmix(char load_save){

  signed short tempx,tempy,fid;
  char file_ret;
  unsigned short memreq,filebytes;

  tempx=getx;
  tempy=gety;

  if (load_save=='l') sprintf(textb[4],"LOAD ");
  if (load_save=='s') sprintf(textb[4],"SAVE ");  
  file_ret=select_filename(textb[4],
                  "N'HOOD MIX","*.mix","my_mix"); 
  if (file_ret=='q'){
	moveto(tempx,tempy);
	is[0]='q';
	return(0);
  }
  memreq=lineL*sizeof(char);

  if (load_save=='l' || load_save=='L'){
#    if (__BORC__||__WATCOM__)	
        fid=open(filename,O_RDWR|O_BINARY);
#    elif (__UNIX__)
        fid=open(filename,O_RDWR);
#    endif
     filebytes= filelength(fid);
  }
  if (load_save=='s')
#    if (__BORC__||__WATCOM__)	
	 fid=open(filename,O_RDWR|O_CREAT|O_TRUNC|O_BINARY,
	                                        S_IREAD|S_IWRITE);
#    elif (__UNIX__)
         fid=open(filename,O_RDWR|O_CREAT|O_TRUNC,
	                                        S_IREAD|S_IWRITE);
#   endif

  if (fid==-1){
#    if (__BORC__||__WATCOM__)	
	sprintf(textb[0],"%s, cont-ret",sys_errlist[errno]);
#    elif (__UNIX__)
        sprintf(textb[0],"%s, file error",filename);
#    endif
        draw_prompt_box(1);
	outtext(textb[0]);
	input_string(1,0);
	is[0]='q';
	close(fid);
	return(0);
  }
  if (load_save=='s') write(fid,nhoodm,memreq);
  if (load_save=='l'){
     if (filebytes<=memreq) read(fid,nhoodm,filebytes);
     else read(fid,nhoodm,memreq);
  }
  
  close(fid);
  moveto(tempx,tempy);
  return(filebytes);
}

/**************** save subtree/basin/field *************************/
void save_data(char *buf){

  signed short tempx,tempy,fid;

  tempx=getx;
  tempy=gety;
# if (__BORC__||__WATCOM__)	
     if ((fid=open(filename_data,O_RDWR|O_CREAT| O_APPEND|O_TEXT,
		                        S_IREAD|S_IWRITE))==-1){
     sprintf(textb[0],"%s, RETURN-continue",sys_errlist[errno]);
# elif (__UNIX__)
     if ((fid=open(filename_data,
                O_RDWR|O_CREAT|O_APPEND,S_IREAD|S_IWRITE))==-1){
        sprintf(textb[0],"%s, file error, RETURN-continue",filename);
# endif	
	draw_prompt_box(1);
	outtext(textb[0]);
	input_string(1,0);
	erase_prompt_box(1);
	close(fid);
	moveto(tempx,tempy);
	return;
  }
  write(fid, buf, strlen(buf));
                          
  close(fid);
  moveto(tempx,tempy);
}

/**************** save subtree/basin/field *************************/
void save_binary_data(unsigned char *buf,unsigned long sizeofbuf){

  signed short tempx,tempy,fid;

  tempx=getx;
  tempy=gety;
# if (__BORC__||__WATCOM__)	
     if ((fid=open(filename_data,
		O_RDWR|O_CREAT| O_APPEND|O_BINARY,
		                S_IREAD|S_IWRITE))==-1){
	sprintf(textb[0],"%s, RETURN-continue",sys_errlist[errno]);
# elif (__UNIX__)
     if ((fid=open(filename_data,					                   O_RDWR|O_CREAT|O_APPEND,S_IREAD|S_IWRITE))==-1){
     sprintf(textb[0],"%s, file error, RETURN-continue",	   
                                          filename_data);
# endif
	draw_prompt_box(1);
	outtext(textb[0]);
	input_string(1,0);
	erase_prompt_box(1);
	close(fid);
	moveto(tempx,tempy);
	return;
  }
  write(fid, buf, sizeofbuf);
                          
  close(fid);
  moveto(tempx,tempy);
}


/********************* save screen image, sept 93 ********************/
void save_screen(void){

  signed short tempx,tempy,
      slice,
      fid,
      divscreeny,yup,
      thisMaxx,thisMaxy;
  char sliceno,
       file_ret;

  unsigned char *ypix,*cpix,*repeat,*buf,
		zz,i,z,
		pixcount,
		startpix, /*no of color groups*/
		pxc;
  unsigned long bi; /*buffer index*/
# if __UNIX__
     XImage *ScreenImage;
     Pixmap *offscreen_pixmap;
     setviewport(0,0,Maxx,WinMaxy,1);
     /*allocate mem for pixmap*/
     if ((offscreen_pixmap = 
          (Pixmap *)malloc(sizeof(Pixmap *))) == NULL)
		outof_memory("Pixmap pointer");
     getimage(0,0,Maxx+1,WinMaxy+1,offscreen_pixmap);
     ScreenImage=XGetImage(D,*offscreen_pixmap,
                0,0,Maxx+1,WinMaxy+1,AllPlanes,XYPixmap);
# elif __BORC__||__UNIX__
     setviewport(0,0,Maxx,getmaxy(),1);
# endif

  tempx=getx;
  tempy=gety;

  file_ret=select_filename("SAVE","SCREEN","*.nat","myimage");

  if (file_ret=='q'){
#       if (__UNIX__)
           freeimage(offscreen_pixmap);
           free(offscreen_pixmap);
           free(ScreenImage);
#       endif
        setviewport(0,0,Maxx,Maxy,1);
	moveto(tempx,tempy);
	is[0]='q';
	return;
  }

  sprintf(textb[0],"ypix");
  if ((ypix=(unsigned char *)calloc(241,sizeof(unsigned char)))
				  ==NULL) outof_memory(textb[0]);
  sprintf(textb[0],"cpix");
  if ((cpix=(unsigned char *)calloc(241,sizeof(unsigned char)))
				  ==NULL) outof_memory(textb[0]);
  sprintf(textb[0],"repeat");
  if ((repeat=(unsigned char *)calloc(241,sizeof(unsigned char)))
				  ==NULL) outof_memory(textb[0]);
  /*max buffer to store bytes*/
  sprintf(textb[0],"buf");
# if (__BORC__)
     if ((buf=(unsigned char *)calloc(65534,sizeof(unsigned char)))
				  ==NULL) outof_memory(textb[0]);
# elif (__WATCOM__||__UNIX__)
     if ((buf=(unsigned char *)calloc(65534*2,sizeof(unsigned char)))
				  ==NULL) outof_memory(textb[0]);
# endif
  /*memory_box(1);*/
# if (__BORC__||__WATCOM__)	
     if ((fid =open(filename,O_RDWR|O_CREAT|O_TRUNC|O_BINARY,
                                     S_IREAD|S_IWRITE))==-1){
	sprintf(textb[0],"%s, RETURN-continue",sys_errlist[errno]);
# elif (__UNIX__)
     if ((fid =open(filename,O_RDWR|O_CREAT|O_TRUNC,
                                     S_IREAD|S_IWRITE))==-1){
	sprintf(textb[0],"%s, file error, RETURN-continue",filename);
# endif

	draw_prompt_box(1);
	outtext(textb[0]);
	input_string(1,0);
	erase_prompt_box(1);

	free(ypix);
	free(cpix);
	free(repeat);

	free(buf);

	close(fid);
#       if (__UNIX__)
           free(ScreenImage);
#       endif
	return;
  }
  if (!hires && getmaxy()<=479){
	sliceno=4; /*4 slices for 640 X 480 VGA screen, divscreeny=120*/
	thisMaxx=639;
	thisMaxy=479;
	buf[0]='v';
	write(fid,buf,1); /*first char in file is screen type*/
  }
  else {
	sliceno=8;/*8 slices for 1024 X 768 IBM8514 screen, divscreeny=96*/
	thisMaxx=1023;
	thisMaxy=767;
	buf[0]='s';
	write(fid,buf,1); /*first char in file is screen type*/
  }

  /*divide screen horizontally into sliceno slices*/
  divscreeny=(thisMaxy+1)/sliceno;
  /*setviewport(0, 0, getmaxx(), getmaxy(), 0);*/

  for (i=0;i<=sliceno-1;i++){
     bi=2; /*buffer index: 0&1=buffsize*/
     yup=divscreeny*i;
     for (slice=0;slice<=thisMaxx;slice++){ /*scan across->*/
	startpix=0;
	pixcount=0;
	for (zz=0;zz<=divscreeny-1;zz++){
#           if (__BORC__||__WATCOM__)
	       pxc=getpixel(slice,zz+yup);
#           elif (__UNIX__)
               pxc=(unsigned char) XGetPixel(ScreenImage,slice,zz+yup);
#           endif
	    /*ignore background*/
	    if (pxc==black){
		startpix=0;
		continue;
	    }
	    if (startpix==1){
		if (cpix[pixcount]==pxc){
			repeat[pixcount]+=1;
			continue;
		}
		else startpix=0;
	    }
	    pixcount++;  /*max divscreeny*/
	    ypix[pixcount]=zz;  /*start y co-ord*/
	    repeat[pixcount]=0; /*set repeat to 0*/
	    cpix[pixcount]=pxc; /*color*/
	    startpix=1;
	}
	buf[bi]=pixcount;
	bi++;
	/*if the whole slice was black*/
	if (pixcount==0) continue;
	/*pixcount=no of continuous color segments*/
	for (z=1;z<=pixcount;z++){
		buf[bi]=ypix[z];
		bi++;
		if (repeat[z]==0) buf[bi-1]+=128;/*set highest bit on, ypix*/
		else{
			buf[bi]=repeat[z];
			bi++;
		}
		buf[bi]=cpix[z];
		bi++;
	}
     }
     /*save buf size in first 2 bytes*/
     buf[0]=(unsigned char)(bi/256);
     buf[1]=(unsigned char)(bi%256);
     write(fid, buf, bi);
  }
  close(fid);

  free(ypix);
  free(cpix);
  free(repeat);
  free(buf);
  /*memory_box(1);*/
  # if __UNIX__
     freeimage(offscreen_pixmap);
     free(offscreen_pixmap);
     free(ScreenImage);
# endif

  setviewport(0, 0, Maxx, Maxy, 1);
  moveto(tempx,tempy);

}

/********************* load screen image, sept 93 ********************/
void load_screen(void){

  signed short tempx,tempy,
      slice,
      fid,
      divscreeny,yup,
      thisMaxx,thisMaxy;
  char keepscreen=0,
       sliceno,file_ret;
  unsigned char ypix,cpix,repeat,*buf,
		i,zz,z,
		pixcount;
 
  unsigned long bi, /*buffer index*/
		maxbuf; /*buffer size*/

# if (__UNIX__)
     unsigned char tempcolor=nowcolor;     
# endif

  tempx=getx;
  tempy=gety;
 
  file_ret=select_filename("LOAD","SCREEN","*.nat","myimage");

  if (file_ret=='q'){
	moveto(tempx,tempy);
	is[0]='q';
	return;
  }

  if (is[0]=='k') keepscreen=1;
# if (__BORC__||__WATCOM__)
    if ((fid =open(filename,O_RDWR|O_BINARY)) == -1){
	sprintf(textb[0],"%s, RETURN-continue",sys_errlist[errno]);
# elif (__UNIX__)
    if ((fid =open(filename,O_RDWR)) == -1){
	sprintf(textb[0],"%s, file error, RETURN-continue",filename);
# endif
	draw_prompt_box(1);
	outtext(textb[0]);
	input_string(1,0);
	erase_prompt_box(1);
	close(fid);
	moveto(tempx,tempy);
	return;
  }
  /*max buffer to store bytes*/
  sprintf(textb[0],"buf");
# if (__BORC__)
     if ((buf=(unsigned char *)calloc(65534,sizeof(unsigned char)))
					==NULL) outof_memory(textb[0]);
# elif (__WATCOM__||__UNIX__)
     if ((buf=(unsigned char *)calloc(65534*2,sizeof(unsigned char)))
					==NULL) outof_memory(textb[0]);
# endif
  read(fid,buf,1); /*first char in file is screen type*/
  if (buf[0]=='v'){
	sliceno=4; /*4 slices for 640 X 480 VGA screen, divscreeny=120*/
	thisMaxx=639;
	thisMaxy=479;
  }
  else if  (buf[0]=='s'){
	sliceno=8;/*8 slices for 1024 X 768 IBM8514 screen, divscreeny=96*/
	thisMaxx=1023;
	thisMaxy=767;
  }
  else{
	close(fid);
#       if (__BORC__||__WATCOM__)
	   fid =open(filename,O_RDWR|O_BINARY);
#       elif (__UNIX__)
           fid =open(filename,O_RDWR); 
#       endif
	sliceno=4; /*assume VGA*/
	thisMaxx=639;
	thisMaxy=479;
  }
  if (keepscreen==0) cleardevice(); 
  setviewport(0, 0, getmaxx(), getmaxy(), 0);

  /*divide screen horizontally into 4 slices*/
  divscreeny=(thisMaxy+1)/sliceno;
  for (i=0;i<=sliceno-1;i++){
     read(fid,buf,2); /*first 2 bytes give size-2 to be read from buf*/
     maxbuf=(unsigned long)buf[0]*256+(unsigned long)buf[1];
     read(fid,buf,maxbuf-2); /*read correct no of bytes from buf*/
     bi=0;
     yup=divscreeny*i;
     for (slice=0;slice<=thisMaxx;slice++){
	pixcount=buf[bi];
	bi++;
	if (pixcount==0) continue;
	for (z=1;z<=pixcount;z++){
	    ypix=buf[bi];
	    bi++;
	    if (ypix>=128){  /*if high bit in ypix=1, no repeats*/
		ypix-=128;   /*lower bits give +co-ord*/
		repeat=0;
	    }
	    else{
		repeat=buf[bi];
		bi++;
	    }
	    cpix=buf[bi];
	    bi++;

	    for (zz=0;zz<=repeat;zz++){
#               if (__BORC__||__WATCOM__)
		   putpixel(slice,ypix+zz+yup,cpix);
#               elif (__UNIX__)
                   XSetForeground(D,Gc,(unsigned long)cpix);
                   XDrawPoint(D, W, Gc,slice,ypix+zz+yup);
#               endif
	    }
	}       
    }
  }  
  free(buf);
  close(fid);
  setviewport(0, 0, Maxx, Maxy, 1);  
# if (__UNIX__)
     setcolor(tempcolor);  
# endif
  moveto(tempx,tempy);
}

/********************* save rule or seed, dec 93 ********************/
unsigned char load_save_wrs
	 (char load_save,char* wrsbuf,char wrstype){ /*or seed*/

  signed short xbox,tempx,tempy,
	       fid,rulebytes,thisi2d,thisj2d;
  unsigned short  poss,z,thislineL,thisbytesL,wiringposs,
		  starti,startj,ii,jj,thisii,thisjj;
  char file_ret,
       bytes_lineL, /*bytes requires for lineL, 1 if<=256, 2 if<256*/
       bytes_thislineL,
       buf0nhood; /*nhood found in buf[0]*/
  unsigned char wire,*buf;		
  unsigned long buffreq,thisbuffreq,buffindex,filebytes;

  tempx=getx;
  tempy=gety;
  rulebytes=(signed short)ceil(pow(2,(double)nhood)/8);

  if (load_save=='l') sprintf(textb[4],"LOAD ");
  if (load_save=='s') sprintf(textb[4],"SAVE ");
  /*single rule=0, wiring only=1, rulescheme only=2, wiring-rule scheme=3*/
  if (wrstype==0)
     file_ret=select_filename(textb[4],"SINGLE RULE","*.rul","myrule");
  else if (wrstype==1)
     file_ret=select_filename(textb[4],"WIRING ONLY","*.w_s","my_wso");
  else if (wrstype==2)
     file_ret=select_filename(textb[4],"RULE SCHEME ONLY","*.r_s","my_rso");
  else if (wrstype==3)
     file_ret=select_filename(textb[4],"WIRING-RULE SCHEME","*.wrs","my_wrs");
  /*SEED*/
  else if (wrstype=='s')
     file_ret=select_filename(textb[4],"SEED","*.eed","myseed");
  if (file_ret=='q'){
	moveto(tempx,tempy);
	is[0]='q';
	return(0);
  }
  /*byte 0 =nhood
    bytes 1,2 =lineL, max=1+256(9+128)=35074
    bytes 3,5 = i2d,j2d for twod otherwise 0,0*/
  if (lineL<=256) bytes_lineL=1;
  else bytes_lineL=2;
  if (wrstype==0) buffreq=1+rulebytes;                      /*one rule     */
  else if (wrstype==1) buffreq=5+lineL*(bytes_lineL*nhood); /*wiring scheme*/
  else if (wrstype==2) buffreq=5+lineL*rulebytes;           /*rule scheme  */
  else if (wrstype==3)                                      /*wr scheme    */
		       buffreq=5+lineL*(bytes_lineL*nhood+rulebytes);
  /*bytes 0,1 =lineL, bytes 2,3 = i2d,j2d for twod otherwise 0,0*/
  else if (wrstype=='s') buffreq=4+bytesL;
  /*buffer required to store bytes*/
  sprintf(textb[0],"buf, buffreq=%lu, calloc failed",buffreq);
  if ((buf=(unsigned char *)calloc(buffreq,sizeof(unsigned char)))
				 ==NULL) outof_memory(textb[0]);
  /*memory_box(1);*/
  if (load_save=='l'){
#    if (__BORC__||__WATCOM__)
        fid=open(filename,O_RDWR|O_BINARY);
#    elif (__UNIX__)
         fid=open(filename,O_RDWR);
#    endif
     if (fid==-1){
#       if (__BORC__||__WATCOM__)
	   sprintf(textb[0],"%s, RETURN-continue",sys_errlist[errno]);
#       elif (__UNIX__)
           sprintf(textb[0],"%s, file error, RETURN-continue",filename);
#       endif
	draw_prompt_box(1);
	outtext(textb[0]);
	input_string(1,0);
	erase_prompt_box(1);
	close(fid);
	free(buf);
	is[0]='q'; /*file not found*/
	moveto(tempx,tempy);
	return(0);
     }

     filebytes= filelength(fid);
     if (wrstype=='s'){
	if (filebytes>buffreq){
	   sprintf(textb[0],"filelength=%lu > bufreq=%lu",
					    filebytes,buffreq);
	   if ((buf=(unsigned char*)
		realloc(buf,filebytes*sizeof(unsigned char)))
					==NULL) outof_memory(textb[0]);
	}
     }
     else {
	if (filebytes!=buffreq){
	   sprintf(textb[0],"filelength=%lu != bufreq=%lu",
					    filebytes,buffreq);
	   if ((buf=(unsigned char*)
		realloc(buf,filebytes*sizeof(unsigned char)))
					==NULL) outof_memory(textb[0]);
	}
     }
  }
  if (load_save=='s')
#    if (__BORC__||__WATCOM__)
	 fid=open(filename,O_RDWR|O_CREAT|O_TRUNC|O_BINARY,
	                                        S_IREAD|S_IWRITE);
#    elif (__UNIX__)
         fid=open(filename,O_RDWR|O_CREAT|O_TRUNC,S_IREAD|S_IWRITE);
#    endif
  if (fid==-1){
#    if (__BORC__||__WATCOM__)
	sprintf(textb[0],"%s, continue-ret",sys_errlist[errno]);
#    elif (__UNIX__)
        sprintf(textb[0],"%s, file error, continue-ret",filename);
#    endif
	draw_prompt_box(1);
	outtext(textb[0]);
	input_string(1,0);
	is[0]='q';
	close(fid);
	free(buf);
	return(0);
  }

  /*SAVE seed, rule, wiring scheme, rule scheme, or wiring/rule scheme*/
  if (load_save=='s'){
     /*seed*/
     if (wrstype=='s'){
	buf[0]=(unsigned char)(lineL & 0x00ff); /*low byte */
	buf[1]=(unsigned char)(lineL >> 8);     /*high byte*/
	if (twod){
	   buf[2]=(unsigned char)i2d;
	   buf[3]=(unsigned char)j2d;
	}
	memcpy(buf+4,wrsbuf,bytesL);
	write(fid, buf, 4+bytesL);

     }
     /*single rule=0,wiring only=1,rulescheme only=2,wiring-rule scheme=3*/
     else{
	buf[0]=nhood;
	if (wrstype==0){
	   memcpy(buf+1,wrsbuf,rulebytes);
	   write(fid, buf, 1+rulebytes);
	}
	else{
	   buf[1]=(unsigned char)(lineL & 0x00ff); /*low byte  */
	   buf[2]=(unsigned char)(lineL >> 8);     /*high byte */
	   if (twod){
	      buf[3]=(unsigned char)i2d;
	      buf[4]=(unsigned char)j2d;
	   }
	   buffindex=5;
	   for (poss=0;poss<=lineL-1;poss++){
	      if (wrstype==2 || wrstype==3){ /*write rule*/
		 memcpy(buf+buffindex,carule[poss],rulebytes);
		 buffindex+=rulebytes;
	      }
	      if (wrstype==1 || wrstype==3){ /*write wiring*/
		 for (wire=0;wire<=nhood-1;wire++){
		    if (lineL<=256){
		       buf[buffindex]=(unsigned char)wiring[poss][wire];
		       buffindex+=1;
		    }
		    else{
		       buf[buffindex]=(unsigned char)
			      (wiring[poss][wire] & 0x00ff); /*low byte */
		       buf[buffindex+1]=(unsigned char)
				 (wiring[poss][wire] >> 8);  /*high byte*/
		       buffindex+=2;
		    }
		 }
	      }
	   }
	   write(fid, buf, buffreq);
	}
     }
  }
  /*LOAD seed, rule, wiring scheme, rule scheme, or wiring/rule scheme*/
  if (load_save=='l'){
     /*seed*/
     if (wrstype=='s'){
	read(fid,buf,4);
	thislineL=buf[0]+(((unsigned short)buf[1])<<8);
	/*no of bytes required to contain thislineL bits*/
	thisbytesL=(unsigned short)ceil((double)thislineL/8);
	thisi2d=(signed short) buf[2];
	thisj2d=(signed short) buf[3];

	if (lineL>=thislineL){
	    read(fid,buf+4,thisbytesL);
	    if (twod && i2d>=thisi2d && j2d>=thisj2d && thisi2d!=0
			&& (i2d>thisi2d || j2d>thisj2d)){
		/*put smaller 2d file pattern somewhere on larger grid*/
		/*default centre*/
		starti=(i2d-thisi2d)/2;
		startj=(j2d-thisj2d)/2;

		if (i2d>=thisi2d && j2d>=thisj2d){
		   get_prompt_box(6,2);
		   sprintf(textb[0],
		     "2d:i=%d,j=%d, file:i=%d,j=%d, enter start coords",
				   i2d,j2d,thisi2d,thisj2d);
		   sprintf(textb[1],
		     "(default %d,%d, max %d,%d) i:",
			    starti,startj,i2d-thisi2d,j2d-thisj2d);
		   xbox=draw_prompt_box(2);
		   outtext(textb[0]);
		   moveto(xbox,gety+CHeight);
		   myouttext(textb[1]);

		   /*input_string(strlen(itoa(i2d-thisi2d,textb[2],10)),0);*/
		   sprintf(textb[2],"%d",i2d-thisi2d);
		   input_string(strlen(textb[2]),0);

		   if (is[0]==13);
		   else if (atoi(is)<=i2d-thisi2d && atoi(is)>-1)
						   starti=atoi(is);
		   sprintf(textb[1]," j:");
		   myouttext(textb[1]);
		   /*input_string(strlen(itoa(j2d-thisj2d,textb[2],10)),0);*/
		   sprintf(textb[2],"%d",j2d-thisj2d);
		   input_string(strlen(textb[2]),0);

		   if (is[0]==13);
		   else if (atoi(is)<=j2d-thisj2d && atoi(is)>-1)
						   startj=atoi(is);
		   putimage((signed short)((float)Maxx)/2,2,
				     boximage_prompt[6],COPY_PUT);
		   freeimage(boximage_prompt[6]);
		}
		ii=starti;
		jj=startj;

		for (z=0;z<=thislineL-1;z++){
		   set_bit(wrsbuf,ii+i2d*jj,get_bit(buf,32+z));
		   ii+=1;
		   if ((z+1)%thisi2d==0){
		      ii=starti;
		      jj+=1;
		   }
		}
	    }
	    else{
	       /*put smaller 1d file pattern somewhere on larger grid*/
	       /*default centre*/
	       if (lineL>thislineL){
		   starti=(lineL-thislineL)/2;
		   get_prompt_box(6,2);
		   sprintf(textb[0],
		     "1d:array length=%d, length file=%d, enter start poss",
						    lineL,thislineL);
		   sprintf(textb[1],
		     "(default %d, max %d):",starti,lineL-thislineL);
		   xbox=draw_prompt_box(2);
		   outtext(textb[0]);
		   moveto(xbox,gety+CHeight);
		   myouttext(textb[1]);

		   /*input_string(strlen(itoa(lineL-thislineL,textb[2],10)),0);*/
		   sprintf(textb[2],"%d",lineL-thislineL);
		   input_string(strlen(textb[2]),0);

		   if (is[0]==13);
		   else if (atoi(is)<=lineL-thislineL && atoi(is)>-1)
						     starti=atoi(is);
		   for (z=0;z<=thislineL-1;z++){
		     set_bit(wrsbuf,starti+z,get_bit(buf,32+z));
		   }
		   putimage((signed short)((float)Maxx)/2,2,
				     boximage_prompt[6],COPY_PUT);
		   freeimage(boximage_prompt[6]);
	       }
	       /*for equal size*/
	       else{
		  for (z=0;z<=thisbytesL;z++){
		     wrsbuf[z]=buf[z+4];
		  }
	       }
	    }
	}
	else{  /*file bigger*/
	    if (twod && i2d<=thisi2d && j2d<=thisj2d){
		read(fid,buf+4,filebytes-4);
		/*put centre of larger 2d file pattern on grid*/
		starti=(thisi2d-i2d)/2;
		ii=starti;
		jj=(thisj2d-j2d)/2;

		for (z=0;z<=lineL-1;z++){
		   set_bit(wrsbuf,z,get_bit(buf,32+ii+thisi2d*jj));
		   ii+=1;
		   if ((z+1)%i2d==0){
		      ii=starti;
		      jj+=1;
		   }
		}
	    }
	    else{
	       read(fid,buf+4,bytesL);
	       memcpy(wrsbuf,buf+4,bytesL);
	    }
	}
	buf0nhood=buf[0];
     }
     /*single rule=0,wiring only=1,rulescheme only=2,wiring-rule scheme=3*/
     else{
	read(fid,buf,1); /*first byte gives nhood size, read into buf*/
	buf0nhood=buf[0];
	if (secondpart==1){
	   /*dont accept diff nhood second part of prog*/
	   if (nhood!=buf0nhood){
		  free(buf);
		  close(fid);

		  /*memory_box(1);*/
		  moveto(tempx,tempy);
		  return(buf0nhood);
	   }
	}
	/*single rule*/
	if (wrstype==0){

	   if (rulemix ){
	      /*cant mix nhood size*/
	      if (nhood!=buf0nhood){
		  free(buf);
		  close(fid);

		  /*memory_box(1);*/
		  moveto(tempx,tempy);
		  return(buf0nhood);
	      }
	   }
	   else {  /*one rule only*/
	      if (nhood!=buf0nhood && buf0nhood!=0){
		  free(nhoodm);
		  free_mem_wiring();
		  nhood=buf0nhood;
		  rulebytes=(signed short)ceil(pow(2,(double)nhood)/8);
		  free_mem_rule0();
		  free_mem_tcode0();
		  free_mem_all_0s_all_1s_rules();
		  sprintf(textb[0],"nhoodm");
		   if ((nhoodm=(char *)calloc(lineL,sizeof(char)))
				   ==NULL) outof_memory(textb[0]);
		  for (z=0; z<=lineL-1;z++) nhoodm[z]=nhood;
		  allocate_mem_rule0(nhood);
		  allocate_mem_tcode0(nhood);
		  allocate_mem_all_0s_all_1s_rules(nhood);
		  allocate_mem_wiring();
		  wire_up_network();
	      }
	   }
	   /*read correct no of bytes into buf*/
	   read(fid,buf+1,rulebytes);
	   if (rulemix) memcpy(wrsbuf,buf+1,rulebytes);
	   else memcpy(carule[0],buf+1,rulebytes);
	}
	else{
	   read(fid,buf+1,4);
	   thislineL=buf[1]+(((unsigned short)buf[2])<<8);
	   if (thislineL<=256) bytes_thislineL=1;
	   else bytes_thislineL=2;
	   thisi2d=(signed short) buf[3];
	   thisj2d=(signed short) buf[4];

	   /*nhood must be equal, but size can be smaller*/
	   if (buf0nhood!=nhood || thislineL>lineL){
		 free(buf);
		 close(fid);
		 draw_prompt_box(1);
		 if (buf0nhood!=nhood){
		   sprintf(textb[0],
			" net nhood %d not equal %d",
					      nhood,buf0nhood);
		   outtext(textb[0]);
		 }
		 if (thislineL>lineL){
		   sprintf(textb[1],
			" net size %d < %d",lineL,thislineL);
		   outtext(textb[0]);
		 }
		 /*memory_box(1);*/
		 input_string(0,1);
		 moveto(tempx,tempy);
		 erase_prompt_box(1);
		 return(buf0nhood);
	   }

	   /*wiring only=1, rulescheme only=2, wiring-rule scheme=3*/
	   else{

	      /*wiring scheme only*/
	      if (wrstype==1) thisbuffreq=
                         5+thislineL*(bytes_thislineL*nhood);
	      /*rule scheme only*/
	      if (wrstype==2) thisbuffreq=5+thislineL*rulebytes;
	      /*wiring-rule scheme*/
	      if (wrstype==3) thisbuffreq=
			 5+thislineL*(bytes_thislineL*nhood+rulebytes);
	      read(fid,buf+5,thisbuffreq-5);

	      buffindex=5;

	      /*for 2-D where file is smaller than array*/
	      if (lineL>thislineL && twod && i2d>=thisi2d && j2d>=thisj2d){
		 /*put smaller 2d file rule/wiring scheme somewhere
		   on larger grid, default centre*/
		 starti=(i2d-thisi2d)/2;
		 startj=(j2d-thisj2d)/2;

		 get_prompt_box(6,2);
		 sprintf(textb[0],
		     "2d:i=%d,j=%d, file:i=%d,j=%d, enter start coords",
				   i2d,j2d,thisi2d,thisj2d);
		 sprintf(textb[1],
		     "(default %d,%d, max %d,%d) i:",
			    starti,startj,i2d-thisi2d,j2d-thisj2d);
		 xbox=draw_prompt_box(2);
		 outtext(textb[0]);
		 moveto(xbox,gety+CHeight);
		 myouttext(textb[1]);
		 
		 /*input_string(strlen(itoa(i2d-thisi2d,textb[2],10)),0);*/
		 sprintf(textb[2],"%d",i2d-thisi2d);
		 input_string(strlen(textb[2]),0);

		 if (is[0]==13);
		 else if (atoi(is)<=i2d-thisi2d && atoi(is)>-1)
							 starti=atoi(is);
		 sprintf(textb[1]," j:");
		 myouttext(textb[1]);

		 /*input_string(strlen(itoa(j2d-thisj2d,textb[2],10)),0);*/
		 sprintf(textb[2],"%d",j2d-thisj2d);
		 input_string(strlen(textb[2]),0);

		 if (is[0]==13);
		 else if (atoi(is)<=j2d-thisj2d && atoi(is)>-1)
							 startj=atoi(is);
		 putimage((signed short)((float)Maxx)/2,2,
				     boximage_prompt[6],COPY_PUT);
		 freeimage(boximage_prompt[6]);

		 ii=starti;
		 jj=startj;

		 for (z=0;z<=thislineL-1;z++){
		    poss=ii+i2d*jj;

		    if (wrstype==2 || wrstype==3){
		       memcpy(carule[poss],buf+buffindex,rulebytes);
		       buffindex+=rulebytes;
		    }
		    if (wrstype==1 || wrstype==3){
		       for (wire=0;wire<=nhood-1;wire++){
			  if (bytes_thislineL==1)
			     wiringposs=buf[buffindex];
			  else if (bytes_thislineL==2)
			     wiringposs=buf[buffindex]+
			       (((unsigned short)buf[buffindex+1])<<8);
			  thisii=wiringposs%thisj2d;
			  thisjj=wiringposs/thisi2d;

			  wiringposs=starti+thisii+(i2d*(startj+thisjj));

			  wiring[poss][wire]=wiringposs;
			  buffindex+=bytes_thislineL;
		       }
		    }
		    ii+=1;

		    if ((z+1)%thisi2d==0){
		       ii=starti;
		       jj+=1;
		    }
		 }
	      }
	      else{
		 starti=0;
		 /*put smaller 1d file rule/wiring scheme somewhere
		   on larger line, default centre*/
		 if (lineL>thislineL){
		    starti=(lineL-thislineL)/2;
		    get_prompt_box(6,2);
		    sprintf(textb[0],
		     "1d:array length=%d, length file=%d, enter start poss",
						    lineL,thislineL);
		    sprintf(textb[1],
		     "(default %d, max %d):",starti,lineL-thislineL);
		    xbox=draw_prompt_box(2);
		    outtext(textb[0]);
		    moveto(xbox,gety+CHeight);
		    myouttext(textb[1]);

		    /*input_string(strlen(itoa(lineL-thislineL,textb[2],10)),0);*/
		    sprintf(textb[2],"%d",lineL-thislineL);
		    input_string(strlen(textb[2]),0);

		    if (is[0]==13);
		    else if (atoi(is)<=lineL-thislineL && atoi(is)>-1)
						     starti=atoi(is);
		    for (z=0;z<=thislineL-1;z++){
		       set_bit(wrsbuf,starti+z,get_bit(buf,32+z));
		    }
		    putimage((signed short)((float)Maxx)/2,2,
				     boximage_prompt[6],COPY_PUT);
		    freeimage(boximage_prompt[6]);
		 }
		 for (poss=0;poss<=thislineL-1;poss++){
		    if (wrstype==2 || wrstype==3){
		       memcpy(carule[poss+starti],buf+buffindex,rulebytes);
		       buffindex+=rulebytes;
		    }
		    if (wrstype==1 || wrstype==3){
		       for (wire=0;wire<=nhood-1;wire++){
			  if (bytes_thislineL==1)
			      wiringposs=buf[buffindex];
			  else if (bytes_thislineL==2)
			      wiringposs=buf[buffindex]+
				 (((unsigned short)buf[buffindex+1])<<8);
			  wiring[poss+starti][wire]=wiringposs+starti;
			  buffindex+=bytes_thislineL;
		       }
		    }
		 }
	      }
	   }
	}
     }
  }
  close(fid);
  free(buf);
  /*memory_box(1);*/
  moveto(tempx,tempy);

  return(buf0nhood);
}

/********************* save last rule, dec 93 ********************/
void save_last_rule(char* rule,char thisnhood){
  signed short tempx,tempy,
               fid,
               rulebytes;
  unsigned char *buf;

  tempx=getx;
  tempy=gety;
  rulebytes=(signed short)ceil(pow(2,(double)thisnhood)/8);

  /*itoa(thisnhood, textb[0], 10);*/
  sprintf(textb[0],"%d",thisnhood);
  memcpy(filename,"last",4);
  memcpy(filename+4,textb[0],1);
  memcpy(filename+5,".rul\0",5);

  /*max buffer to store bytes*/
  sprintf(textb[0],"buf");
  if ((buf=(unsigned char *)calloc(1+rulebytes,sizeof(unsigned char)))
					==NULL) outof_memory(textb[0]);
  /*memory_box(1);*/
# if (__BORC__||__WATCOM__)
  if ((fid =open(filename,O_RDWR|O_CREAT|O_TRUNC|O_BINARY,
                                     S_IREAD|S_IWRITE))==-1){
	sprintf(textb[0],"%s, %s, RETURN-continue",
	                          sys_errlist[errno],filename);
# elif (__UNIX__)
  if ((fid =open(filename,O_RDWR|O_CREAT|O_TRUNC,S_IREAD|S_IWRITE))==-1){
	sprintf(textb[0],"%s, file error, RETURN-continue",filename);
# endif

	draw_prompt_box(1);
	outtext(textb[0]);
	input_string(1,0);
	is[0]='q';
	close(fid);
	free(buf);
	return;
	/*perror("Error:");*/
  }
  buf[0]=thisnhood;
  memcpy(buf+1,rule,rulebytes);
  write(fid, buf, 1+rulebytes);
  close(fid);
  free(buf);
  /*memory_box(1);*/
  moveto(tempx,tempy);
}

/********************* load last rule, dec 93 ********************/
char load_last_rule(char* rule,char thisnhood){
  signed short tempx,tempy,fid,rulebytes; 
  unsigned char *buf,
		buf0nhood; /*nhood founf in buf[0]*/

  tempx=getx;
  tempy=gety;

  /*itoa(thisnhood, textb[0], 10);*/
  sprintf(textb[0],"%d",thisnhood);
  memcpy(filename,"last",4);
  memcpy(filename+4,textb[0],1);
  memcpy(filename+5,".rul",4);
  /*max buffer to store bytes, for max nhoood=9*/
  sprintf(textb[0],"buf");
  if ((buf=(unsigned char *)calloc(1+(signed short)ceil(pow(2,(double)9)/8),
		     sizeof(unsigned char)))==NULL) outof_memory(textb[0]);
  /*memory_box(1);*/
# if (__BORC__||__WATCOM__)
     if ((fid =open(filename,O_RDWR|O_BINARY)) == -1){ 
	sprintf(textb[0],"%s, %s, RETURN-continue",
	                   sys_errlist[errno],filename);
# elif (__UNIX__)
     if ((fid =open(filename,O_RDWR)) == -1){ /*perror("Error:");*/
	sprintf(textb[0],"%s, file error, RETURN-continue",filename);
# endif
	draw_prompt_box(1);
	outtext(textb[0]);
	input_string(1,0);
	is[0]='q';
	free(buf);
	close(fid);
	return(0);
  }
  read(fid,buf,1); /*first byte gives nhood size, read into buf*/
  buf0nhood=buf[0]; /*nhood founf in buf[0]*/
  rulebytes=(signed short)ceil(pow(2,(double)thisnhood)/8);
  /*read correct no of bytes into buf*/
  read(fid,buf+1,rulebytes);
  memcpy(rule,buf+1,rulebytes);
  free(buf);
  close(fid);
  moveto(tempx,tempy);
  return(buf0nhood);
}

/********************* load rule, dec 93 ********************/
void load_glider_rule(char* rule,signed short fileno){
  signed short tempx,tempy,
               fid,rulebytes,tablemax;
  char buf0nhood; /*nhood found in buf[0]*/
  unsigned char *buf;
		

  tempx=getx;
  tempy=gety;

  /*itoa(nhood, textb[0], 10);*/
  sprintf(textb[0],"%d",nhood);
  memcpy(filename,"c",1);
  memcpy(filename+1,textb[0],1);
  memcpy(filename+2,"_",1);

  /*itoa(fileno, textb[0], 10);*/
  sprintf(textb[0],"%d",fileno);
  memcpy(filename+3,textb[0],strlen(textb[0]));
  memcpy(filename+3+strlen(textb[0]),".rul",4);
  sprintf(textb[0],"filename=%s ",filename);
  draw_prompt_box(1);
  outtext(textb[0]);

  /*max buffer to store bytes, for max nhoood=9*/
  sprintf(textb[0],"buf");
  if ((buf=(char *)calloc
	  (1+(signed short)ceil(pow(2,(double)9)/8),sizeof(char)))
					==NULL) outof_memory(textb[0]);
  /*memory_box(1);*/

# if (__BORC__ || __WATCOM__)	
     if ((fid =open(filename,O_RDWR|O_BINARY)) == -1){
	sprintf(textb[0],"%s, RETURN-continue",sys_errlist[errno]);
# elif (__UNIX__)
     if ((fid =open(filename,O_RDWR)) == -1){ 
	sprintf(textb[0],"%s, file error, RETURN-continue",filename);
# endif
	draw_prompt_box(1);
	outtext(textb[0]);
	input_string(1,0);
	is[0]='q';
	free(buf);
	close(fid);
	return;
  }
  read(fid,buf,1); /*first byte gives nhood size, read into buf*/
  buf0nhood=buf[0]; /*nhood founf in buf[0]*/
  if (buf0nhood==nhood){
	rulebytes=(signed short)ceil(pow(2,(double)nhood)/8);
	/*read correct no of bytes into buf*/
	read(fid,buf+1,rulebytes);
	memcpy(rule,buf+1,rulebytes);
  }
  tablemax= (signed short)pow(2,(double)nhood)-1;
  print_layered_bitstring(64,rule,tablemax,scale,sep,0,1);
  outtext(" ");
  print_current_bitstring_hexbytes(1,rule,nhood,Maxx,white,0);
  free(buf);
  close(fid);
  moveto(tempx,tempy);
}

/********************* save rule or seed, dec 93 ********************/
void load_glider_buf(signed short no_of_glider_rules){

  signed short fid,rulebytes;
  unsigned long buffreq,filebytes;

  rulebytes=(signed short)ceil(pow(2,(double)nhood)/8);

  memcpy(filename,"glider",6);

  /*memcpy(filename+6,itoa(nhood,textb[0],10),1);*/
  sprintf(textb[0],"%d",nhood);
  memcpy(filename+6,textb[0],1);

  memcpy(filename+7,".r_s",4);

  /*byte 0 =nhood*/
  /*bytes 1,2 =lineL, max=1+256(9+128)=35074*/
  /*bytes 3,5 = i2d,j2d for twod otherwise 0,0*/

  buffreq=5+no_of_glider_rules*rulebytes;

  /*buffer required to store bytes*/
  /*glider_buf is global variable, freed in main*/
  sprintf(textb[0],"glider_buf, buffreq=%lu, calloc failed",buffreq);
  if ((glider_buf=(unsigned char *)calloc(buffreq,sizeof(unsigned char)))
				 ==NULL) outof_memory(textb[0]);
# if (__BORC__ || __WATCOM__)	
     fid=open(filename,O_RDWR|O_BINARY);
# elif (__UNIX__)
     fid=open(filename,O_RDWR);
#endif

  filebytes= filelength(fid);
  if (filebytes>buffreq){
  sprintf(textb[0],"buf, file=%lu > bufreq=%lu",filebytes,buffreq);
  if ((glider_buf=(unsigned char*)
	   realloc(glider_buf,filebytes*sizeof(unsigned char)))
					==NULL) outof_memory(textb[0]);
     buffreq=filebytes;
  }

  read(fid,glider_buf,buffreq);

  close(fid);
}

/********************* select file and list files, dec 93 **************/
char select_list_files(char* filespec,
	     signed short leftbox,signed short topbox){

# if (__BORC__||__WATCOM__)
 /*returns filename length or 0*/
 signed short tempx,tempy,
     done;
 char len=0;
#if (__BORC__)
    struct ffblk ffblk;
#elif (__WATCOM__)
    struct find_t fileinfo;
#endif

  /*boreland
 struct ffblk {
  char ff_reserved[21]; reserved by DOS
  char ff_attrib;       attribute found
  signed short  ff_ftime;        file time
  signed short  ff_fdate;        file date
  long ff_fsize;        file size
  char ff_name[13];     found file name
 };
 struct ffblk ffblk;

  watcom
 struct find_t{
  char reserved[21];
  char attrib;
  unsigned short wr_time;
  unsigned short wr_date;
  unsigned long size;
  char name[13];
 };*/

  tempx=getx;
  tempy=gety;
  draw_box(2,leftbox,topbox,Maxx-2,Maxy-2,1,0);
  moveto(leftbox+3,topbox);

 start:
# if (__BORC__)
     done = findfirst(filespec,&ffblk,0);
# elif (__WATCOM__)
     done = _dos_findfirst(filespec,_A_NORMAL,&fileinfo);
# endif

  if (done==-1){
     sprintf(textb[0],"no %s files",filespec);
     outtext(textb[0]);
     input_string(1,0);
  }
  else{
     while (!done){
#       if (__BORC__)
	   sprintf(textb[2],"%s", ffblk.ff_name);
#       elif (__WATCOM__)
	   sprintf(textb[2],"%s", fileinfo.name);
#       endif

	if (gety>Maxy-vgay(40)){
	    outtext("see more-m");
	    moveto(leftbox+3,gety+CHeight);
	    outtext("or filename");
	    moveto(leftbox+3,
	    gety+CHeight);
	    myouttext(":");
	    len=input_string(8,0);
	    if (is[0]=='m') {
		erase_box(leftbox,topbox,Maxx-2,Maxy-2);
		draw_box(-1,leftbox,topbox,Maxx-2,Maxy-2,1,0);
		moveto(leftbox+3,topbox);
		len=0;
	    }
	    else if (isalpha(is[0])) break;
	    else {
		len=0;
		break;
	    }
	}
	outtext(textb[2]);
	moveto(leftbox+3,gety+CHeight);

	#if (__BORC__)
	   done = findnext(&ffblk);
        #elif (__WATCOM__)
	   done = _dos_findnext(&fileinfo);
	#endif
     }
     if (len==0 && done){
	outtext("list again-a");
	moveto(leftbox+3,gety+CHeight);
	outtext("or filename");
	moveto(leftbox+3,gety+CHeight);
	myouttext(":");
	len=input_string(8,0);
	    if (is[0]=='a') {
		erase_box(leftbox,topbox,Maxx-2,Maxy-2);
		draw_box(-1,leftbox,topbox,Maxx-2,Maxy-2,1,0);
		moveto(leftbox+3,topbox);
		len=0;
		goto start;
	    }
	    else if (!isalpha(is[0])) len=0;
     }
  }
  putimage(leftbox,topbox,boximage[2],COPY_PUT);
  freeimage(boximage[2]);
  moveto(tempx,tempy);
  return(len);
/************************ different for unix *******************/
# elif (__UNIX__)
/*returns filename length or 0*/
 signed short tempx,tempy;
 
 char len=0,filefound;

 DIR *dirp;
 struct dirent *dp; 


  tempx=getx;
  tempy=gety;
  draw_box(2,leftbox,topbox,Maxx-2,Maxy-2,1,0);
  moveto(leftbox+3,topbox);
  
  start:
  dirp = opendir(".");
  filefound=0;
  while (1){
        dp=readdir(dirp);
        
        if (dp==NULL) break;        
        if (memcmp(dp->d_name+(strlen(dp->d_name)-4), 
                                   filespec+1, 4)!=0) continue;
        filefound=1;       
	sprintf(textb[2],"%s",dp->d_name );
        if (gety>Maxy-vgay(40)){
	    outtext("see more-m");
	    moveto(leftbox+3,gety+CHeight);
	    outtext("or filename");
	    moveto(leftbox+3,gety+CHeight);
	    myouttext(":");
	    len=input_string(8,0);
	    if (is[0]=='m') {
		erase_box(leftbox,topbox,Maxx-2,Maxy-2);
		draw_box(-1,leftbox,topbox,Maxx-2,Maxy-2,1,0);
		moveto(leftbox+3,topbox);
		len=0;
	    }
	    else if (isalpha(is[0])) break;
	    else {
		len=0;
		break;
	    }
	}
	outtext(textb[2]);
	moveto(leftbox+3,gety+CHeight);
	
     
  }
  if (len==0 && (dp==NULL || 
                 memcmp(dp->d_name+strlen(dp->d_name)-4, filespec, 4)!=0)){
        outtext("list again-a");
	moveto(leftbox+3,gety+CHeight);
	outtext("or filename");
	moveto(leftbox+3,gety+CHeight);
	myouttext(":");
	len=input_string(8,0);
	if (is[0]=='a') {
		erase_box(leftbox,topbox,Maxx-2,Maxy-2);
		draw_box(-1,leftbox,topbox,Maxx-2,Maxy-2,1,0);
		moveto(leftbox+3,topbox);
		len=0;
		closedir (dirp);
                goto start;
	}
	else if (!isalpha(is[0])) len=0;
  }
  if (filefound==0){            
            sprintf(textb[0],"no %s files",filespec);
            outtext(textb[0]);
            input_string(1,0);           
  }
               
  putimage(leftbox,topbox,boximage[2],COPY_PUT);
  freeimage(boximage[2]);
  moveto(tempx,tempy);
  return(len);
# endif
}



/*********** change drive or directory, Oct 94 *********************/
void change_drive_dir(char which){
 /*diff code for borland and watcom*/
 #if (__BORC__)
  unsigned short xbox,len;
  char driveno,*new_dir;

   /*boorland <dir.h> MAXDIR+1=67, MAXPATH+1=81*/
   sprintf(textb[0],"new_dir");
   if ((new_dir=(char *)calloc(67,sizeof(char)))
				   ==NULL) outof_memory(textb[0]);
   if (which=='1'){
	sprintf(textb[0],
	"current path %s, CHANGE DRIVE",path);
	sprintf(textb[2],"enter new drive (A,B,C etc):");
	xbox=draw_prompt_box(2);
	outtext(textb[0]);
	moveto(xbox,gety+CHeight);
	myouttext(textb[2]);
	input_string(1,0);
	if ((is[0]!=13 && is[0]!='q')
		     && (isupper(is[0]) || islower(is[0]))){
	   if (isupper(is[0])) driveno=is[0]-64;
	   else driveno=is[0]-96;
	   if (_chdrive(driveno)==-1){
	      moveto(xbox,gety);
	      setfillstyle(SOLID_FILL,black);
	      bar(getx,gety+vgay(2),
			   Maxx-vgax(3),gety+CHeight+vgay(2));
	      sprintf(textb[1],"cant change to drive %c",is[0]);
	      myouttext(textb[1]);
	      input_string(1,0);
	   }
	}
   }
   else if (which=='2'){
	sprintf(textb[0],
	"current path %s, CHANGE DIRECTORY",path);
	xbox=draw_prompt_box(2);
	outtext(textb[0]);
	moveto(xbox,gety+CHeight);
	
	myouttext("new dir, (ie \\dir\\subdir):");
	len=input_string(MAXDIR,0);
	if (is[0]!=13 && is[0]!='q'){
	   is[len]='\0';
	   sprintf(new_dir,"\%s",is);
	   if (chdir(new_dir)==-1){
	      moveto(xbox,gety);
	      setfillstyle(SOLID_FILL,black);
	      bar(getx,gety+vgay(2),
			   Maxx-vgax(3),gety+CHeight+vgay(2));
	      sprintf(textb[1],"cant change to %s",new_dir);
	      outtext(textb[1]);
	      input_string(1,0);
	   }
	}
   }
   free(new_dir);
   getcurdir(0,old_dir);
   getcwd(path,81);
   /*******************************************/
 #elif (__WATCOM__)
  unsigned short xbox,len;
  char driveno,*new_path;

   sprintf(textb[0],"new_path");
   if ((new_path=(char *)calloc(67,sizeof(char)))
				   ==NULL) outof_memory(textb[0]);

   sprintf(textb[0],
	"current path %s, CHANGE drive/directory",path);

   xbox=draw_prompt_box(2);
   outtext(textb[0]);
   moveto(xbox,gety+CHeight);
   myouttext("new path, (ie c:\\dir\\subdir):");
   len=input_string(80,0);
   if (is[0]!=13 && is[0]!='q'){
      is[len]='\0';
      sprintf(new_path,"%s",is);
      if (chdir(new_path)==-1){
	 moveto(xbox,gety);
	 setfillstyle(SOLID_FILL,black);
	 bar(getx,gety+vgay(2),
			   Maxx-vgax(3),gety+CHeight+vgay(2));
	 sprintf(textb[1],"cant change to %s",new_path);
	 outtext(textb[1]);
	 input_string(1,0);
      }
   }
   free(new_path);
   getcwd(path,81);
 #endif

}


