/************************** MAIN.C *********************************/
#define EXT
#   include "edecfunc.h"
#undef EXT

#if __UNIX__
#   include <sys/types.h>
#   include <sys/limits.h>
#   include <fcntl.h>
#   include <dirent.h>
#endif

/****************** main 13 May 1993 **************************/
void main(int argc, char **argv){
   
 signed short temp,xbox,
      demorad, /*rad of circle in screensave demo*/
      tempy,tempy1,main30y,main40y,selectry,show_w_ry,seed_y,branch_y;
 unsigned short zu,randseed;
 char firstgraphics, basinfield_setting,range_setting;
#if __BORC__||__WATCOM__
   signed short mode;
#endif
#if __WATCOM__
   time_t t; 
#endif
        bground='w';
        /*command line argument for background color, ie -w or -b*/ 
        if (argc>1){
           if (argv[1][0]=='-' 
              && (argv[1][1]=='w' || argv[1][1]=='b')) 
                   bground=argv[1][1];
#          if __BORC__||__WATCOM__
	      if (argv[1][0]=='-' && argv[1][1]=='h') hires=1;
	      if (argv[2][0]=='-' && argv[2][1]=='h') hires=1;
	      if (argv[2][0]=='-' && argv[2][1]=='b') bground='b';;
#          endif

        }
	Maxu=USHRT_MAX;  /*max unsigned int=65535*/
	Maxint=SHRT_MAX; /*max signed short int=32767*/
        nhood=fieldno=in_startbasin=in_startfield=pre_fansize_freq_hist=0;
	msize=200;
	layout_notset=1;
#       if __BORC__
           randomize();
	   randseed=rand();
#       elif __WATCOM__
           srand((unsigned) time(&t));
	   randseed=rand();
#       elif __UNIX__
           randseed=getpid()*time(0); 
#       endif
	allocate_mem_buffers();
	allocate_mem_nhood_matrix(9);/*also set memory*/
	allocate_mem_Z_parameter();
	firstgraphics=secondpart=0;
#if __BORC__||__WATCOM__
  start:
#endif
	open_graphics(firstgraphics);

#       if __UNIX__
           if (is[0]=='q'){
              XDestroyWindow(D,W);
              exit(1);
           }
#       endif

        Leftx=50;
	xtext=(float)vgax(Leftx)/CWidth;
   main10:
	cleardevice();
	setcolor(white);
	draw_bottom_title();
	firstgraphics=1;
	

#       if __BORC__||__WATCOM__
	   srand(randseed);
#       elif __UNIX__
   main11:
	srandom(randseed);
#       endif
	/*show video config/mouse*/
	/*get mode name strings*/
#       if __BORC__
	   mode = getgraphmode();
	   sprintf(textb[0],
		 "DDLab, Mar 1996, graphics=%s, randseed=%u",
				   getmodename(mode),randseed);
#       elif __WATCOM__
	   _getvideoconfig(&vc);
	   sprintf(textb[0], "Mar, Jan 1996, graphics=%dx%d, randseed=%u",
			    vc.numxpixels,vc.numypixels,randseed);
#       elif __UNIX__
           sprintf(textb[0],
		 "DDLab, Mar 1996, screen=%dx%d pt=%d randseed=%u",
			     Maxx+1,WinMaxy+1,pointsize,randseed);

#       endif

	xbox=draw_prompt_box(2);
	myouttext(textb[0]);
#if __BORC__||__WATCOM__
	if (mouse_found) sprintf(textb[0],
	       "mouse found: left button=ret, right button='q'=backtrack");
	if (!mouse_found) sprintf(textb[0],"mouse not found");
#elif __UNIX__
	sprintf(textb[0],
	      "mouse buttons: left=ret, right='q'=backtrack");
#endif
	moveto(xbox,gety+CHeight);
	outtext(textb[0]);

	memory_box(1);
	moveto(vgax(50),vgay(50));
	sprintf(textb[0],
	  "EXIT-q graphics-setup-g options-o randseed-r");
	outtext(textb[0]);
	next_line(xtext,1);
	myouttext("forward only/singe basin/subtree-s (default field):");
	setfillstyle(SOLID_FILL,black);
	bar(getx,gety,getx+CWidth,gety+CHeight);
	input_string(1,0);
	if (is[0]=='r'){
	   erase_prompt_box(2);
	   draw_prompt_box(1);
#          if __BORC__
	      sprintf(textb[0],
	        "enter random number seed 0-%u (default random):",RAND_MAX);
#          elif __WATCOM__
	      sprintf(textb[0],
		"enter random number seed 0-%u (default random):",Maxu);
#          elif __UNIX__
           sprintf(textb[0],
	    "enter random number seed 0-%lu (default random):",
                                      (unsigned long)pow(2,15)-1);
#          endif

	   myouttext(textb[0]);
	   input_string(5,0);
	   if (is[0]=='q');
	   else if (is[0]==13) randseed=myrand();
	   else if (atoi(is)<=Maxu) randseed=atoi(is);
#          if __BORC__||__WATCOM__
              goto main10;
#          elif __UNIX__
              goto main11;
#          endif
	}
	if (is[0]=='o'){
	   finish_options(0);
	   cleardevice();
	   draw_bottom_title();
#          if __BORC__||__WATCOM__
              goto main10;
#          elif __UNIX__
              goto main11;
#          endif
	}
	if (is[0]=='g'){
#          if __BORC__
	      closegraph();
	      goto start;
#          elif __WATCOM__
	      goto start;
#          elif __UNIX__
              show_old_colors();
              revise_graphics();
              goto main10;
#          endif
	   
	}
	if (is[0]=='q'){
	   memory_box(1);
	   setcolor(lightred);
	   sprintf(textb[0],"Are you sure you want to Quit?-q, Restart-ret:");
	   temp=textwidth(textb[0])/2;
	   draw_box(-1,Maxx/2-temp-15,Maxy/2-15,
			     Maxx/2+temp+15,Maxy/2+15,1,blue);
	   draw_box(-1,Maxx/2-temp-8,Maxy/2-8,
			     Maxx/2+temp+8,Maxy/2+8,1,black);
	   outtext(textb[0]);
	   input_string(1,0);
	   if (is[0]=='q'){
	      free_mem_buffers();
	      free_mem_nhood_matrix(9);
	      free_mem_Z_parameter();
#             if __BORC__
		 closegraph();
#             elif __WATCOM__
		 _setvideomode(_DEFAULTMODE);
		 _setvideomode(_TEXTBW80);
#             elif __UNIX__
                close_graphics();
#             endif
	      exit(1);
	   }
	   erase_box(Maxx/2-temp-15,Maxy/2-15,Maxx/2+temp+15,Maxy/2+15);
	   setcolor(white);
	   setpback_x_lines(0);
#          if __BORC__||__WATCOM__
               goto main10;
#          elif __UNIX__
               goto main11;
#          endif
        }
	basinfield=0;
	if (is[0]!='s' && is[0]!='S') basinfield=1;
	if (basinfield_setting!=basinfield){
	   layout_notset=1;
	   basinfield_setting=basinfield;
	}
  main15:
	next_line(xtext,1);
	sprintf(textb[0],"range of network size-r, else-ret:");
	myouttext(textb[0]);
	input_string(1,0);
	if (is[0]=='q'){
	   setpback_x_lines(1);
#          if __BORC__||__WATCOM__
              goto main10;
#          elif __UNIX__
              goto main11;
#          endif
	}
	rangeL=0;
	if (is[0]=='r') rangeL=1;
	if (range_setting!=rangeL){
	   layout_notset=1;
	   range_setting=rangeL;
	}
  main20:
	showbits_1d_as_2d=i2d=j2d=0;;
	if (basinfield && rangeL==0) select_linelength_31();
	else if (rangeL==1) select_linelength_range();
	else select_linelength_singlebasin();
	if (is[0]=='q'){
	   setpback_x_lines(1);
	   goto main15;
	}
	allocate_mem_CA_states();/*includes others*/
	/*allocate basin levels radii*/
	/*decreace as log2 radius circles up to lastlevel, then constant*/
	lastlevel=90;
	sprintf(textb[0],"rad");
	if ((rad=(float*)calloc(lastlevel+1,sizeof(float)))
				  ==NULL) outof_memory(textb[0]);
	/*nominal array for in-degree histogram*/
	maxinhist=0;
	sprintf(textb[0],"pre_fan_freq");
	if ((pre_fan_freq=
	   (unsigned long *)calloc(1,sizeof(unsigned long)))
					==NULL) outof_memory(textb[0]);
	memory_box(1);
	main30y=gety;
  main30:
	select_nhood_size(0);
	if (is[0]=='q'){
	   free(nhoodm);
	   free_mem_CA_states();
           free(rad);
	   free(pre_fan_freq);
	   pre_fansize_freq_hist=0;
	   memory_box(1);
	   if (rangeL) setpback_x_lines(1);
	   else setpback_x_lines(0);
	   goto main20;
	}
	allocate_mem_rule0(nhood);
	allocate_mem_tcode0(nhood);
	allocate_mem_all_0s_all_1s_rules(nhood);
	tempy=gety;
  wire_up:
	rules_set=0;
	select_wiring_options();
	if (twod) showbits_1d_as_2d=0;
	if (is[0]=='q'){
	   free(nhoodm);
	   free_mem_rule0();
	   free_mem_tcode0();
	   free_mem_all_0s_all_1s_rules();
	   moveto(vgax(50),main30y);
	   goto main30;
	}
	if (!loc_twod_fonly){
	   allocate_mem_wiring();
	   wire_up_network();
	   memory_box(1);
	}
	moveto(vgax(50),tempy);
	if (is[0]=='q'){
	   if (!loc_twod_fonly){
	      free_mem_wiring();
	      memory_box(1);
	   }
	   goto wire_up;
	}
	main40y=gety;
 main40:
	pdata=0;
	sep=2;
	moveto(vgax(50),main40y);
	setfillstyle(SOLID_FILL,black);
	bar(0,CHeight+main40y+2,Maxx,Maxy-vgay(33));
	select_totalistic();
	if (is[0]=='q'){
	   if (!loc_twod_fonly){
	      free_mem_wiring();
	      memory_box(1);
	   }
	   goto wire_up;
	}
	memory_box(1);
 selectrule:
	selectry=gety;
	no_glider_rules[4]=0;  /*number of rules in glider file*/
	no_glider_rules[5]=63;
	no_glider_rules[6]=3;
	no_glider_rules[7]=10;
	no_glider_rules[8]=0;
	no_glider_rules[9]=0;
	rulemix=0;
	rules_set=1;
	tempy1=rule_selection(); /*tempy1=y co-ord of text*/
	/*load file with glider rules, buffer calloced in function*/
	if (no_glider_rules[(unsigned short)nhood]>0 && nhood>3)
		  load_glider_buf(no_glider_rules[(unsigned short)nhood]);
	if (is[0]=='q'){
	   if (no_glider_rules[(unsigned short)nhood]>0 && nhood>3) 
                                                         free(glider_buf);
	   if (rulemix){
	      free_mem_rulemix();
	      free_mem_tcodemix();
	      memory_box(1);
	   }
	   rules_set=0;
	   goto main40;
	}
	moveto(vgax(50),tempy1);
	show_w_ry=gety;
 show_w_r:
	if (!loc_twod_fonly) show_w_r_scheme();
	memory_box(1);
	secondpart=1;
	if (is[0]=='q'){
	   if (no_glider_rules[(unsigned short)nhood]>0 && nhood>3) 
                                                         free(glider_buf);
	   if (rulemix){
	      free_mem_rulemix();
	      free_mem_tcodemix();
	      memory_box(1);
	   }
	   moveto(vgax(50),selectry);
	   secondpart=0;
	   goto selectrule;
	}
	toggle_single_field=0;
	branch_y=gety;
 
        /*Derrida plot for a set of initial state pairs*/
        draw_prompt_box(1);
        outtext("Derrida plot-D:");
        input_string(1,0);
        if (is[0]=='D') draw_Derrida_plot();
        
/*****branch to basin of attraction field code******/
 branch:
	if (twod) rangeL=0; /*cant have range of size for 2-d array*/
	moveto(vgax(50),branch_y);
	if (toggle_single_field==1){
	   moveto(xtext*CWidth,vgay(275));
	   basinfield=abs(basinfield-1); /*toggle single/field*/
	   toggle_single_field=0;
	   acceptall=0;

	}
	was_changed=0;
	if (basinfield){
	   direction='f';
	   goto main200;
	}
	seed_y=gety;
 main50:
	select_seed(bitseed,"SEED",0);
	if (is[0]=='q'){
	   moveto(vgax(50),show_w_ry);
	   goto show_w_r;
	}
	memcpy(A,bitseed,bytesL);
	rangebytesL=bytesL;
 main60:
	select_pattern_scrolling();
	if (is[0]=='q'){	  
           moveto(vgax(50),seed_y);
	   goto main50;
	}
	if (!loc_twod_fonly && !forward_only){
	   /*prompts for scale and position*/
	   /*draw log2 radius circles - store radii in rad[]*/
	   setup_plot();
	   if (is[0]=='q') goto main60;
	}
	if (!loc_twod_fonly && !forward_only){
	   labelsizefactor=1;
	   format_draw();  /*sets various basin draw options*/
	   if (is[0]=='q'){
	      pdata=0;
	      goto main60;
	   }
	}
	if (!loc_twod_fonly && !forward_only){
	   set_mutation(); /*sets various mutation options*/
	   if (is[0]=='q') goto main60;
	}
 main90:
	totalgofE=totalprecount=0;
	if (loc_twod_fonly || forward_only) forward_only_para();
	else select_foreward_back();
	if (direction=='b') select_stepforward();
	if (is[0]=='q') goto main60;
	setviewport(0,0,Maxx,Maxy,0);
	clearviewport();
	mut=startmut+1;
	if (mut==0) mut=1;
	if (gd_z_graph){
	   /*rectangle to contain basins*/
	   if (stp) rectangle(lineL*scale+vgax(11),vgay(45),Maxx-2,vgay(158));
	   else  rectangle(2,vgay(45),Maxx-2,vgay(158));
	   scale=1;
	   gofE_z_graph();
	   if (mutate==5) allocate_code_mem();
	}
	if (screensavedemo==1){
	   setfillstyle(SOLID_FILL,darkgray);
	   bar(0,0,Maxx,Maxy);
	   if (direction=='f') demorad=startrad*5*lineL/11;
	   else demorad=startrad*5;
	   moveto(ox,oy);
#          if __BORC__
	      setcolor(white);
	      setfillstyle(SOLID_FILL,black);
	      pieslice(ox,oy,0,360,demorad);
	      setcolor(black);
	      line(ox,oy,ox+demorad-1,oy);
	      setcolor(white);
#          elif __WATCOM__
	      setfillstyle(SOLID_FILL,black);
	      setcolor(fillcolor);
	      _ellipse(_GFILLINTERIOR,ox-demorad,oy-demorad,
					ox+demorad,oy+demorad);
	      setcolor(white);
	      _ellipse(_GBORDER,ox-demorad,oy-demorad,
					ox+demorad,oy+demorad);
#          elif __UNIX__
              setcolor(white);
	      setfillstyle(SOLID_FILL,black);
	      pieslice(ox,oy,0,360,demorad);	
#          endif
	}
 startbasin:
	/*show various prompts*/
	if (limitcheck>0 || direction=='b'){ /*drawing basins/subtrees*/
	   if (see_ppstack==1 && nonlocal) sprintf(textb[1],"ppstack-p");
	   else sprintf(textb[1],"%s","");
	   sprintf(textb[0],
                  "%s matrix-m STP-s scroll-# exp-e contr-c",textb[1]);
#          if __BORC__
	      draw_hint_box(0,textb[0],385);
#          elif __WATCOM__||__UNIX__
	      draw_hint_box(0,textb[0],390);
#          endif
	}
	in_startbasin=1;
	isexception=0;

	if (see_ppstack){
	   ppL=pp_ymax=pp_histcount=pp_wild_tot=0;
	   for (zu=lineL-1;zu!=Maxu;zu--) pp_hist_total[zu]=0;
	}
	if (see_ppstack==1 && nonlocal){
	   sprintf(textb[0],"partial pre-image histogram: start pause-p");
	   draw_prompt_box(1);
	   outtext(textb[0]);
	}
	firstox=ox;
	firstoy=oy;
	/* range of single basins or trees for increasing CA size*/
	if (rangeL) draw_range_single();
	else{   /*single basins or trees for one size only*/
	   memcpy(A,bitseed,bytesL);
	   /*draw single basin of attraction*/
	   if (direction=='f'){
	      bitflipcount=0;
	      totatt_states=0;
	      run_forward();
	   }
	   /*if backward, upstream only, draw trees*/
	   else upstream_only();
	   memory_box(1);
	   if (gd_z_graph){
	      graphspot=ceil((double)lx/275);
	      /*plot Z parameter*/
	      if (direction=='b') moveto(gox+lx*zparam[0],
				  goy-(signed short)(ly*totsubgofEdensity));
	      if (direction=='f') moveto(gox+lx*zparam[0],
			   goy-(signed short)(ly*basingofEdensity));
	      circle(getx,gety,graphspot);
	      if (gd_z_graph==2){
		 /*plot lambda ratio*/
		 if (direction=='b') moveto(gox-300+lx*lratio,
				  goy-(signed short)(ly*totsubgofEdensity));
		 if (direction=='f') moveto(gox-300+lx*lratio,
			   goy-(signed short)(ly*basingofEdensity));
		 circle(getx,gety,graphspot);
	      }
	   }
	   if (pre_fansize_freq_hist){
	      show_pre_fansize_freq_hist();
	      /*reset in-degree histogram to zero*/
	      free(pre_fan_freq);
	      sprintf(textb[0],"pre_fan_freq");
	      if ((pre_fan_freq=(unsigned long *)
	      calloc(maxinhist+1,sizeof(unsigned long)))
				  ==NULL) outof_memory(textb[0]);
	   }
	   if ((mutantdontpause==0 && screensavedemo==0) || is[0]=='q')
						   finish_options(1);
	}
	if (toggle_single_field==1) goto endbasin;
	if (gd_z_graph ){
	   /*delete-restore rectangle to contain basins*/
	   setfillstyle(SOLID_FILL,black);
	   if (stp){
	      bar(2,vgay(45),Maxx-2,vgay(158));
	      bar3d(lineL*scale+vgax(11),vgay(45),Maxx-2,vgay(158),0,0);
	   }
	   else  bar3d(2,vgay(45),Maxx-2,vgay(158),0,0);

	}
	else if (screensavedemo==1 && is[0]!='q'){
	   firstox=myrand()%Maxx;
	   firstoy=myrand()%Maxy;
	   setfillstyle(SOLID_FILL,black);
#          if __BORC__
	      setcolor(white);
	      pieslice(firstox,firstoy,0,360,demorad);
	      setcolor(black);
	      line(firstox,firstoy,firstox+demorad-1,firstoy);
	      setcolor(white);
#          elif __WATCOM__
	      setcolor(fillcolor);
	      _ellipse(_GFILLINTERIOR,firstox-demorad,firstoy-demorad,
					firstox+demorad,firstoy+demorad);
	      setcolor(white);
	      _ellipse(_GBORDER,firstox-demorad,firstoy-demorad,
					firstox+demorad,firstoy+demorad);
#          elif __UNIX__
              setcolor(white);
	      setfillstyle(SOLID_FILL,black);
	      pieslice(firstox,firstoy,0,360,demorad);	
#          endif

	   /*set new random seed*/
	   for (zu=L;zu!=Maxu;zu--) set_bit(bitseed,zu,((myrand()%100)/50));
	}
	else clearviewport();
	/*mutate or change rule table*/
	if ((is[0]==13||mutantdontpause==1) && is[0]!='q'){
	   /*space-time patterns only - dont mutate*/
	   if (direction=='f' && limitcheck==0) goto startbasin;
	   fieldno=0;
	   if (was_changed==0){
	      if (mutate<=1) mut-=1;
	      if (mut==endmut-1) mut=startmut;
	   }
	   if (gd_z_graph){
	      endcount+=1;
	      biased_new_rule();
	   }
	   if (mutate_rule(nhood)) goto startbasin;
	   else acceptall=0;
	}
 endbasin:
	draw_bottom_title();
	if (stp){
	   moveto(0,0);
	   if (nowscrolling==1){
#             if __BORC__||__WATCOM__
	         freeimage(stpimage);
#             endif	       
	      nowscrolling=0;
	   }
	}
	if (gd_z_graph){
	   if (!rulemix && (mutate==4 || mutate==5)) finish_options(1);
	   /*delete basin rectangle*/
	   bar(2,vgay(45),Maxx-2,vgay(158));
	   endcount=0;
	   if (mutate==5){
	      free(codetickoff);
	      free(tempcode);
	   }
	}
	in_startbasin=0;
	if (toggle_single_field==1) goto branch;
	if (acceptall==0 || loc_twod_fonly) goto main60;
	else goto main90;

/* * * * * * * * * * * * basin field * * * * * * * * * * */
 main200:
	select_pattern_scrolling();
	if (is[0]=='q'){
	   moveto(vgax(50),show_w_ry);
	   goto show_w_r;
	}
	/*set layout*/
	setup_plot();	/*draw log2 radius circles - store radii in rad[]*/
	memory_box(1);
	if (is[0]=='q') goto main200;

	labelsizefactor=1;
	format_draw();  /*sets various basin draw options*/
	if (is[0]=='q'){
	   pdata=0;
	   goto main200;
	}
	set_mutation(); /*sets various mutation options*/
	if (is[0]=='q') goto main200;

	see_ppstack=exhaustive_testing=0;
	sprintf(textb[3],"%s","");

	if (lineL<limitL)
	   sprintf(textb[3],"exh testing-e, random map-r");
	if (nonlocal){
	   sprintf(textb[2],"(non-local)");
	   sprintf(textb[1],"view partial pre-image stack-1, fan pause-2:");
	}
	else{
	   sprintf(textb[2],"(local)");
	   sprintf(textb[1],"view partial pre-image stack-1:");
	}
	if (rangeL) sprintf(textb[0],"basin field %s L=%d-%d, %s,",
			       textb[2],startL,endL,textb[3]);
	else sprintf(textb[0],"basin field %s L=%d, %s",
			       textb[2],lineL,textb[3]);

	xbox=draw_prompt_box(2);
	outtext(textb[0]);
	moveto(xbox,gety+CHeight);
	myouttext(textb[1]);
	input_string(1,0);
	if (is[0]=='q'){
	   erase_prompt_box(2);
	   pdata=0;
	   goto main200;
	}
	if (is[0]=='1') see_ppstack=1;
	else if (is[0]=='2') see_ppstack=2;

	else if (lineL<limitL){ /*borland<=18 watcom<=32*/
	   if (is[0]=='e') exhaustive_testing=1;
	   else if (is[0]=='r') exhaustive_testing=2;
	}
	clearviewport();
	firstox=ox;
	firstoy=oy;
	fieldno=0;
	firstxspacing=xspacing;
	firstyspacing=yspacing;
	mut=startmut+1;
	if (mut==0) mut=1;
	if (gd_z_graph){
	   /*rectangle to contain basins*/
	   scale=1;
	   if (stp) rectangle(lineL*scale+vgax(11),vgay(45),Maxx-2,vgay(158));
	   else  rectangle(2,vgay(45),Maxx-2,vgay(158));
	   gofE_z_graph();
	   if (mutate==5) allocate_code_mem();
	   endcount=0;

	}
 startfield:
	/*show various prompts*/
	if (see_ppstack==1 && nonlocal) sprintf(textb[1]," ppstack-p");
	else sprintf(textb[1],"%s","");
	sprintf(textb[0],
              "matrix-m STP-s scroll-# exp-e contr-c%s",textb[1]);
	#if __BORC__
	   draw_hint_box(0,textb[0],385);
	#elif __WATCOM__||__UNIX__
	   draw_hint_box(0,textb[0],390);
	#endif

	in_startfield=1;
	isexception=0;
	
	if (see_ppstack){
	   ppL=pp_ymax=pp_histcount=pp_wild_tot=0;
	   for (zu=lineL-1;zu!=Maxu;zu--) pp_hist_total[zu]=0;
	}
	if (see_ppstack==1 && nonlocal){
	   sprintf(textb[0],"partial pre-image histogram: start pause-p");
	   draw_prompt_box(1);
	   outtext(textb[0]);
	}
	if (rangeL) draw_range_field();
	else {
	   totatt_states=0;
	   draw_field(); /*draw basin of attraction field*/
	   if (gd_z_graph){
	      graphspot=ceil((double)lx/250);
	      /*plot Z parameter*/
	      moveto(gox+lx*zparam[0],
				goy-(signed short)(ly*fieldgofEdensity));
	      circle(getx,gety,graphspot);
	      if (gd_z_graph==2){
		 /*plot lambda ratio*/
		 moveto(gox-vgax(300)+lx*lratio,
				goy-(signed short)(ly*fieldgofEdensity));
		 circle(getx,gety,graphspot);
	      }
	   }
	   if (mutantdontpause==0 && !(exhaustive_testing && earlyexitfield))
							print_field_data();
	   if (pre_fansize_freq_hist){
	      show_pre_fansize_freq_hist();
	      /*reset in-degree histogram to zero*/
	      free(pre_fan_freq);
	      sprintf(textb[0],"pre_fan_freq");
	      if ((pre_fan_freq=(unsigned long *)
	      calloc(maxinhist+1,sizeof(unsigned long)))
				  ==NULL) outof_memory(textb[0]);
	   }
	   if (mutantdontpause==0 || is[0]=='q') finish_options(1);
	}
	if (toggle_single_field==1) goto endfield;
	if (gd_z_graph ){
	   /*delete-restore rectangle to contain basins*/
	   setfillstyle(SOLID_FILL,black);
	   if (stp){
	      bar(2,vgay(45),Maxx-2,vgay(158));
	      bar3d(lineL*scale+vgax(11),vgay(45),Maxx-2,vgay(158),0,0);
	   }
	   else  bar3d(2,vgay(45),Maxx-2,vgay(158),0,0);
	}
	else clearviewport();

	/*mutate or change rule table*/
	if (is[0]==13||mutantdontpause==1){
	   fieldno=0;
	   if (was_changed==0){
	      if (mutate<=1) mut-=1;
	      if (mut==endmut-1) mut=startmut;
	   }
	   if (gd_z_graph){
	      endcount+=1;
	      biased_new_rule();
	   }
	   if (mutate_rule(nhood)) goto startfield;
	   else acceptall=0;
	}
 endfield:
	draw_bottom_title();
	if (gd_z_graph){
	   if (!rulemix && (mutate==4 || mutate==5)) finish_options(1);
	   /*delete basin rectangle*/
	   bar(2,vgay(45),Maxx-2,vgay(158));
	   endcount=0;
	   if (mutate==5){
	      free(codetickoff);
	      free(tempcode);
	   }
	}
	in_startfield=0;
	if (toggle_single_field==1) goto branch;
	moveto(vgax(50),vgay(100));
	goto main200;
}

/****** show pre-image fan frequency histogram, jan 1994 ***********/
void show_pre_fansize_freq_hist(void){
 float histheight,loghistheight,histwidth,totalxaxis,logxpos,lognextxpos;
 unsigned long zz,thisfreq,maxfreq,ss=0,totalss,
     totalnodes=0,totaledges=0,maxfan=0,interval=0,
     thismaxinhist,maxshowinhist,lastinbin;
 signed short z,maxheight,border,
     leftborder,botborder,xright,ybot,xaxismax,tempx,tempy,tempx2;
 unsigned short zu;
 char xlog=0,ylog=0;
 /*for histogram data file*/
 /*signed short fid;
   char file_ret;*/

    maxheight=vgay(120);
    leftborder=vgax(50);
    botborder=vgax(40);
    border=vgay(35);
    xright=80;
    ybot=67;
    histwidth=vgax(5);
    tempx=getx;
    tempy=gety;
    if (basinfield){      /*basin field*/
		totalss=ss=(unsigned long)(pow(2,(double)lineL));
		maxfan=maxfieldfan;
    }
    else if (direction=='f'){  /*single basin*/
		totalss=(unsigned long)basinsize;
		maxfan=maxbasinfan;
    }
    else{                 /*subtree only*/
		totalss=(unsigned long)totsubtree;
		maxfan=maxtreefan;
    }
    for (zu=0;zu<=maxinhist;zu++){
		totalnodes+=pre_fan_freq[zu];
		totaledges+=zu*pre_fan_freq[zu];
    }
    if (pre_fan_freq[maxinhist]>=1) totaledges+=maxfan-maxinhist;
    if (totalnodes<totaledges) totalss=totalnodes;

    /*in case basin was interrupted too soon*/
    if (totalss==0 || (direction=='f'&& totatt_states==0)
		      || !totalnodes || !totaledges){
       moveto(tempx,tempy);
       return;
    }
    /*find largest in-degree frequency*/
    maxfreq=pre_fan_freq[0];
    for (z=maxinhist;z>=1;z--){
       if (pre_fan_freq[z]>maxfreq) pre_fan_freq[z]=maxfreq;
    }
    ss=maxfreq;
    /*find largest in-degree<=maxhist*/
    for (z=maxinhist;z>=0;z--){
       if (pre_fan_freq[z]>0){
	  maxshowinhist=z;
	  break;
       }
    }
    thismaxinhist=maxshowinhist;

  redrawhist:
    lastinbin=pre_fan_freq[maxshowinhist];
    xaxismax=thismaxinhist;
    if (xaxismax<25) xaxismax=25;
    histwidth= (float)vgax(500)/xaxismax;
    if (histwidth>vgax(10)) histwidth=vgax(10);
    totalxaxis=(xaxismax+1)*histwidth;


    for (z=thismaxinhist+1;z<=maxshowinhist;z++) lastinbin+=pre_fan_freq[z];

    draw_box(11,vgax(xright-3)-leftborder,Maxy-vgay(ybot)-maxheight-border,
	  vgax(xright)+totalxaxis+border,
			 Maxy-vgay(ybot)+botborder,1,0);

    histheight=maxheight;
    line(vgax(xright),Maxy-vgay(ybot),vgax(xright),Maxy-vgay(ybot)-maxheight);
    if (ss>16) interval=(unsigned long)(ss/16);
    else interval=1;
    setcolor(yellow);
    /*centre y axis title*/
#   if __BORC__
       settextstyle(2,VERT_DIR , 0);
#   elif __WATCOM__
       _settextorient(0,1);
#   endif

#   if __BORC__||__WATCOM__
    sprintf(textb[1],"number of nodes");
    if (ylog) sprintf(textb[0],"%s (log)",textb[1]);
    else sprintf(textb[0],"%s",textb[1]);

    /*
    if (textwidth(textb[0])>=maxheight) moveto(vgax(xright)-leftborder+5,
					    Maxy-vgay(ybot)-maxheight);
    else moveto(vgax(xright)-leftborder+5,Maxy-vgay(ybot)
			   -(maxheight-textwidth(textb[0]))/2);
    */
    moveto(vgax(xright)-leftborder+5,Maxy-vgay(ybot)-vgay(20));


    outtext(textb[0]);

#   elif __UNIX__
       moveto(vgax(xright)-leftborder+2,Maxy-vgay(ybot)-maxheight*.7);
       tempx2=getx;
       outtext("number");
       moveto(tempx2,gety+CHeight);
       outtext("of");
       moveto(tempx2,gety+CHeight);
       outtext("nodes");
       moveto(tempx2,gety+CHeight);
       if (ylog) outtext("(log)");
#   endif

#   if __BORC__
       settextstyle(2,HORIZ_DIR, 0);
#   elif __WATCOM__
       _settextorient(1,0);
#   endif

    /*centre x axis title*/
    sprintf(textb[0],"pre-images, in-degree");
    if (textwidth(textb[0])>=xaxismax*histwidth)
			moveto(vgax(xright),Maxy-vgay(ybot)+vgay(20));
    else moveto(vgax(xright)+(xaxismax*histwidth-textwidth(textb[0]))/2,
					    Maxy-vgay(ybot)+vgay(20));
    outtext(textb[0]);
    if (xlog) outtext(" (log)");

    /*draw y axis*/
    if (!ylog){

       for (zz=0;zz<=ss;zz+=interval){
	  histheight=(float)maxheight*((float)zz/ss);
	  moveto(vgax(xright),Maxy-vgay(ybot)-histheight);
	  if (zz%(interval*4)==0 || ss<8){
	     line(getx-4,gety,getx,gety);
	     sprintf(textb[0],"%lu",zz);
	     moveto(getx-4-textwidth(textb[0]),
		    gety-CHeight*.5);
	     outtext(textb[0]);
	  }
	  else line(getx-2,gety,getx,gety);
       }
       if (ss%(interval*4)!=0 && ss>7){
	  moveto(vgax(xright),Maxy-vgay(ybot)-maxheight);
	  line(getx-4,gety,getx,gety);
	  sprintf(textb[0],"%lu",(unsigned long)ss);
	  moveto(getx-4-textwidth(textb[0]),
		     gety-CHeight*1.3);
	  outtext(textb[0]);
       }
    }

    /*draw x axis*/
    line(vgax(xright),Maxy-vgay(ybot),vgax(xright)+(histwidth*(xaxismax+1)),
						   Maxy-vgay(ybot));

    if (!xlog){
       for (zu=0;zu<=xaxismax+1;zu++){
	  moveto(vgax(xright)+(zu*histwidth),Maxy-vgay(ybot));
	  if (zu%(10*(signed short)ceil((double)thismaxinhist/100))==0){
	     lineto(getx,gety+4);
	     moveto(getx-CWidth/2,gety);
	     if (zu==maxinhist) sprintf(textb[0],"%d+",zu);
	     else sprintf(textb[0],"%d",zu);
	     outtext(textb[0]);
	  }
	  else if (thismaxinhist<=200) line(getx,gety,getx,gety+2);
	  else if (zu%(5*(signed short)ceil((double)thismaxinhist/100))==0)
				      line(getx,gety,getx,gety+2);
       }
       if (lastinbin>0 && thismaxinhist<maxshowinhist){
	  moveto(getx+CWidth,Maxy-vgay(ybot)-CHeight/2);
	  outtext("+");
       }
    }
    setcolor(white);
    /*draw histogram*/
    for (z=0;z<=thismaxinhist;z++){
	if (z==0) setfillstyle(INTERLEAVE_FILL,red);
	else setfillstyle(SOLID_FILL,blue);
	thisfreq=pre_fan_freq[z];

	if (z==thismaxinhist){
	   /*last frquency shown + all the rest in black*/
	   thisfreq=lastinbin;
	   if (lastinbin>0) setfillstyle(SOLID_FILL,white);
	}

	if (thisfreq>0){
	    histheight=(float)maxheight*((float)thisfreq/(float)ss);

	    if (xlog){
	       logxpos=(float)(totalxaxis*
		       log((double)z+1)/log((double)thismaxinhist));
	       lognextxpos=(float)(totalxaxis*
		       log((double)z+2)/log((double)thismaxinhist));

	    }
	    if (!xlog && !ylog){
	       if (histheight>maxheight+border) histheight=maxheight+border;
	       bar3d(vgax(xright)+z*histwidth,Maxy-vgay(ybot)-histheight,
			 vgax(xright)+(z+1)*histwidth,Maxy-vgay(ybot),0,0);

	    }
	    else{

	       if (ylog){
		  loghistheight=(float)(maxheight*
		       log((double)thisfreq)/log((double)maxfreq));
	       }

	       if (xlog && ylog){
		  bar3d(vgax(xright)+logxpos,Maxy-vgay(ybot)-loghistheight,
			 vgax(xright)+lognextxpos,Maxy-vgay(ybot),0,0);
	       }
	       else if (!xlog && ylog){
		  bar3d(vgax(xright)+z*histwidth,
		     Maxy-vgay(ybot)-loghistheight,
			 vgax(xright)+(z+1)*histwidth,Maxy-vgay(ybot),0,0);
	       }
	       else if (xlog && !ylog){
		  if (histheight>maxheight+border)
		                           histheight=maxheight+border;
		  bar3d(vgax(xright)+logxpos,Maxy-vgay(ybot)-histheight,
			 vgax(xright)+lognextxpos,Maxy-vgay(ybot),0,0);
	       }
	    }
	}
    }
    z--;
    if ((unsigned short)z<maxinhist && pre_fan_freq[z]>0){
       /*last frequency only in "blue"*/
       setfillstyle(SOLID_FILL,blue);
       thisfreq=pre_fan_freq[z];
       histheight=(float)maxheight*((float)thisfreq/(float)ss);
       if (histheight>maxheight+border) histheight=maxheight+border;
       bar3d(vgax(xright)+z*histwidth,Maxy-vgay(ybot)-histheight,
			 vgax(xright)+(z+1)*histwidth,Maxy-vgay(ybot),0,0);
    }

    moveto(vgax(140),Maxy-vgay(ybot)-maxheight-border+vgay(3));
    if (direction=='b')
       sprintf(textb[0],"subtree: nodes/edges=%lu/%lu",
					      totalnodes,totaledges);
    else sprintf(textb[0],"total att/nodes/edges=%lu/%lu/%lu",
				totatt_states,totalnodes,totaledges);
    outtext(textb[0]);
    moveto(vgax(140),gety+CHeight);
    sprintf(textb[0],"max in-degree=%lu, gE=%lu",maxfan,pre_fan_freq[0]);
    outtext(textb[0]);

    /*show exceptions*/
    if (show_maj>=0){
	moveto(vgax(140),gety+CHeight);
	sprintf(textb[0],
		 "exceptions=%d, %g",isexception,(float)isexception/ss);
	outtext(textb[0]);
    }

    /*moveto(vgax(140),gety+CHeight);
    outtext("xlog-x ylog-y log-log-g save data-s quit-q:");
    input_string(1,0);

    xlog=ylog=0;
    if (is[0]=='q') goto skip;
    else if (is[0]=='g') xlog=ylog=1;
    else if (is[0]=='x') xlog=1;
    else if (is[0]=='y') ylog=1;
    else if (is[0]=='s'){
       file_ret=select_filename("SAVE","HIST-DATA", "*.his","my_hist");

       if (file_ret!='q'){
#        if __BORC__||__WATCOM__
	    if ((fid=open(filename,
		   O_RDWR|O_CREAT| O_APPEND|O_TEXT,S_IREAD|S_IWRITE))==-1){
	       sprintf(textb[0],"%s, RETURN-continue",sys_errlist[errno]);
	       draw_prompt_box(1);
	       outtext(textb[0]);
	       input_string(1,0);
	       erase_prompt_box(1);
	       close(fid);
	    }

#        elif __UNIX__
	    if ((fid=open(filename, O_CREAT|O_APPEND,S_IREAD|S_IWRITE))==-1){
	       sprintf(textb[0],"file error, RETURN-continue");
	       draw_prompt_box(1);
	       outtext(textb[0]);
	       input_string(1,0);
	       erase_prompt_box(1);
	       close(fid);
	    }
#         endif
	  write(fid,pre_fan_freq,maxshowinhist*sizeof(unsigned long));
	  close(fid);
       }
    }*/
    
    moveto(vgax(140),gety+CHeight);
    /*outtext("(options-o prtbox-p save-s quit-q)");*/ /*bug -s*/
    outtext("(options-o prtbox-p quit-q)");
    moveto(vgax(140),gety+CHeight);

    if (maxshowinhist>25) outtext("re-scale x/y axis (def-d):");
    else outtext("re-scale y axis (def-d):");
       if (maxshowinhist>25){
       sprintf(textb[0],"x-max (25-%lu):",maxshowinhist);
       myouttext(textb[0]);
       input_string(8,0);
       if (is[0]=='q') goto skip;
       /*print histogram box*/
#      if __BORC__||__WATCOM__
	 if (is[0]=='p') printimage('L',0,0,
	    vgax(xright-3)-leftborder,Maxy-vgay(ybot)-maxheight-border,
	     vgax(xright)+((xaxismax+1)*histwidth)+border,
			 Maxy-vgay(ybot)+botborder);
#      elif __UNIX__
	 if (is[0]=='p') printimage();
#      endif
       else if (is[0]=='o') finish_options(1);
       else if (is[0]=='d') thismaxinhist=maxshowinhist;
       else if (is[0]!=13 && atol(is)>=25 && atoi(is)<=maxshowinhist)
						thismaxinhist=atol(is);
    }
    myouttext(" y-max:");
    input_string(8,0);
    if (is[0]=='q') goto skip;
    /*print histogram box*/
#   if __BORC__||__WATCOM__
      if (is[0]=='p') printimage('L',0,0,
	  vgax(xright-3)-leftborder,Maxy-vgay(ybot)-maxheight-border,
	     vgax(xright)+((xaxismax+1)*histwidth)+border,
			 Maxy-vgay(ybot)+botborder);
#   elif __UNIX__
	 if (is[0]=='p') printimage();
#   endif
    else if (is[0]=='o') finish_options(1);
    else if (is[0]=='d') ss=maxfreq;
    else if (is[0]!=13 && atol(is)>0) ss=atol(is);

    putimage(vgax(xright-3)-leftborder,
		   Maxy-vgay(ybot)-maxheight-border,boximage[11],COPY_PUT);
    freeimage(boximage[11]);
    goto redrawhist;

   skip:
    putimage(vgax(xright-3)-leftborder,
		   Maxy-vgay(ybot)-maxheight-border,boximage[11],COPY_PUT);
    freeimage(boximage[11]);
    is[0]=0;
    moveto(tempx,tempy);
}

/********************** mutate the rule, Sept 1993 *********************/
void finish_options(char alloptions){
 signed short tempx,tempy;
 unsigned char tempcolor,test;

   tempx=getx;
   tempy=gety;
   moveto(0,0);
  start:
   finish_options_box(alloptions);
   switch (is[0]){
      case 'g':
	 freeimage(boximage[1]);
#        if __BORC__||__WATCOM__
            if (alloptions) open_graphics(1);
#        elif __UNIX__
            if (alloptions) revise_graphics(); 
#        endif
         goto start;
      case 'p':
	 if (!stp){
	    tempcolor=getcolor();
	    setcolor(red);
	    rectangle(0,0,getmaxx(),getmaxy());
	    setcolor(tempcolor);
	 }
	 putimage(2,2,boximage[1],COPY_PUT);
	 freeimage(boximage[1]);
#        if __BORC__||__WATCOM__
            printimage('L',0,0,0,0,getmaxx(),getmaxy());
#        elif __UNIX__
            printimage();
#        endif
         goto start;
      case 's':
	 putimage(2,2,boximage[1],COPY_PUT);
	 freeimage(boximage[1]);
	 save_screen();
	 goto start;
      case 'l':
	 putimage(2,2,boximage[1],COPY_PUT);
	 freeimage(boximage[1]);
	 load_screen();
	 test=0;
#        if __BORC__||__WATCOM__
	 while (!(test=='q' || test==13)) /*pause to grab screen*/
	     test=keycheck(0);
#        elif __UNIX__
             while(!(test=='q' || test==13)){
                 if (XCheckWindowEvent(D,W,KeyPressMask,&Event)){
                    if (Event.type == KeyPress){                    
                       button='k';
                       test=keycheck(0);   
                    }		
	         }
	      }
#        endif
	 goto start;
      case 'o':
	 putimage(2,2,boximage[1],COPY_PUT);
	 freeimage(boximage[1]);
	 if (alloptions){
	    if (nhood){
	       print_rule_in_box(2,carule[0]);
	       if (rulemix==0){
		  /*show Z parameter*/
		  z_parameter_all(nhood,0,carule[0]);
		  show_rule_bottom(nhood,0,carule[0],0);
	       }
	    }
	    /*if not forward only*/
	    if (is[0]=='q' && !(limitcheck==0 && direction=='f')) goto start;
	 }
	 break;
      case 'n':
	 putimage(2,2,boximage[1],COPY_PUT);
	 freeimage(boximage[1]);
	 if (alloptions){
	    if (!loc_twod_fonly && alloptions) show_w_r_scheme();
	 }
	 goto start;
      case 't':
	 putimage(2,2,boximage[1],COPY_PUT);
	 freeimage(boximage[1]);
	 if (alloptions) toggle_single_field=1;
	 break;
      case 'P':/*turn space-time pattern on/off*/
	 putimage(2,2,boximage[1],COPY_PUT);
	 freeimage(boximage[1]);
	 if (alloptions){
	    if (!(limitcheck==0 && direction=='f')) stp=abs(stp-1);
	 }
	 break;
      case 'S':/*reset seed*/
	 putimage(2,2,boximage[1],COPY_PUT);
	 freeimage(boximage[1]);
	 if (alloptions){
	    if (!basinfield){
	       moveto(vgax(200),vgay(315));
	       select_seed(bitseed,"SEED",1);
	       memcpy(A,bitseed,bytesL);
	    }
	 }
	 break;
      default: /*including 'q'*/
	 putimage(2,2,boximage[1],COPY_PUT);
	 freeimage(boximage[1]);
	 if (is[0]=='q') diff_plot=0;
	 break;
      }
      moveto(tempx,tempy);
}

/********************** mutate the rule, Sept 1993 *********************/
char mutate_rule(char nhoodz){
 signed short tablemax,
	      equivcode,codeclustersize,
	      codedec,tcd1,tcd2,tcd3,/*decimal code + 3 EQUIVALENTS*/
	      z,zz,sod,counter,temp;
 unsigned short cellno,cellmax=0,
		poss,wire,bit;
 char tempbit;
 unsigned long ruledec;
 float ztemp,tempinc;

   if (was_changed==1){
      was_changed=0;
      fieldno=0;
      ox=firstox;
      oy=firstoy;
      xspacing=firstxspacing;
      yspacing=firstyspacing;
      return(1);
   }
   /*mutate wiring*/
   if (mutate=='w'){
      if (wires_to_move==-1){
	 for (poss=lineL-1;poss!=Maxu;poss--)
			   randomly_wire_cell(poss,lineL-1);
      }
      else{
	 for (wire=1;wire<=wires_to_move;wire++){
	    poss=myrand()%lineL;
	    wiring[poss][myrand()%nhoodm[poss]]=myrand()%lineL;
	 }
      }
   }
   /*flip one or nore bits at random*/
   else if (mutate=='b' && bits_to_flip>0){
     startbit:
      for (bit=1;bit<=bits_to_flip;bit++){
	 if (rulemix) cellno=myrand()%lineL;
	 else cellno=0;
	 poss=myrand()%(signed short)pow(2,(double)nhoodm[cellno]);
	 set_bit(carule[cellno],poss,abs(get_bit(carule[cellno],poss)-1));
      }
      if (!rulemix){
	 z_parameter_all(nhood,0,carule[0]);
	 if (zparam[0]<.1) goto startbit;
      }
   }

   /*other mutations rule/s or totalistic code/s*/
   else{
      /*5-code+1,4-code rand,3-rule+1,2-rule rand,1-onebit cum,0-bit single*/
      tablemax=(signed short)pow(2,(double)nhoodz)-1;
      if (rulemix) cellmax=L;
      for (cellno=0;cellno<=cellmax;cellno++){
	 if (nhood_mixed)
	     tablemax=(signed short)pow(2,(double)nhoodm[cellno])-1;

	 /*bitflip ruletable from left pos to right pos*/
	 if (mutate==1 || mutate==0){
	    /*flip next bit*/
	    set_bit(carule[cellno],mut,abs(get_bit(carule[cellno],mut)-1));
	    if (mutate==0){
	       /*flip last bit back*/
	       if (mut<tablemax) set_bit(carule[cellno],
				mut+1,abs(get_bit(carule[cellno],mut+1)-1));
	    }
	 }
	 if (mutate==5||mutate==4){
	    /*decriment code number*/
	    if (mutate==5){
	      startmutate5:
	       if ((gd_z_graph || (codetypeonly!='a')) && rulemix==0){
		   /*totalistc rules are symetric
		   typical cluster

		   start---tcd2   equiv
		    |       |
		    |       |
		    |       |
		   tcd1----tcd3   equiv   compliment
			   negative
		  */

		  /*negatine transformation*/
		  memcpy(tempcode,cacode[0],
			      (signed short)ceil((double)(nhoodz+1)/8));
		  /*flip bits*/
		  for (z=nhoodz;z>=0;z--)
			  set_bit(tempcode,z,abs(get_bit(tempcode,z)-1));
		  /*compliment transformation of start*/
		  tcd1=(signed short)dec_equiv(tempcode,nhoodz);

		  /*swap bits*/
		  /*negative transformation of start, done on compliment*/
		  if (nhoodz%2==1){ /*if odd nhood, even size code table*/
		     for (z=nhoodz;z>=(nhoodz+1)/2;z--){
			tempbit=get_bit(tempcode,z);
			set_bit(tempcode,z,get_bit(tempcode,nhoodz-z));
			set_bit(tempcode,nhoodz-z,tempbit);
		     }
		  }
		  else { /*if even nhood, odd size code table*/
		     for (z=nhoodz;z>=(nhoodz/2)+1;z--){
			tempbit=get_bit(tempcode,z);
			set_bit(tempcode,z,get_bit(tempcode,nhoodz-z));
			set_bit(tempcode,nhoodz-z,tempbit);
		     }
		  }
		  tcd2=(signed short)dec_equiv(tempcode,nhoodz);
		  /*flip bits*/
		  /*compliment of negative of start*/
		  for (z=nhoodz;z>=0;z--)
			   set_bit(tempcode,z,abs(get_bit(tempcode,z)-1));
		  tcd3=(signed short)dec_equiv(tempcode,nhoodz);
	       }
	       codedec=(signed short)dec_equiv(cacode[cellno],nhoodz);

	       /*if (rulemix==0 && !lambda_z_graph){*/
	       if (rulemix==0 && codetypeonly!='a'){

		  equivcode=codeclustersize=1;
		  if (!lambda_z_graph || pause_show_code){
		     draw_prompt_box(1);
		     sprintf(textb[0],"%d-code cluster:%d",nhoodz,codedec);
		     myouttext(textb[0]);
		  }
		  set_bit1(codetickoff,codedec);

		  /*tickoff equivalent, max one*/
		  if (tcd2!=codedec){
		     if (!lambda_z_graph || pause_show_code){
			sprintf(textb[0],"=%d",tcd2);
			myouttext(textb[0]);
		     }
		     set_bit1(codetickoff,tcd2);
		     equivcode+=1;
		     codeclustersize+=1;
		     endcount+=1;
		  }

		  if (gd_z_graph || codetypeonly=='c'){
		     /*tick off rest of cluster*/
		     if (tcd1!=codedec && tcd1!=tcd2){
			if (!lambda_z_graph || pause_show_code){
			   sprintf(textb[0]," %d",tcd1);
			   myouttext(textb[0]);
			}
			set_bit1(codetickoff,tcd1);
			codeclustersize+=1;
			endcount+=1;
		     }
		     if (tcd3!=codedec && tcd3!=tcd2 && tcd3!=tcd1){
			if (!lambda_z_graph || pause_show_code){
			   sprintf(textb[0],"=%d",tcd3);
			   myouttext(textb[0]);

			}
			set_bit1(codetickoff,tcd3);
			codeclustersize+=1;
			endcount+=1;
		     }
		  }
		  totcode_eq_or_cl+=1;
		  if (!lambda_z_graph || pause_show_code){
		     sprintf(textb[0]," equiv=%d clust=%d",
					 equivcode,codeclustersize);
		     myouttext(textb[0]);
		  }
		  if (pause_show_code){
		     sprintf(textb[0]," tot=%d end-q",
						   totcode_eq_or_cl);
		     myouttext(textb[0]);
		     input_string(1,0);
		     if (is[0]=='q'){
			pause_show_code=0;
			is[0]=0;
		     }
		  }
	       }
	      nextblank:
	       codedec-=1;
	       if (rulemix==0){
		  if (codedec<1) return(0);
		  if (gd_z_graph || codetypeonly!='a'){
		     if (get_bit(codetickoff,codedec)==1) goto nextblank;
		  }
	       }
	       if (codedec<1) codedec=(signed short)pow(2,(double)nhoodz+1)-1;
	       /*max code dec*/
	       dec_to_bit_line(cacode[cellno],codedec,nhoodz+1);
	       /*skip codes with Z parameter <.1*/
	       if (gd_z_graph && !rulemix){
		  for (zz=tablemax;zz>=0;zz--){
		     sod=0;
		     for (z=nhoodm[cellno]-1;z>=0;z--)
					sod+=get_bit(nm[z],zz);
		     set_bit(carule[cellno],zz,get_bit(cacode[cellno],sod));
		  }
		  z_parameter_all(nhoodz,0,carule[0]);
		  if (zparam[0]<lowlimZ || zparam[0]>highlimZ){
		     codedec-=1;
		     endcount+=1;
		     goto startmutate5;
		  }
	       }
	    }
	    /*reset code at randon*/
	    if (mutate==4){
	       for (z=nhoodz;z>=0;z--)
			set_bit(cacode[cellno],z,((myrand()%100)/50));
	    }
	    /*convert code to rule*/
	    for (zz=tablemax;zz>=0;zz--){
	       sod=0;
	       for (z=nhoodm[cellno]-1;z>=0;z--) sod+=get_bit(nm[z],zz);
	       set_bit(carule[cellno],zz,get_bit(cacode[cellno],sod));
	    }
	 }
	 /*decriment rule number*/
	 else if (mutate==3 && nhoodm[cellno]<=5){
	    ruledec=dec_equiv(carule[cellno],tablemax);
	   startdecr:
	    ruledec-=1;
	    if (ruledec<1){
	       if (rulemix==0) return(0);
	       else ruledec=(unsigned long) (pow(2,(double)(tablemax+1))-1);
	    }
	    dec_to_bit_line(carule[cellno],ruledec,tablemax+1);

	    if (!rulemix){
	       z_parameter_all(nhoodz,0,carule[0]);
	       if (gd_z_graph){
		  if (zparam[0]<lowlimZ || zparam[0]>highlimZ)
						  goto startdecr;
	       }
	    }
	 }
	 /*reset rule at randon*/
	 else if (mutate==2 || (mutate=='b' && bits_to_flip==-1)){

	   startrandom:
	    if (!rulemix){
	       if (lambda_bias==0) lambda_bias=50;
	       for (z=tablemax;z>=0;z--)
		   set_bit(carule[cellno],z,((myrand()%100)/lambda_bias));
	       z_parameter_all(nhood,0,carule[0]);
	       if (zparam[0]<.06) goto startrandom;

	       if  (set_z_high){
		  z_parameter_all(nhoodz,0,carule[0]);
		  if (zparam[0]<.55) goto startrandom;  /*.65*/

		  tempinc= myrand() % 35;                 /* 27*/

		  counter=0;
		  if (zparam[0]<.6 +tempinc/100){    /*.7*/
		     ztemp=zparam[0];
		    changebit:
		     counter+=1;
		     temp= myrand() % tablemax;
		     /*random bit flip*/
		     set_bit(carule[0],temp,abs(get_bit(carule[0],temp)-1));
		     z_parameter_all(nhoodz,0,carule[0]);
		     if (zparam[0]<ztemp){
			/*flip back*/
			set_bit(carule[0],temp,abs(get_bit(carule[0],temp)-1));
			/*flip another*/
			if (counter<500) goto changebit;
		     }
		     ztemp=zparam[0];
		     if (zparam[0]<.6+tempinc/100){   /*7*/
			if (counter<500) goto changebit;
		     }
		  }
	       }
	    }
	    else{
	       for (z=tablemax;z>=0;z--)
		  set_bit(carule[cellno],z,((myrand()%100)/50));
	    }
	 }
      }
      if (!rulemix) z_parameter_all(nhoodz,0,carule[0]);
   }
   fieldno=0;
   ox=firstox;
   oy=firstoy;
   xspacing=firstxspacing;
   yspacing=firstyspacing;
   return(1);
}

/************ set biased new rule for Gd - Z graph, Jan 94 ***************/
void biased_new_rule(void){
  unsigned short tempx,tempy;

    tempx=getx;
    tempy=gety;

    if (mutate==2){
       if (endcount<.2 * totalgraphrules) {
	  lambda_bias=50;
	  set_z_high=1;
	  goto skipcount;
       }
       if (endcount<.28 * totalgraphrules) {
	  lambda_bias=50;
	  set_z_high=0;
	  goto skipcount;
       }
       if (endcount<.36 * totalgraphrules) {
	  lambda_bias=45;
	  set_z_high=0;
	  goto skipcount;
       }
       if (endcount<.44 * totalgraphrules) {
	  lambda_bias=40;
	  set_z_high=0;
	  goto skipcount;
       }
       if (endcount<.52 * totalgraphrules) {
	  lambda_bias=35;
	  set_z_high=0;
	  goto skipcount;
       }
       if (endcount<.6 * totalgraphrules) {
	  lambda_bias=30;
	  set_z_high=0;
	  goto skipcount;
       }
       if (endcount<.68 * totalgraphrules) {
	  lambda_bias=25;
	  set_z_high=0;
	  goto skipcount;
       }
       if (endcount<.76  * totalgraphrules) {
	  lambda_bias=20;
	  goto skipcount;
       }
       if (endcount<.84  * totalgraphrules){
	  lambda_bias=15;
	  goto skipcount;
       }
       if (endcount<.92  * totalgraphrules){
	  lambda_bias=10;
	  goto skipcount;
       }

       if (endcount<=totalgraphrules){
	  lambda_bias=5;
	  goto skipcount;
       }
    }
    skipcount:

    if (!(mutate==3 || mutate==5)){
       sprintf(textb[0],"t=%lu c=%lu lb=%d zh=%d",
	      totalgraphrules,endcount,lambda_bias,set_z_high);
       if (endcount>=totalgraphrules) mutantdontpause=0;

       draw_box(-1,Maxx-vgax(150),2,Maxx-2,vgay(17),1,0);
       outtext(textb[0]);
    }
    /*show number of rules plotted*/
    draw_box(-1,Maxx-vgax(150),vgay(138),vgax(610),vgay(153),1,0);
    sprintf(textb[0],"total plotted=%lu",endcount);
    outtext(textb[0]);
    moveto(tempx,tempy);
}

/********************** lamdda ratio - Z parameter graph *******************/
void draw_lambda_z_graph(char dontbias){
 signed short z,zz,sod,tablemax,xbox,xbox1;
  
   unsigned long *canal_freq,*lr_freq;
   unsigned long **canal_lr_freq;
   unsigned long zu;
   char show_CP;

   tablemax=(signed short)pow(2,(double)nhood)-1;
   sprintf(textb[0],"canal_freq");
   if ((canal_freq=
      (unsigned long *)calloc(nhood+1,sizeof(unsigned long)))
				   ==NULL) outof_memory(textb[0]);

   sprintf(textb[0],"lr_freq");
   if ((lr_freq=
      (unsigned long *)calloc((tablemax+1)/2+1,sizeof(unsigned long)))
				   ==NULL) outof_memory(textb[0]);

   sprintf(textb[0],"canal_lr-freq");
   if ((canal_lr_freq=
      (unsigned long **)calloc(nhood+1,sizeof(unsigned long*)))
				   ==NULL) outof_memory(textb[0]);
   for (z=0;z<=nhood;z++){
      sprintf(textb[0],"canal_lr_freq");
      if ((canal_lr_freq[z]=
	(unsigned long *)calloc((tablemax+1)/2+1,sizeof(unsigned long)))
				   ==NULL) outof_memory(textb[0]);

   }
   
   if (nhood==4) mutate=3;     /*to check exhaustivly*/

   /*count down code-space from set code*/
   if (mutate==5){
      totalgraphrules=(unsigned long) dec_equiv(cacode[0],nhood);
      /*convert code to rule*/
      for (zz=tablemax;zz>=0;zz--){
	 sod=0;
	 for (z=nhood-1;z>=0;z--) sod+=get_bit(nm[z],zz);
	 set_bit(carule[0],zz,get_bit(cacode[0],sod));
      }
   }
   /*show all of rulespace*/
   else if (mutate==3)
      totalgraphrules=(unsigned long) dec_equiv(carule[0],tablemax);

   graphspot=ceil((double)lx/275);
   totcode_eq_or_cl=0;
   endcount=0;


   /* count ruleno or codeno */
   if (mutate==3 || mutate==5){
      z_parameter_all(nhood,0,carule[0]);
      canal_freq[canaltotal]+=1;
      lr_freq[(signed short)(lratio*(tablemax+1)/2)]+=1;

      canal_lr_freq[canaltotal][(signed short)(lratio*(tablemax+1)/2)]+=1;

      /*
      draw_prompt_box(1);
      sprintf(textb[0],"%d",(signed short)(lratio*(tablemax+1)/2));
      outtext(textb[0]);
      input_string(1,0);
      */

      moveto(gox+lx*zparam[0],goy-(signed short)(ly*lratio));
      circle(getx,gety,graphspot);

      for (endcount=0;endcount<=totalgraphrules+1;endcount++){
	 z_parameter_all(nhood,0,carule[0]);
	 canal_freq[canaltotal]+=1;
	 lr_freq[(signed short)(lratio*(tablemax+1)/2)]+=1;
	 canal_lr_freq[canaltotal][(signed short)(lratio*(tablemax+1)/2)]+=1;


	 if (keycheck(0)=='q') break;; /*to interrupt*/
	 /*draw_box(-1,Maxx-vgax(150),2,Maxx-2,vgay(17),1,0);*/

	 if (endcount%100==0){
	    draw_prompt_box(1);
	    sprintf(textb[0],"c-frequency:");
	    outtext(textb[0]);
	    for (z=0;z<=nhood;z++){
	       sprintf(textb[0],"%lu ",canal_freq[z]);
	       outtext(textb[0]);
	    }
	    sprintf(textb[0]," total rules=%lu last=%lu",
				    totalgraphrules+1,endcount);
	    outtext(textb[0]);
	 }
	 if (mutate_rule(nhood)==0) break;
	 if (pause_show_code) show_rule_bottom(nhood,0,carule[0],0);

	 moveto(gox+lx*zparam[0],goy-(signed short)(ly*lratio));
	 circle(getx,gety,graphspot);

      }
      draw_prompt_box(1);
      sprintf(textb[0],"c-frequency:");
      outtext(textb[0]);
      for (z=0;z<=nhood;z++){
	 sprintf(textb[0],"%lu ",canal_freq[z]);
	 outtext(textb[0]);
      }
      sprintf(textb[0]," total rules=%lu last=%lu",
				    totalgraphrules+1,endcount);
	 outtext(textb[0]);

      /*show number of rules plotted*/
      draw_box(-1,vgax(150),vgay(405),vgax(335),vgay(420),1,0);

      if (codetypeonly=='a' || mutate==3)
	 sprintf(textb[0],"total plotted=%lu",endcount);
      else if (codetypeonly=='e')
	 sprintf(textb[0],"total plotted=%lu, equivalents=%d",
					   endcount,totcode_eq_or_cl);
      else sprintf(textb[0],"total plotted=%lu, clusters=%d",
					   endcount,totcode_eq_or_cl);
      outtext(textb[0]);


   }
   else{
      for (zu=1;zu<=totalgraphrules;zu++){
	 z_parameter_all(nhood,0,carule[0]);
	 canal_freq[canaltotal]+=1;
	 lr_freq[(signed short)(lratio*(tablemax+1)/2)]+=1;
	 canal_lr_freq[canaltotal][(signed short)(lratio*(tablemax+1)/2)]+=1;

	 if (dontbias==1) goto skipcountf;

	 if (zu<.09*totalgraphrules) {
	    lambda_bias=5;
	    goto  skipcountf;
	 }
	 if (zu<.18*totalgraphrules) {
	    lambda_bias=10;
	    goto skipcountf;
	 }
	 if (zu<.27*totalgraphrules) {
	    lambda_bias=15;
	    goto skipcountf;
	 }
	 if (zu<.36*totalgraphrules) {
	    lambda_bias=20;
	    goto skipcountf;
	 }
	 if (zu<.45*totalgraphrules) {
	    lambda_bias=25;
	    goto skipcountf;
	 }
	 if (zu<.54*totalgraphrules) {
	    lambda_bias=30;
	    set_z_high=0;
	    goto skipcountf;
	 }
	 if (zu<.63*totalgraphrules) {
	    lambda_bias=35;
	    set_z_high=0;
	    goto skipcountf;
	 }
	 if (zu<.72*totalgraphrules) {
	    lambda_bias=40;
	    set_z_high=0;
	    goto skipcountf;
	 }
	 if (zu<.81*totalgraphrules) {
	    lambda_bias=45;
	    set_z_high=0;
	    goto skipcountf;
	 }
	 if (zu<.90*totalgraphrules) {
	    lambda_bias=50;
	    set_z_high=0;
	    goto skipcountf;
	 }

	 if (zu<=totalgraphrules) {
	    lambda_bias=50;
	    /*set_z_high=1;*/
	    set_z_high=0;
	    goto skipcountf;
	 }
	skipcountf:

	 if (keycheck(0)=='q') break;; /*to interrupt*/
	 if (zu%100==0){
	    draw_box(-1,Maxx-vgax(150),2,Maxx-2,vgay(17),1,0);
	    sprintf(textb[0],"t=%lu c=%lu lb=%d zh=%d",
			    totalgraphrules,zu,lambda_bias,set_z_high);
	    outtext(textb[0]);
	 }


	 mutate_rule(nhood);

	 moveto(gox+lx*zparam[0],goy-(signed short)(ly*lratio));
	 circle(getx,gety,graphspot);
      }
      /*show number of rules plotted*/
      draw_box(-1,vgax(230),vgay(405),vgax(335),vgay(420),1,0);
      sprintf(textb[0],"total plotted=%lu",zu-1);
      outtext(textb[0]);
   }

   show_CP=0;
   outtext(" show C-P data-s:");
   input_string(1,0);
   if (is[0]!='s') goto skip_CP; 
   else show_CP=1;
     
   setcolor(lightred);
#  if __WATCOM__||__UNIX__
      draw_box(11,2,vgay(35),Maxx-2, Maxy/3,1,0);
#  elif __BORC__
      draw_box(-1,2,vgay(35),Maxx-2, Maxy/3,1,0);
#  endif
   setcolor(white);
   xbox=getx;

   sprintf(textb[0],
     "Canalyzing-lambda ratio frequency count, total rules=%lu:",
						  totalgraphrules+1);
   outtext(textb[0]);

   moveto(xbox,gety+CHeight);
   outtext("  Canalyzing freq: ");
   xbox1=getx;
   for (z=0;z<=nhood;z++){
      sprintf(textb[0],"%lu=%.1f%%",
	   canal_freq[z],100*(float)canal_freq[z]/(totalgraphrules+1));
      outtext(textb[0]);
      moveto(xbox1+CWidth*10*(z+1),gety);
   }
   moveto(xbox,gety+CHeight);
   outtext("lambda ratio freq: ");
   xbox1=getx;
   for (z=0;z<=(tablemax+1)/2;z++){
      sprintf(textb[0],"%lu=%.1f%%",
		   lr_freq[z],100*(float)lr_freq[z]/(totalgraphrules+1));
      outtext(textb[0]);
      moveto(xbox1+CWidth*10*(z+1),gety);
   }
   /*columns  range of lambda ratio*/
   moveto(xbox,gety+CHeight);
   xbox1=getx+CWidth*10;
   for (z=1;z<=(tablemax+1)/2;z++){
      sprintf(textb[0],"Lr=%d",z);
      moveto(xbox1+CWidth*10*z,gety);
   }

   for (zz=0;zz<=(tablemax+1)/2;zz++){
	 if (zz==0){
	    moveto(xbox,gety+CHeight);
	    sprintf(textb[0],"ldr  ");
	    outtext(textb[0]);
	    xbox1=getx;
	 }
	 moveto(xbox1+CWidth*10*zz,gety);
	 sprintf(textb[0],"%g  ",(float)zz/((tablemax+1)/2));
	 outtext(textb[0]);
   }

   /*columns  range of P*/
   xbox1=getx+CWidth*10;
   for (z=1;z<=(tablemax+1)/2;z++){
      sprintf(textb[0],"Lr=%d",z);
      moveto(xbox1+CWidth*10*z,gety);
   }

   for (zz=0;zz<=(tablemax+1)/2;zz++){
	 if (zz==0){
	    moveto(xbox,gety+CHeight);
	    sprintf(textb[0],"P    ");
	    outtext(textb[0]);
	    xbox1=getx;
	 }
	 moveto(xbox1+CWidth*10*zz,gety);
	 sprintf(textb[0],"%g  ",1-((float)zz/((tablemax+1)/2))/2);
	 outtext(textb[0]);
   }
   for (z=0;z<=nhood;z++){

      for (zz=0;zz<=(tablemax+1)/2;zz++){
	 if (zz==0){
	    moveto(xbox,gety+CHeight);
	    sprintf(textb[0],"C=%d  ",z);
	    outtext(textb[0]);
	    xbox1=getx;
	 }
	 moveto(xbox1+CWidth*10*zz,gety);
	 if (canal_lr_freq[z][zz]>0){
	    sprintf(textb[0],"%lu=%.1f%%",
	      canal_lr_freq[z][zz],
		 100*(float)canal_lr_freq[z][zz]/(totalgraphrules+1));
	    outtext(textb[0]);
	 }
	 else outtext("0");

      }
   }
  skip_CP:

   finish_options(0);

   setfillstyle(SOLID_FILL,black);
   if (mutate==3 || mutate==5)
	 bar(vgax(150),vgay(405),vgax(335),vgay(420));
   else bar(vgax(230),vgay(405),vgax(335),vgay(420));
   bar(gox-vgax(20),goy+vgay(12),gox+lx+vgay(20),goy-ly-+vgay(10));
   erase_prompt_box(3);
   free(canal_freq);
   free(lr_freq);
   for (z=0;z<=nhood+1;z++) free(canal_lr_freq[z]);
   free (canal_lr_freq);

   if (show_CP){
#     if __WATCOM__||__UNIX__
	 putimage(2,vgay(35),boximage[11],COPY_PUT);
	 freeimage(boximage[11]);
#     elif __BORC__
         draw_box(-1,2,vgay(35),Maxx-2, Maxy/3,0,0);
#     endif
   }
}

/***************** garden-of-Eden dencity <-> Z parameter ***************/
void gofE_z_graph(void){
 signed short z,zz,tempx2;
 double ix,iy;
 char graphno;

    gox=vgax(360);
    goy=vgay(420);

    lx=vgax(250);
    ly=vgay(250);

    setcolor(white);

    ix=lx/10;
    iy=ly/10;

    if (lambda_z_graph==1) graphno=1;/*graph of lambda ratio - Z*/
    else{
       if (gd_z_graph==1) graphno=1;    /*graph for Z parameter*/
       else if (gd_z_graph==2) graphno=2;/*graph for lambda ratio*/
    }
    for (zz=1;zz<=graphno;zz++){
	if (zz==2) gox-=vgax(300);

	moveto(gox,goy);
	linerel((signed short)lx,0);

	/*draw x-axis*/
	for (z=0;z<=10;z++){
		moveto(gox+(signed short)(ix*z),goy);
		linerel(0,-vgax(5));
		if (z%5==0){
		    linerel(0,-vgax(5));
		    moverel(0,vgax(11));
		    sprintf(textb[0],"%.1f",(float)(z)/10);
		    myouttext(textb[0]);
		}
	}
	moveto(gox+(signed short)lx,goy);
	linerel(0,-(signed short)ly);

	/*title x-axis*/
	moveto(gox+(signed short)(ix*2),goy+1);
	if (zz==1) sprintf(textb[0],"Z parameter");
	if (zz==2) sprintf(textb[0],"Lambda ratio");
	outtext(textb[0]);

	/*draw y-axis*/
	moveto(gox,goy);
	linerel(0,-(signed short)ly);
	for (z=0;z<=10;z++){
	   moveto(gox,goy-(signed short)(iy*z));
	   linerel(vgay(5),0);
	   if (z%5==0){
	      linerel(vgay(5),0);
	      moverel(-vgay(5),0);
	      sprintf(textb[0],"%.1f",(float)(z)/10);
	      moverel(-(textwidth(textb[0])*1.5),-CHeight);

	      myouttext(textb[0]);
	   }
	}
	/*title y-axis*/
#       if __BORC__||__WATCOM__
           if (lambda_z_graph==1) sprintf(textb[0],"Lambda ratio");
	   else sprintf(textb[0],"G-density");
#       endif
#       if __BORC__
	   settextstyle(2,VERT_DIR , 0);
	   moveto(gox-vgax(17),goy-(signed short)(iy*4));
           outtext(textb[0]);
#       elif __WATCOM__
	   _settextorient(0,1);
	   moveto(gox-vgax(17),goy-(signed short)(iy*2));
           outtext(textb[0]);
#       elif __UNIX__
           if (lambda_z_graph==1) sprintf(textb[0],"Lambda ratio");
	   else sprintf(textb[0],"G density");
           moveto(gox-vgax(17),goy-(signed short)(iy*4));       
	   tempx2=getx;
	   for (z=0;z<=strlen(textb[0])-1;z++){
	      sprintf(textb[1],"%c",textb[0][z]);
	      outtext(textb[1]);
	      moveto(tempx2,gety+CHeight*.7);
	   }
#       endif 

#       if __BORC__
	   settextstyle(2, HORIZ_DIR, 0);
#       elif __WATCOM__
	   _settextorient(1,0);
#       endif

	moveto(gox,goy-(signed short)ly);
	linerel((signed short)lx,0);
    }
    gox=vgax(360);
}

/********************** probapility of forgetting *********************/
void forget_graph(void){
 signed short tempx,tempy,z,xint;
 long xdiv,zl;
 float startf,f;
 double ix,iy;

  gox=(signed short)((float)Maxx/7);
  goy=Maxy-(signed short)((float)Maxy/7);
  lx=Maxx-2*gox;
  ly=Maxy-2*(Maxy-goy);

 startgraph:
  setcolor(white);
  xdiv=20;  /*divs in x-axis*/
  sprintf(textb[0],
	"Probability (p) of forgetting other network transitions\n");
  next_line(xtext,1);
  myouttext(textb[0]);
  sprintf(textb[0],"when learning a new pre-image by moving one wire,");

  next_line(xtext,1);
  myouttext(textb[0]);

  sprintf(textb[0],
    "or one bitflip in ruletable (in this case p=0 on same pre-image fan)");
  next_line(xtext,1);
  myouttext(textb[0]);

  nhood=0;
  sprintf(textb[0],
  "select: moving one wire (default), or one bit-flip in ruletable - enter b:");
  next_line(xtext,1);
  myouttext(textb[0]);

  input_string(1,0);
  if (is[0]=='b' || is[0]=='B'){
     sprintf(textb[0],"enter size of pseudo neighbourhood (default 5) :");
     next_line(xtext,1);
     myouttext(textb[0]);
     input_string(3,1);
     if (is[0]=='q') return;
     nhood=atoi(is);
     if (is[0]==13 ||is[0]=='0') nhood=5;
  }
  sprintf(textb[0],"enter number of cell missmatches (default 20):");
  next_line(xtext,1);
  myouttext(textb[0]);
  input_string(10,1);
  if (is[0]=='q') return;
  xdiv=atol(is);
  if (is[0]==13 || is[0]=='0') xdiv=20;

  if (xdiv<11) {xint=1;goto graph10;}
  if (xdiv<21) {xint=2;goto graph10;}
  if (xdiv<51) {xint=5;goto graph10;}
  if (xdiv<101) {xint=10;goto graph10;}
  if (xdiv<501) {xint=25;goto graph10;}
  if (xdiv<1001) {xint=50;goto graph10;}
  if (xdiv<2001) {xint=100;goto graph10;}
  if (xdiv<5001) {xint=250;goto graph10;}
  if (xdiv<10001) {xint=500;goto graph10;}
  if (xdiv<2000) {xint=2500;goto graph10;}
  if (xdiv>4000) {xint=5000;goto graph10;}
  graph10:

  ix= lx/xdiv;
  iy= ly/10;

  moveto(gox,goy);
  linerel((signed short)lx,0);

  /*draw x-axis*/
  for (zl=0;zl<=xdiv;zl++){
     if (zl%xint==0){
	moveto(gox+(signed short)(ix*zl),goy);
	linerel(0,-7);
	moverel(0,textscale+1);
	sprintf(textb[0],"%lu",zl);
	myouttext(textb[0]);
     }
  }
  moveto(gox+(signed short)lx,goy);
  linerel(0,-(signed short)ly);

  /*title x-axis*/
  moveto(gox+(signed short)(lx/4),goy+40);
  sprintf(textb[0],"Number of missmatched cells");
  myouttext(textb[0]);
  if (nhood==0){
     sprintf(textb[0]," - one wire moved");
     myouttext(textb[0]);
  }
  if (nhood>0){
     sprintf(textb[0]," - one ruletable bit flipped");
     myouttext(textb[0]);
  }
  /*draw y-axis*/
  moveto(gox,goy);
  linerel(0,-(signed short)ly);
  for (z=0;z<=10;z++){
     moveto(gox,goy-(signed short)(iy*z));
     linerel(7,0);
     sprintf(textb[0],"%.1f",(float)(z)/10);
     moverel(-(textwidth(textb[0])*2),-CHeight);
     myouttext(textb[0]);
  }
  /*title y-axis*/
# if __BORC__
     settextstyle(2,VERT_DIR , 0);
# elif __WATCOM__
     _settextorient(0,1);
# endif

  moveto(gox-60,goy-ly+ly/6);
  sprintf(textb[0],"p = prbability of forgetting other transitions");
  myouttext(textb[0]);

  moveto(gox,goy-(signed short)ly);
  linerel((signed short)lx,0);

  /*prob of forgetting other transition by moving one wire*/
  if (nhood==0) startf=(float)1/4;
  if (nhood>0){
     /*prob of forgetting other transition outside pre-image fan*/
     /*by flipping one bit*/
     startf=(float)((double)1/pow(2,(double)nhood));
  }

  f=startf;
  graphspot=ceil((double)6/xint);

  moveto(gox+(signed short)(ix),goy-(signed short)(f*ly));
  for (zl=1;zl<=xdiv;zl++){
	if (zl==1) circle(getx,gety,graphspot);

	else{
		f=startf+(1-startf)*f;
		lineto(gox+(signed short)(ix*zl),goy-(signed short)(f*ly));
		circle(getx,gety,graphspot);
	}
	if (zl%xint==0){
		tempx=getx;tempy=gety;
		sprintf(textb[0],"%.3f",f);
		myouttext(textb[0]);
		moveto(tempx,tempy);
	}
  }
# if __BORC__
     settextstyle(2,HORIZ_DIR, 0);
# elif __WATCOM__
     _settextorient(1,0);
# endif

  /*print graphics screen*/
  sprintf(textb[0],"to print screen enter l-(landscape), p-(portrait) :");
  draw_prompt_box(1);
  myouttext(textb[0]);
  input_string(1,0);

  if (is[0]=='q' || is[0]=='Q') return;

	erase_prompt_box(1);
#       if __BORC__||__WATCOM__	
           /*portrait*/
	   if (is[0]=='p') printimage('P',0,0,0,0,Maxx,Maxy);
	   /*landscape*/
	   if (is[0]=='l') printimage('L',0,0,0,0,Maxx,Maxy);
#       elif __UNIX__
           if (is[0]=='p'||is[0]=='l') printimage();
#       endif	   


	sprintf(textb[0],"RETURN for memu, k to keep screen, q to quit :");
	draw_prompt_box(1);
	myouttext(textb[0]);
	input_string(1,0);

	setcolor(white);
	if (is[0]=='q' || is[0]=='Q') return;

	if (is[0] != 'k') cleardevice();

	erase_prompt_box(1);
	moveto(0,0);
	goto startgraph;
}
