/************** include/define 13 May 1993 ********************/
#include "edecfunc.h"

/************* print the next line, 13 May 93 *************/
void end_page(char cur_scale){  /* scale = ca scrolling interval*/
#if __BORC__||__WATCOM__
 unsigned long imsize=0,pixno;
 signed short tempx,tempy;  
 unsigned long imsizelimit;
#endif
   /*note: unsigned short scrolly must be a global variable
    - it is refered to again*/

   /*dont do this if not showing space-time pattern*/
   if (stp==0) return;
   
   if (scrolling==0){
      moveto(0,gety+cur_scale);		
      if (Maxy-gety<cur_scale){
         setviewport(0, 0,lineL*cur_scale+2, Maxy, 1);
         clearviewport();
         setviewport(0, 0, Maxx, Maxy, 0);
#        if __WATCOM__
	    moveto(0,0);
#        endif
	 return;
      }
   }/*scrolling == 0*/
   
   if (scrolling==1){
      if (nowscrolling==0){
         moveto(0,gety+cur_scale);		 
      	 if (Maxy-gety<cur_scale){
	    nowscrolling=1;   /*scroll display*/
	    scrolly=gety-cur_scale;
	    moveto(0,gety+cur_scale); 		
            /****** not xwindows ************/
#           if __BORC__
	       imsizelimit=64000;
#           elif __WATCOM__
	       imsizelimit=640000;
#           endif
#           if __BORC__||__WATCOM__
	       imsize=(unsigned long)
		   imagesize(0,cur_scale,
                       lineL*cur_scale,scrolly+cur_scale);
	       if (imsize>imsizelimit){
		  tempx=draw_prompt_box(2);		    
		  outtext("Not enough memory to scroll");
		  moveto(tempx,gety+CHeight);
		  outtext("return to continue by sweeps:");
		  input_string(1,0);
		  erase_prompt_box(2);
		  scrolling=nowscrolling=0;
		  moveto(0,0);
		  setviewport(0, 0, (L+1)*cur_scale+2, Maxy, 1);
		  clearviewport();
		  setviewport(0, 0, Maxx, Maxy, 0);
		  return;
	       }
	       /*size of space-time pattern image in bytes*/
	       pixno=(unsigned long)
                       (((lineL*cur_scale)+1)*(scrolly+1));
	       if ((stpimage = malloc(imsize)) == NULL){
	       	  tempx=draw_prompt_box(1);		    
		  sprintf(textb[0],"stpimage was %dx%d, pixno=%lu",
			 (lineL*cur_scale)+1,scrolly+1,pixno);
		  outtext(
                     "Not enough memory to scroll, expect CRASH");
		  moveto(tempx,gety+CHeight);
		  outtext(textb[0]);
		  moveto(tempx,gety+CHeight);
		  outtext("return to continue by sweeps:");
		  scrolling=nowscrolling=0;
		  moveto(0,0);
		  input_string(1,0);
		  setviewport(0,0,lineL*cur_scale+2,Maxy,1);
		  clearviewport();
		  setviewport(0, 0, Maxx, Maxy, 0); 
	       }
#           endif
	    /***** not xwindows (above) ********/   
	 }     
#        if __UNIX__
	    else {  /*if not scrolling yet*/	
                copy_part_image(current_draw,
		    &W,0,gety-cur_scale,0,
                         gety-cur_scale,pixmap_width,cur_scale);
	    }
#        endif

      }
      else{  /*if (nowscrolling==1)*/     
          setfillstyle(SOLID_FILL,black);
#         if __UNIX__              
             bar(0,scrolly,pixmap_width,Maxy);
             copy_part_image(current_draw,current_draw,
                  0,cur_scale,0,0,pixmap_width,scrolly);
             putimage(0,0,current_draw,COPY_PUT);             

#         elif __BORC__||__WATCOM__
	     getimage(0,cur_scale,
                    lineL*cur_scale,scrolly+cur_scale,stpimage);
	     bar(0,scrolly,lineL*cur_scale+2,scrolly+cur_scale);
             putimage(0,0,stpimage,COPY_PUT);
	     bar(0,scrolly-cur_scale,
                    lineL*cur_scale+2,scrolly+cur_scale);
#         endif
	  moveto(0,scrolly-cur_scale);
      }
   }
}

/**** print the next line acc to width/height of text, 13 May 1993 ********/
void next_line(float chwidth,float lineht){  /*to locate start of new line*/
 signed short hpix,vpix;

            hpix=(signed short)( chwidth * CWidth);
	    vpix=(signed short)( lineht * CHeight);
	    moveto(hpix,gety+vpix);
	    if (Maxy-gety<CHeight ){
		draw_prompt_box(1);
		outtext("attempting to write text below Maxx");
		input_string(1,0);
	    }
}

/************* step back x lines, Aug 1993 **************************/
void setpback_x_lines(char xlines){
 signed short tempx,tempy;

	next_line(xtext,-xlines);
	tempx=getx;
	tempy=gety;
	setfillstyle(SOLID_FILL,black);
	bar(getx,gety+2,Maxx-10,gety+CHeight*(xlines+2));
	moveto(tempx,tempy);
	next_line(xtext,-1);
}

/************* print CA state as line of cells May 93 *****************/
void print_current_state(char *temp, signed short color){
 signed short tempx,tempy;
 unsigned short zu;

   tempx=getx;
   tempy=gety;
   setcolor(white);
   setfillstyle(SOLID_FILL,black);
   bar(tempx,tempy,tempx+L*scale+scale-sep,tempy+scale-sep);
   for(zu=L;zu!=Maxu;zu--){
      if (get_bit(temp,zu)==1)setfillstyle(SOLID_FILL,color);
      else setfillstyle(SOLID_FILL,darkgray);
      bar(getx,gety,getx+scale-sep,gety+scale-sep);
      /*put a dot on zero cell*/
      if (scale>=3) putpixel(getx-1+scale/2,gety-1+scale/2,green);
      moverel(scale,0);
   }
   moveto(tempx,tempy);
}

/************* print CA state as line of cells May 93 *****************/
void print_current_state_h(char *temp, signed short color){
 signed short tempx,tempy;
 unsigned short zu;

   tempx=getx;
   tempy=gety;
   setcolor(white);
   setfillstyle(SOLID_FILL,black);
   if (hilight_learn && color!=white){
      bar(tempx-1,tempy-1,tempx+L*scale+scale-sep+1,tempy+scale-sep+1);
      rectangle(tempx-2,tempy-2,tempx+L*scale+scale-sep+2,tempy+scale-sep+2);
   }
   else bar(tempx,tempy,tempx+L*scale+scale-sep,tempy+scale-sep);
   for(zu=L;zu!=Maxu;zu--){
      if (get_bit(temp,zu)==1)setfillstyle(SOLID_FILL,color);
      else setfillstyle(SOLID_FILL,darkgray);
      bar(getx,gety,getx+scale-sep,gety+scale-sep);
      /*put a dot on zero cell*/
      if (scale>=3) putpixel(getx-1+scale/2,gety-1+scale/2,green);
      moverel(scale,0);
   }
   moveto(tempx,tempy);
}

/************* print CA state as line of cells May 93 *****************/
void print_current_state_twod(char *temp, signed short color){
 signed short zz=0,tempx,tempy;
 unsigned short zu;

   tempx=getx;
   tempy=gety;
   setcolor(white);
   setfillstyle(SOLID_FILL,black);
   if (hilight_learn && color!=white){
      bar(tempx-2,tempy-2,tempx+i2d*(scale-sep)+2,tempy+j2d*(scale-sep)+2);
      rectangle
	(tempx-3,tempy-3,tempx+i2d*(scale-sep)+3,tempy+j2d*(scale-sep)+3);
   }
   else bar(tempx,tempy,tempx+i2d*(scale-sep),tempy+j2d*(scale-sep));
   for (zu=L;zu!=Maxu;zu--){
      zz+=1;
      if (get_bit(temp,zu)==1) setfillstyle(SOLID_FILL,color);
      else setfillstyle(SOLID_FILL,black);
      bar(getx,gety,getx+scale-sep,gety+scale-sep);
      moverel(scale-sep,0);
      if (zz%i2d==0) moveto(tempx,gety+scale-sep);
   }
   rectangle(tempx-1,tempy-1,
	    tempx+i2d*(scale-sep)+1,tempy+j2d*(scale-sep)+1);
   moveto(tempx,tempy);
}

/******************** print current rule in hex **********************/
signed short print_current_bitstring_hexbytes
	     (char isrule, char *array,char nhoodz,
		   signed short xright,signed short color,char printer){
 signed short startx,
    lineno=0, /*no of lines needed *//*printer*/
    temp,                            /*   =0..screen only*/
    z,size,countz=0,countzz=0;       /*   =1..screen + printer/file*/
 unsigned char bytez; 		     /*   =2..unallocated*/
				     /*   =3..printer/file only*/
				     /*   =4..screen only in special box*/
			  /*isrule: 2=tot,1=rule,0=state*/

   startx=getx;
   setcolor(color);
   if (nhoodz==0 || nhoodz==-2){
      size=(signed short)ceil( (double)lineL/8);    /*bytes in CA line*/
      temp=32; /*was 64 */
      if (xright<Maxx) temp=16;
   }
   /* for totalistic code*/
   /*else if (nhoodz==-1) size=(signed short)ceil( (double)(nhood+1)/8);*/
   else if (isrule==2) size=(signed short)ceil( (double)(nhoodz+1)/8);
   else{                           /*bytes in rule table*/
      size=(signed short)ceil(pow(2,(double)nhoodz)/8);
      temp=32;
      if (printer==4 || xright<Maxx) temp=16;
   }
   for (z=size-1;z>=0;z--){
      bytez=array[z];
      countz+=1;
      countzz+=1;
      if (bytez<16) sprintf(textb[1],"0%x",bytez);
      else sprintf(textb[1],"%x",bytez);

      if ((pdata || filedata) && (printer==1 || printer==3 || printer==5)){
	 textb[0][(countzz*2)-2]=textb[1][0];
	 textb[0][(countzz*2)-1]=textb[1][1];
	 if ((countzz*2)%32==0){
	    if (printer!=3){
	       textb[0][countzz*2]='\n';
	       textb[0][countzz*2+1]='\0';
	    }
	    else textb[0][countzz*2]='\0';
	    if (filedata) save_data(textb[0]);
	    if (pdata) print_out(textb[0]);
	    if (filedata) save_data(textb[0]);
	    countzz=0;
	 }
	 else if (countzz==size){
	    textb[0][countzz*2]='\0';
	    if (pdata) print_out(textb[0]);
	    if (filedata) save_data(textb[0]);
	 }
      }
      if (printer<2 || printer==4) outtext(textb[1]);
      if (nhoodz!=-2){
	 moveto(getx+vgax(4),gety);
	 if (countz==temp || getx>xright-8){
	    moveto(startx,gety+CHeight);
	    lineno++;
	    countz=0;
	 }
      }
   }
   if (nhoodz!=-2) next_line(xtext,-lineno);
   return(lineno-1);
}

/******************** print bit line, May 93 *******************/
unsigned long print_bit_line(char *temp,unsigned short size,
	    unsigned short color,signed short cellscale,
					signed short cellsep){
 unsigned short zu;
 unsigned long decnumber=0;

   for (zu=size-1;zu!=Maxu;zu--){
      if (size<=32)
	    decnumber+=(unsigned long)(get_bit(temp,zu)*pow(2,(double)zu));
      if (get_bit(temp,zu)) setfillstyle(SOLID_FILL,color);
      else setfillstyle(SOLID_FILL,darkgray);
      bar(getx,gety,getx+cellscale-cellsep,gety+cellscale-cellsep);
      moverel(cellscale,0);
   }
   return(decnumber);
}

/********** convert bitstring to dec, max 32 bits, May 93 **************/
void dec_to_bit_line(char* bitline,
	      unsigned long decvalue, signed short size){
 signed short z,zz; /*max z=31*/
 unsigned long tempvalue;

   tempvalue=decvalue;
   for (z=size-1; z>=0; z--){
      set_bit0(bitline,z);
      zz=tempvalue/(unsigned long)(pow(2,(double)z));
      if (zz>=1) {
	 set_bit1(bitline,z);
	 tempvalue-=(unsigned long)pow(2,(double)z);
      }
   }
}

/*************** input hex in boxes, April 93 **************/
void input_hex(char nhoodz,char isrule,char *array,signed short hexbyteposl,
			signed short hexbyteposr){

 signed short
     r,test=0,incount=0,z,count,
     tempx,tempy,startx;
     
 unsigned char hexfold;

#  define showcount  { tempx=getx;\
			tempy=gety;\
			sprintf(textb[0],"hexcount=%d",incount);\
			moveto(memory_box(0)+3,3);\
			outtext(textb[0]);\
			moveto(tempx,tempy);}

   r=2*(hexbyteposl-hexbyteposr+1); /*twice string length in bytes*/
   hexfold=32; /*was 64*/
#  if __BORC__||__WATCOM__
      fflush(stdin);
#  endif
   startx=getx;
   /*keep existing hex rule table*/
   count=0;
   for (z=r/2-1;z>=0;z--){
      is[count]=(array[z]&0xf0)>>4;
      is[count+1]=array[z]&0x0f;
      count+=2;
   }
   setfillstyle(SOLID_FILL,black);
   while (1){
      if (nhoodz>5) showcount;
#     if __BORC__
	 flashing_cursor(-1,+vgay(3),CWidth,CHeight+1,green);
#     elif __WATCOM__
	 flashing_cursor(-1,+vgay(4),CWidth-1,CHeight+2,green);
#     elif __UNIX__
         flashing_cursor(0,0,0,0,-1,+vgay(3)-8,CWidth,CHeight+1-8,green);
#     endif

      test=keycheck(0);
      if (test=='q'){
	 is[0]='q';
	 return;        /*to stepback in setup*/
      }
      if (twod && !isrule){
	 /*rotate left,right,up,down*/
	 if (test=='l'|| test=='r'|| test=='u'|| test=='d'){
	    /* 0..................size*2 -1, update array*/
	    count=0;
	    for (z=hexbyteposl;z>=hexbyteposr;z--){
	       array[z]= (is[count]<<4) + is[count+1];
	       count+=2;
	    }
	    rotate_array_2d(array,test,1);
	    is[0]='r';
	    return;
	 }
      }
      else {
	 /*rotate left or right*/
	 if (test=='l' || test=='r'){
	    /* 0..................size*2 -1, update array*/
	    count=0;
	    for (z=hexbyteposl;z>=hexbyteposr;z--){
	       array[z]= (is[count]<<4) + is[count+1];
	       count+=2;
	    }
	    rotate_array(nhoodz,array,test,isrule,1);
	    is[0]='r';
	    return;
	 }
      }
      /*arrows:128+  75=left,77=right,72=up,80=down*/
      /*left arrow or back space*/
      if (test==LeftArrow || test==8){
	 if (incount>0){
	    moveto(getx-CWidth,gety);
	    if (incount%2==0) moveto(getx-CWidth,gety);
	    if (incount%hexfold==0)
		   moveto (startx+CWidth*((3*hexfold/2)-2),
					    gety-(CHeight+3));
	    incount--;
	 }
	 else if (incount==0){
	    moveto(startx+CWidth*(3*((r-1)%hexfold)/2),
			      gety+(CHeight+3)*((r-1)/hexfold));
	    incount=r-1;
	 }
	 showcount;
	 continue;
      }
      /*right arrow*/
      else if (test==RightArrow){
	 moveto(getx+CWidth,gety);
	 incount++;
	 if (incount%2==0) moveto(getx+CWidth,gety);
	 if (incount%hexfold==0) moveto(startx,gety+CHeight+3);
	 if (incount==r){
	    moveto(startx,gety-(CHeight+3)*(r/hexfold) );
	    incount=0;
	 }
	 showcount;
	 continue;
      }
      /*down arrow*/
      else if (test==DownArrow){
	 if (r-1>=incount+hexfold){
	    moveto(getx,gety+CHeight+3);
	    incount+=hexfold;
	 }
	 showcount;
	 continue;
      }
      /*up arrow*/
      else if (test==UpArrow){
	 if (incount>=hexfold){
	    moveto(getx,gety-(CHeight+3));
	    incount-=hexfold;
	 }
	 showcount;
	 continue;
      }
      else if (test==13){  /*carrage return*/
	/*fflush(stdin);*/
	 break;
      }
      else if (incount<r){
	 if (isxdigit(test)) { /*test for hex digit*/
	    sprintf(textb[0],"%c",test);
            setfillstyle(SOLID_FILL,black);
#        if __BORC__
	       bar(getx,gety,getx+CWidth,gety+CHeight);
#        elif __WATCOM__
	       bar(getx+1,gety,getx+CWidth,gety+CHeight);
#        elif __UNIX__
               bar(getx,gety,getx+CWidth,gety+CHeight);
#        endif
	    /*to avoid unever textwidth*/
	    tempx=getx;
	    tempy=gety;
	    outtext(textb[0]);
	    moveto(tempx,tempy);
	    moveto(getx+CWidth,gety);
	    if (isdigit(test)) test-=48;
	    if (islower(test)) test-=87;
	    if (isupper(test)) test-=55;
	    is[incount]=test;
	    incount++;
	    if (incount%2==0) moveto(getx+CWidth,gety);
	    if (incount%hexfold==0) moveto(startx,gety+CHeight+3);
	    if (incount==r){
	       moveto(startx,
	       gety-(CHeight+3)*(r/hexfold) );
	       incount=0;
	    }
	    showcount;
	    continue;
	 }
      }
   }
  /*0..................size*2 -1, update array*/
  count=0;
  for (z=hexbyteposl;z>=hexbyteposr;z--){
     array[z]= (is[count]<<4) + is[count+1];
     count+=2;
  }
}

/** input bit string - set/erase cells, draw with mouse, June 93 *******/
void input_string_cell(char nhoodz,char isrule,char* array,
	 unsigned short leftpos,unsigned short rightpos,
	     char stringtype,signed short cellscale,
		signed short cellsep,signed short endx,signed short endy){
 signed short tempx,tempy,startx,starty,
     gap=0,gapno=0,cellx,celly,x1,y1,x2,y2;
 unsigned short  incount,r,foldposs;
 unsigned char cellcolor,test=0;
 char outside;

#  define showbitcount {\
      tempx=getx;\
      tempy=gety;\
      sprintf(textb[0],"cell=%d,%dx%d",\
	leftpos-incount,foldposs-1-cellx,\
	  (signed short)ceil((double)r/foldposs)-1-celly);\
      moveto(memory_box(0)+3,3);\
      outtext(textb[0]);\
      moveto(tempx,tempy);\
   }

   cellx=celly=0;
   r=leftpos-rightpos+1;
   incount=0;
   if ((!twod || isrule) && r>=64) foldposs=64;
   else if (!twod && r<64) foldposs=r;
   else foldposs=i2d;

   startx=getx;
   starty=gety;

   if (isrule){
	if (!hires) gap=2;
	else gap=3;
   }
   endx-=cellscale;
   endy-=cellscale;
   if (r%foldposs!=0) endy+=cellscale;

#  if __BORC__||__WATCOM__    
      if (mouse_found){
         /*confine mouse in rectangle*/
         if (cellscale>=3){     
	    mouse_call(7,0,startx,endx+1);
	    mouse_call(8,0,starty,endy+2);
         }
	 else {
	    mouse_call(7,0,startx,endx);
	    mouse_call(8,0,starty,endy);
         }
      }
#  endif 
   while (1){
      if (nhoodz>2) showbitcount;
#     if __BORC__
	 flashing_cursor(-1,-1,
		    cellscale-cellsep+1,cellscale-cellsep+1,green);
#     elif __WATCOM__
	 flashing_cursor(-1-3,-1+2,cellscale-cellsep+1-3,
			     cellscale-cellsep+1+2,green);
#     elif __UNIX__ /*change mouse shape in rectangle*/
            if (cellscale>=3){   
               flashing_cursor(startx,endx+1,starty,endy+2,-1,-1-6,
		    cellscale-cellsep+1,cellscale-cellsep+1-6,green);
	    }
            else{
               flashing_cursor(startx,endx,starty,endy,-1,-1-6,
		    cellscale-cellsep+1,cellscale-cellsep+1-6,green);
	    }         
#     endif
     
      if (mouse_found){
	 if (button=='l'|| button=='r'){
	  startmouse:
	    button_not_rel=outside=0;

	    if (isrule) gapno=(mouse_x-startx)/(cellscale*8+gap);
	    cellx=(mouse_x-startx-(gapno*gap))/(cellscale);
	    gapno=cellx/8;
	    celly=(mouse_y-starty)/(cellscale);

	    incount=cellx+foldposs*celly;

	    /*prevent input beyond end of last partial row*/
#           if __BORC__||__WATCOM__
	       if (r>foldposs && r%foldposs!=0 && incount>r-1) outside=1;
#           elif __UNIX__
               if ((r>foldposs && r%foldposs!=0 && incount>r-1)
                    || inside_rect==0) outside=1;
#           endif
	    x1=startx+gapno*gap+cellx*cellscale;
	    y1=starty+celly*cellscale;
	    x2=x1+cellscale-cellsep;
	    y2=y1+cellscale-cellsep;

	    if (button=='l'){
	       if (!outside){
		  cellcolor=lightred;
		  set_bit1(array,leftpos-incount);
		  setfillstyle(SOLID_FILL,black);
		  bar(x1,y1,x2,y2);
	       }
	       /*check left mouse button released*/
#              if __BORC__||__WATCOM__   
	          mouse_call(6,0,0,0);
                  if (globbx==0) button_not_rel='l';
#              elif __UNIX__
                  if (!XCheckWindowEvent(D,W,ButtonReleaseMask,&Event))
                               button_not_rel='l';  
#              endif	      
	    }
	    if (button=='r'){
	       if (!outside){
		  cellcolor=darkgray;
		  set_bit0(array,leftpos-incount);
		  setfillstyle(SOLID_FILL,white);
		  bar(x1,y1,x2,y2);
	       }
	       /*check right mouse button released*/
#              if __BORC__||__WATCOM__   
	          mouse_call(6,1,0,0);
                  if (globbx==0) button_not_rel='r';
#              elif __UNIX__
                   if (!XCheckWindowEvent(D,W,ButtonReleaseMask,&Event))
                               button_not_rel='r';                  
#              endif	      
	    }
	    if (!outside){
	       setfillstyle(SOLID_FILL,cellcolor);
	       bar(x1,y1,x2,y2);
	       /*put a dot on zero cell*/
	       if (button=='r'&& cellscale>=4)
		    putpixel(x1-1+cellscale/2,y1-1+cellscale/2,green);
	    }
	    /*showbitcount;*/
	    if (button_not_rel){
#              if __BORC__||__WATCOM__   		  
                  mouse_call(3,0,0,0); /*mouse position*/
                  mouse_x=globcx;
		  mouse_y=globdx;
#              elif __UNIX__
                  if (XCheckWindowEvent(D,W,PointerMotionMask,&Event)){
                      if (Event.type == MotionNotify){
                         mouse_x=Event.xmotion.x;
                         mouse_y=Event.xmotion.y;
                          if (mouse_x>=startx && mouse_y>=starty
                               && mouse_x<=endx && mouse_y<=endy){
                             if (inside_rect==0){
                                XDefineCursor(D,W,leftCursor);
	                        inside_rect=1;
	                     }
                         }
                         else if (inside_rect==1){
                            XDefineCursor(D,W,rightCursor);
                            inside_rect=0;
                         }

                         /* show co-ordinates*/
	                 /*sprintf(textb[0],"x=%d y=%d",mouse_x,mouse_y);
	                 draw_hint_box(0,textb[0],500);*/           
                     }  
                  }
#              endif		 
	       goto startmouse;
	    }
	    moveto(x1,y1);
	    continue;
	 }
      }
      test=keycheck(0);
      if (test=='q'){
	 is[0]='q';
#        if __BORC__||__WATCOM__ /*release mouse for rectangle*/
	    mouse_call(7,0,0,getmaxx());
	    mouse_call(8,0,0,getmaxy());

#        elif __UNIX__
             XDefineCursor(D,W,rightCursor); /*restore cursor shape*/
#        endif
	 return;        /*to stepback in setup*/
      }

      if (twod && !isrule){
	 /*rotate left,right,up,down*/
	 if (test=='l'|| test=='r'|| test=='u'|| test=='d'){
	    is[0]='r';
	    rotate_array_2d(array,test,1);
	    return;
	 }
      }
      else {
	 /*rotate left or right*/
	 if (test=='l' || test=='r'){
	    is[0]='r';
	    rotate_array(nhoodz,array,test,isrule,1);
	    return;
	 }
      }
      /*arrows:128+  75=left,77=right,72=up,80=down*/
      /*left arrow or back space*/
      if (test==LeftArrow || test==8){
	 if (incount>0){
	    moveto(getx-cellscale,gety);
	    if (isrule && incount%8==0){
	       if (hires) moverel(-3,0);
	       else moverel(-2,0);
	    }
	    if (incount%foldposs==0){
	       moveto(startx+cellscale*(foldposs-1),gety-cellscale);
	       if (isrule){
		  if (hires) moverel(((foldposs/8)-1)*3,0);
		  else moverel(((foldposs/8)-1)*2,0);
	       }
	    }
	    incount--;
	 }
	 else if (incount==0){
	    moveto(startx+cellscale*((r-1)%foldposs),
	    starty+cellscale*((r-1)/foldposs) );
	    if (isrule && nhoodz>3){
	       if (hires) moverel(((foldposs/8)-1)*3,0);
	       else moverel(((foldposs/8)-1)*2,0);
	    }
	    incount=r-1;
	 }
	 showbitcount;
	 continue;
      }
      /*right arrow*/
      else if (test==RightArrow){
	 moveto(getx+cellscale,gety);
	 incount++;
	 if (isrule==1 && incount%8==0){
	    if (hires) moverel(3,0);
	    else moverel(2,0);
	 }
	 if (incount%foldposs==0) moveto(startx,gety+cellscale);
	 if (incount==r){
	    moveto(startx,starty);
	    incount=0;
	 }
	 showbitcount;
	 continue;
      }
      /*down arrow*/
      else if (test==DownArrow){
	 if (r-1>=incount+foldposs){
	    moveto(getx,gety+cellscale);
	    incount+=foldposs;
	 }
	 showbitcount;
	 continue;
      }
      /*up arrow*/
      else if (test==UpArrow){
	 if (incount>=foldposs){
	    moveto(getx,gety-cellscale);

	    incount-=foldposs;
	 }
	 showbitcount;
	 continue;
      }
      /*carrage return*/
      else if (test==13){
	 is[incount]=13;
	 /*fflush(stdin);*/
	 break;
      }
      /*test for digit*/
      if (stringtype==1 && incount<r){
	 if (isdigit(test)){
	    if (test=='1'){
	       setfillstyle(SOLID_FILL,lightred);
	       set_bit1(array,leftpos-incount);
	    }
	    else{
	       setfillstyle(SOLID_FILL,darkgray);
	       set_bit0(array,leftpos-incount);
	    }
	    bar(getx,gety,getx+cellscale-cellsep,
					  gety+cellscale-cellsep);
	    /*put a dot on zero cell*/
	    if (test=='0' && cellscale>=4)
		putpixel(getx-1+cellscale/2,gety-1+cellscale/2,green);
	    incount++;
	    moverel(cellscale,0);
	    if (isrule && incount%8 == 0){
	       if (hires) moverel(3,0);
	       else moverel(2,0);
	    }
	    if (incount%foldposs==0) moveto(startx,gety+cellscale);
	    if (incount==r){
	       moveto(startx,starty);
	       incount=0;
	    }
	 }
      }
   }
   if (mouse_found){
#     if __BORC__||__WATCOM__ 
         mouse_call(7,0,0,getmaxx());
         mouse_call(8,0,0,getmaxy());
#     elif __UNIX__
         XDefineCursor(D,W,rightCursor); /*restore cursor shape*/
#     endif
   }
}

/*********** define range of hex bytes in char array, 8 Aug 1993 *********/
void define_hex(char nhoodz,char isrule,char *array,signed short hexbyteposl,
	     signed short hexbyteposr,float thisxtext){
 signed short xbox,endx,endy,z,zz=0,size,pair,
     tempx,tempy,thisx;
 char vcount=0;
 unsigned char hexval,hexfold;

   tempx=getx;
   tempy=gety;
   get_prompt_box(9,2);
   xbox=draw_prompt_box(2);
   outtext("enter hex, arrows-move");
   if (twod && !isrule) sprintf(textb[0],"rotate-l/r/u/d, accept-ret");
   else sprintf(textb[0],"rotate-l/r, accept-ret");
   moveto(xbox,gety+CHeight);
   outtext(textb[0]);
   moveto(tempx,tempy);

   hexfold=16;
   size=hexbyteposl-hexbyteposr+1;

   next_line(thisxtext,2);
   tempx=getx;
   tempy=gety;

 redraw:
   endx=0;
   for (z=hexbyteposl;z>=hexbyteposr;z--){
      zz+=1;
      for (pair=2;pair>=1;pair--){
	 thisx=getx;
	 if (pair==2)hexval=(array[z]&0xf0)>>4;
	 else if(pair==1) hexval=array[z]&0x0f;
	 sprintf(textb[0],"%x",hexval);
	 outtext(textb[0]);
	 moveto(thisx+CWidth,gety);
      }
      moveto(thisx+CWidth*2,gety);
      if (zz%hexfold == 0){
	 endx=getx;
	 moveto(thisxtext*CWidth,gety+CHeight+3);
      }
   }
   if (endx==0) endx=getx+CWidth;
   endy=gety+CHeight+3;
   moveto(tempx,tempy);

   input_hex(nhoodz,isrule,array,hexbyteposl,hexbyteposr);
   if (is[0]=='q'){
      putimage((signed short)((float)Maxx)/2,
			   2,boximage_prompt[9],COPY_PUT);
      freeimage(boximage_prompt[9]);
      return;
   }
   if (is[0]=='r'){
      moveto(tempx,tempy);
      setfillstyle(SOLID_FILL,black);
      bar(getx,gety,endx,endy);
      is[0]=zz=endx=endy=0;
      goto redraw;
   }
   vcount=ceil( (double)size/hexfold );
   moveto(tempx,tempy+vcount*(CHeight+3));
   putimage((signed short)((float)Maxx)/2,
			   2,boximage_prompt[9],COPY_PUT);
   freeimage(boximage_prompt[9]);
}

/*********** define range of bits in char array, 13 May 1993 *********/
void define_bits(char nhoodz,char isrule,char *array,
       unsigned short leftpos,unsigned short rightpos,
				char cellscale,char cellsep){

 signed short xbox,zz=0,startx,starty,tempx,tempy,
	      foldposs,endx,endy;
 unsigned short zu,size,r;
 char vcount=0;

   tempx=getx;
   tempy=gety;
   if (mouse_found){
      get_prompt_box(9,4);
      xbox=draw_prompt_box(4);
      outtext("keyboard: 0/1-set bit, arrows-move, accept-ret");
      moveto(xbox,gety+CHeight);
      outtext("mouse: press-set bit, keep pressed-draw, release-move");
      moveto(xbox,gety+CHeight);
      outtext("mouse buttons: left-set 1, right-set 0");
   }
   else{
      get_prompt_box(9,2);
      xbox=draw_prompt_box(2);
      outtext("0/1-set bit, arrows-move");
   }
   if (twod && !isrule)
   sprintf(textb[0],"rotate-l/r/u/d, accept-ret");
   else sprintf(textb[0],"rotate-l/r, accept-ret");
   moveto(xbox,gety+CHeight);
   outtext(textb[0]);
   moveto(tempx,tempy);

   cellscale=4;
   cellsep=2;

   r=leftpos-rightpos+1;

   if ((!twod || isrule) && r>=64) foldposs=64;
   else if (!twod && r<64) foldposs=r;
   else foldposs=i2d;

   if (hires || Maxx>=800){
      cellscale=7;
      cellsep=2;
   }
   
  
    if (!isrule){
         if (hires || Maxx>=800){
            cellscale=5;
            cellsep=2;
            if (lineL>=80*80-1) cellscale=4; 
            if (lineL>=150*150-1) cellscale=3;      
	    if (lineL>=(unsigned short)(200*200-1)){
               cellscale=2;
               cellsep=1;
            }       
         }
         else{  
            cellscale=4;
            cellsep=2;
            if (lineL>=36*36-1) cellscale=3;                 
            if (lineL>=56*56-1){                      
	       cellscale=2;
	       cellsep=1;         
            }
	    if (lineL>=(unsigned short)(96*96-1)){
               cellscale=1;
               cellsep=1;
            }
         }
   }
   size=leftpos-rightpos;
   next_line(xtext,2);
   startx=getx;
   starty=gety;
   if (isrule && nhoodz<=5) foldposs=size+1;

 redraw: /*after rotation*/
   for (zu=size;zu!=Maxu;zu--){     /*draw bitstring*/
      zz+=1;
      if (get_bit(array,zu)==1) setfillstyle(SOLID_FILL,lightred);
      else setfillstyle(SOLID_FILL,darkgray);
      bar(getx,gety,getx+cellscale-cellsep,gety+cellscale-cellsep);
      /*put a dot on zero cell*/
      if (get_bit(array,zu)==0 && cellscale>=4)
	    putpixel(getx-1+cellscale/2,gety-1+cellscale/2,green);
      moverel(cellscale,0);
      if (isrule && zz%8 == 0){
	 if (hires) moverel(3,0);
	 else moverel(2,0);
      }
      if (zz%foldposs==0){
	 endx=getx;
	 moveto(xtext*CWidth,gety+cellscale);
	 vcount+=1;
      }
   }
   endy=gety;

   moveto(startx,starty);
   input_string_cell(nhoodz,isrule,array,leftpos,rightpos,1,
			 cellscale,cellsep,endx,endy);
   if (is[0]=='q'){
      putimage((signed short)((float)Maxx)/2,
			   2,boximage_prompt[9],COPY_PUT);
      freeimage(boximage_prompt[9]);
      return;
   }
   if (is[0]=='r'){
      moveto(startx,starty);
      setfillstyle(SOLID_FILL,black);
      bar(getx,gety,endx,endy);
      is[0]=zz=vcount=endx=endy=0;
      goto redraw;
   }
   if (nhoodz<=4) moveto(endx,starty);
   else {
      moveto(startx,starty+(cellscale*vcount));
      next_line(xtext,.5);
   }
   putimage((signed short)((float)Maxx)/2,
			   2,boximage_prompt[9],COPY_PUT);
   freeimage(boximage_prompt[9]);
}

/****** select bitstring from a random sequence, 12 July 93 ********/
void random_bits(char nhoodz,unsigned short blockdiam, char isrule,
		char hex, char *array, unsigned short leftpos,
			     char cellscale, char cellsep){
 signed short z,zz,sod,tempx,tempy,tempx0,tempy0,tempx1,tempy1,
	      tablemax,tablebytes,bottom_box,rbox;
 char ch,was_rotated=0,*carule_temp;
 unsigned long number;

   if (xtext==(float)vgax(50)/CWidth) rbox=vgax(330);
   else if (xtext==(float)vgax(340)/CWidth) rbox=Maxx-5;
   else rbox=(signed short)(xtext*CWidth+vgax(280));

   if (isrule==2){
      tablemax=(signed short)pow(2,(double)nhoodz)-1;
      tablebytes=(signed short)ceil(pow(2,(double)nhoodz)/8);
      if ((carule_temp=(char *)calloc(tablebytes,sizeof(char)))
			       ==NULL) outof_memory("carule_temp");
   }
#   if __BORC__||_WATCOM__
       if (cellscale<CWidth){
          cellscale=CWidth-1;
          if (hires) cellscale=CWidth-2;
          cellsep=2;
       }
#   endif
   setcolor(white);
   next_line(xtext,1);
   if (twod && !isrule)
       sprintf(textb[0],"(rotate-l/r/u/d, another-n, goback-q, accept-ret)");
   else sprintf(textb[0],"(rotate-l/r, another-n, goback-q, accept-ret)");
   myouttext(textb[0]);
   tempx0=getx;
   tempy0=gety;
   next_line(xtext,2);
   tempx1=getx;
   tempy1=gety;
   ch='n';
   while(ch=='n'){
      moveto(tempx1,tempy1);      
      if (!isrule){
         if (hires || Maxx>=800){
            cellscale=5;
            cellsep=2;
            if (lineL>=80*80-1) cellscale=4; 
            if (lineL>=150*150-1) cellscale=3;      
	    if (lineL>=(unsigned short)(200*200-1)){
               cellscale=2;
               cellsep=1;
            }       
         }
         else{  
            cellscale=4;
            cellsep=2;
            if (lineL>=36*36-1) cellscale=3;                 
            if (lineL>=56*56-1){                      
	       cellscale=2;
	       cellsep=1;         
            }
            if (lineL>=96*96-1){
               cellscale=1;
               cellsep=1;
            }
         }
      }
      /*rules/codes randomised here - if was rotated dont randomise*/
      if (blockdiam==0) print_layered_bitstring
	      (64,array,leftpos,cellscale,cellsep,
			       abs(was_rotated-1),isrule);
      else{ /*cell array randomised here*/
	 if (was_rotated==0) set_central_block(array,blockdiam);
	 print_layered_bitstring
			  (64,array,lineL-1,cellscale,cellsep,0,isrule);
      }
      was_rotated=0;
      if (leftpos<32 ){
	 next_line(xtext,1);
	 /*erase space for rule dec no*/
	 tempx=getx;
	 tempy=gety;
	 setfillstyle(SOLID_FILL,black);
	 bottom_box=gety+CHeight*3;
	 if (bottom_box>Maxy-vgay(33)) bottom_box=Maxy-vgay(33)-1;
	 /*bar(getx,gety,Maxx*4/7-1,bottom_box);*/
	 bar(getx,gety,rbox-1,bottom_box);

	 moveto(tempx,tempy);

	 number=dec_equiv(array,leftpos);
	 if (isrule==0) sprintf(textb[0]," (dec)%lu",number);
	 if (isrule==1) sprintf(textb[0]," %drule=(dec)%lu",nhoodz,number);
	 /*totalistic code*/
	 if (isrule==2) sprintf(textb[0]," %dcode=(dec)%lu",nhoodz,number);
	 outtext(textb[0]);
      }
      if ((nhoodz>5 && isrule==1)||
		     (isrule==0 && leftpos>31)) next_line(xtext,1);
      else outtext(" (hex)");
      tempx=getx;
      tempy=gety;
      if (hex){
	 /*erase space for string, rule hex no*/
	 setfillstyle(SOLID_FILL,black);
	 /*rule*/
	 if (isrule){
	    bar(getx,gety,rbox-1,gety+CHeight*4);
	    print_current_bitstring_hexbytes
			     (isrule,array,nhoodz,rbox-1,white,0);
	 }
	 /*ca state*/
	 else{
	    bottom_box=gety+CHeight*3;
	    if (bottom_box>Maxy-vgay(33)) bottom_box=Maxy-vgay(33)-1;
	    bar(getx,gety,rbox-1,bottom_box);
	    print_current_bitstring_hexbytes
				(isrule,array,0,rbox-1,white,0);
	 }
      }
      if (isrule>0){
	 z_parameter_all(nhoodz,1,array);
	 if (isrule==2){
	    /*convert code to rule*/
	    for (zz=tablemax;zz>=0;zz--){
	       sod=0;
	       for (z=nhoodz-1;z>=0;z--) sod+=get_bit(nm[z],zz);
	       set_bit(carule_temp,zz,get_bit(array,sod));
	    }
	    z_parameter_all(nhoodz,1,carule_temp);
	 }
      }
      /*for mouse*/
      moveto(tempx0,tempy0);
#     if __BORC__||__WATCOM__
	 flashing_cursor(0,CHeight-vgay(3),
			      CWidth,CHeight,green);
#     elif __UNIX__
	 flashing_cursor(0,0,0,0,0,CHeight-vgay(3)-6,
			      CWidth,CHeight-6,green);
#     endif
      if (button=='l') ch=13;
      else if (button=='r') ch='q';
      
      else{

#        if __BORC__||__WATCOM__
            ch=getch();
#        elif __UNIX__
            /*if (XQLength(D)!=0) ch=keycheck(0);*/
            if (button=='k') ch=keycheck(0);
#        endif
      }
      if (twod && !isrule){
	 /*rotate left,right,up,down*/
	 if (ch=='l'||ch=='r'|| ch=='u'|| ch=='d'){
	    rotate_array_2d(array,ch,1);
	    was_rotated=1;
	    ch='n';
	 }
      }
      else {
	 /*rotate left or right*/
	 if (ch=='l' || ch=='r'){
	    rotate_array(nhoodz,array,ch,isrule,1);
	    was_rotated=1;
	    ch='n';
	 }
      }
      if (ch=='q'){
	 is[0]='q';
	 if (isrule==2) free(carule_temp);
	 /*delete top right z parameter box*/
	 if (isrule>0) draw_box(-1,Maxx/2,vgay(27),Maxx-2,vgay(50),0,0);
	 moveto(tempx,tempy);
	 return;
      }
   }
   if (isrule==2) free(carule_temp);
   /*delete top right z parameter box*/
   if (isrule>0) draw_box(-1,Maxx/2,vgay(27),Maxx-2,vgay(50),0,0);
   moveto(tempx,tempy);
}

/****** print bit string with random central block, Jan 94 ********/
void set_central_block(char *array,unsigned short blockdiam){
 signed short ii,jj;
 unsigned short zu,poss,minvalue;

   memcpy(array,all_0s,bytesL);
   if (!twod){
      minvalue=L/2-blockdiam/2-1;
      if (minvalue==0) minvalue=Maxu;
      for (zu=L/2+blockdiam/2;zu!=minvalue;zu--)
			    set_bit(array,zu,( (myrand() % 100)/50) );
   }
   else{
      for (jj=j2d/2+blockdiam/2;jj>=j2d/2-blockdiam/2;jj--){
	 for (ii=i2d/2+blockdiam/2;ii>=i2d/2-blockdiam/2;ii--){
	    poss=i2d*jj+ii;
	    set_bit(array,poss,( (myrand() % 100)/50) );
	 }
      }
   }
}

/****** print bit string, if >foldpos start new row, 13 May 1993 ********/
void print_layered_bitstring(signed short foldpos,
	   char *array, unsigned short leftpos,
	      char thisscale,char thissep, char makerandom, char isrule){

 signed short extrabits,phantombits=0,zz=0,startx;
 unsigned short zu;

   startx=getx;
   foldpos=64; /*overrides function argument*/
   if (isrule){
      thisscale=vgax(4);
      thissep=vgax(2);
   }

   extrabits=(leftpos+1)%8;
   if (extrabits>0) phantombits=8-extrabits;

   for (zu=phantombits+leftpos;zu!=Maxu;zu--){
      zz+=1;
      if (zu>leftpos)
	      putpixel(getx-1+thisscale/2,gety-1+thisscale/2,white);
      else{
	 if (makerandom==1) set_bit(array,zu,(myrand()%100)/50);
	 if (get_bit(array,zu)==1) setfillstyle(SOLID_FILL,lightred);
	 else setfillstyle(SOLID_FILL,darkgray);
	 bar(getx,gety,getx+thisscale-thissep,
				      gety+thisscale-thissep);
	 /*put a dot on zero cell*/
	 if (get_bit(array,zu)==0 && thisscale>=4)
	     putpixel(getx-1+thisscale/2,gety-1+thisscale/2,green);
      }
      moverel(thisscale,0);
      if (isrule==1 || !twod ){
	 /*break bitstring into 8 bit chunks, extra on left*/
	 if (zz%8==0){
	    if (hires) moverel(3,0);
	    else moverel(2,0);
	 }
      }
      if (twod && !isrule){
	 if (zu%i2d==0) moveto(xtext*CWidth,gety+thisscale);
      }
      else if (zz%foldpos==0 && zu>0 && zz>8)
		       moveto(startx,gety+thisscale);
   }
}

/******** convert bit string to dec number, 13 May 1993 **********/
unsigned long dec_equiv(char *temparray, char leftpos){
 signed short z;
 unsigned long number=0;

   for (z=leftpos;z>=0;z--) number+=get_bit(temparray,z)*pow(2,z);
   return(number);
}

/******* convert bit sequence to dec number, 13 May 1993 ***********/
unsigned short dec_equiv_sound(char *temparray,
		signed short leftpos, signed short rightpos){
 signed short z;
 unsigned short number=0;

   for (z=leftpos;z>=rightpos;z--)
		   number+=get_bit(temparray,z)*pow(2,z-rightpos);
   return(number);
}
/******************* random seed, April 93 ********************/
unsigned char random_seed(unsigned char color1,
                      signed short rand_seed_percent){
  unsigned short zu1,bitno,Hamm;
  char *firstA, *compA, *firstcompA, bit;
  signed short ii,jj;

   if (ncolor==0){
      if (color1==white) color1=yellow;
      else if (color1==yellow) color1=white;
   }

   if (rand_seed_percent==100){
      if (diff_plot){
	 if (!twod){
            for (zu1=lineL/2-1;zu1!=Maxu;zu1--){ 
               bit=(myrand()%100)/50;
               set_bit(A,zu1,bit);
               set_bit(A,zu1+lineL/2,bit);
            }
         }
         else{
            for (jj=j2d-1;jj>=0;jj--){
	       for (ii=i2d/2-1;ii>=0;ii--){
                  bit=(myrand()%100)/50;
                  set_bit(A,jj*i2d+i2d/2+ii,bit);
                  set_bit(A,jj*i2d+ii,bit); 
	       }		        
            }
	 }
      }
      else{   
         for (zu1=L;zu1!=Maxu;zu1--) 
               set_bit(A,zu1,(myrand()%100)/50);
      }
   }
   else{
      Hamm=lineL* ((float)rand_seed_percent/100);
      if ((firstA=(char*)calloc(bytesL,sizeof(char)))
				    ==NULL) outof_memory(textb[0]);      
      if ((compA=(char*)calloc(bytesL,sizeof(char)))
				    ==NULL) outof_memory(textb[0]);     
      if ((firstcompA=(char*)calloc(bytesL,sizeof(char)))
				    ==NULL) outof_memory(textb[0]);
      /*flip bits if Hamm <= lineL/2, similar to  Derrida plot*/               
      if (Hamm<=lineL/2){                               
          bitno=0;
          memcpy(firstA,A,bytesL);   
          while(1){
             bitno+=1;
             zu1=myrand()%lineL; 
             /*flip a bit at random position*/
             set_bit(A,zu1,abs(get_bit(A,zu1)-1));
             /*restore flip if not different*/
             if (get_bit(A,zu1)==get_bit(firstA,zu1)){ 
                             set_bit(A,zu1,abs(get_bit(A,zu1)-1));
                             bitno-=1;
             }                                                
             if (bitno==Hamm) break;
          } 	           
       }
       else if (Hamm>=lineL/2+1){
          /*restore bits in compliment if Hamm >= lineL/2 + 1*/  
          for (zu1=L;zu1!=Maxu;zu1--) 
                  set_bit(compA,zu1,abs(get_bit(A,zu1)-1));         
          memcpy(firstcompA,compA,bytesL);
          bitno=0;
          while(1){
             if (Hamm==lineL) break;
             bitno+=1;
             zu1=myrand()%lineL; 
             /*flip a bit at random position in compliment*/
             set_bit(compA,zu1,abs(get_bit(compA,zu1)-1))
             /*restore flip*/
	     if (get_bit(compA,zu1)==get_bit(firstcompA,zu1)){
                set_bit(compA,zu1,abs(get_bit(compA,zu1)-1));
                bitno-=1;
             }
             if (bitno==lineL-Hamm) break;
          } 	           
          memcpy(A,compA,bytesL);                    
       }
       free(firstA);
       free(compA);
       free(firstcompA);                   
   }
   seed_was_set=1;
   return(color1);
}

/********** random bitflip in current state, March 94 ***********/
unsigned char random_bitflip_state(unsigned char color1){
 unsigned short z;

   if (ncolor==0){
     if (color1==white) color1=yellow;
     else if (color1==yellow) color1=white;
   }
   z=myrand()%lineL;
   set_bit(A,z,abs(get_bit(A,z)-1));
   seed_was_set=1;
   return(color1);
}

/******************* random block, April 93 ********************/
unsigned char random_block(signed short blockdiam,unsigned char color1){
 signed short ii,jj;
 unsigned short z,poss;

   if (ncolor==0){
      if (color1==white) color1=yellow;
      else if (color1==yellow) color1=white;
   }
   memcpy(A,all_0s,bytesL);/*set all bits to 0*/
   

   if (!twod){
      for (z=L/2+blockdiam/2;z>=L/2-blockdiam/2;z--)
		       set_bit(A,z,( (myrand() % 100)/50) );
      }
      else{
	 for (jj=j2d/2+blockdiam/2;jj>=j2d/2-blockdiam/2;jj--){
	    for (ii=i2d/2+blockdiam/2;ii>=i2d/2-blockdiam/2;ii--){
		poss=i2d*jj+ii;
		set_bit(A,poss,( (myrand() % 100)/50) );
	    }
	 }
      }
      seed_was_set=1;
      return(color1);
}

/**************** singleton, April 93 *****************************/
unsigned char singleton_seed(unsigned char color1){

   if (ncolor==0){
      if (color1==white) color1=yellow;
      else if (color1==yellow) color1=white;
   }
   memcpy(A,all_0s,bytesL);/*set all bits to 0*/
   
   set_bit1(A,L/2);
   seed_was_set=1;
   return(color1);
}
/**************** negative singleton, Oct 93 ************************/
unsigned char singleton_neg_seed(unsigned char color1){
 unsigned short z;

   if (ncolor==0){
      if (color1==white) color1=yellow;
      else if (color1==yellow) color1=white;
   }
   memset(A, 255, bytesL);/*set all bits to 1*/
 
   /*set exess bits to 0*/
   for (z=L+1;z<=bytesL*8-1;z++) set_bit0(all_1s,z);
   set_bit0(A,L/2);
   seed_was_set=1;
   return(color1);
}

/******* flip rule table bit, random, all 0s, all 1s, April 93 *******/
unsigned char bit_flip(char what,unsigned char color1){
 signed short temp,z,zz,poss,tempx,tempy,
	      tablemax,fliptable,counter;
 float ztemp;

#  define remember_flippos {\
	if (direction=='f' && limitcheck==0 && !rulemix){\
	   bitflipcount+=1;\
	   sprintf(textb[0],"flipppos");\
	   if( (flippos =(signed short*)\
	      realloc(flippos,sizeof(signed short)*(bitflipcount+1)))==NULL)\
		   outof_memory(textb[0]);\
	   flippos[bitflipcount]=temp;\
	}\
   }

   if (rulemix) poss=L;
   else poss=0;
   /*if (nhood_mixed) flipnhood=nhoodm[0];*/
   fliptable= (signed short)pow(2,(double)nhood);
   if (ncolor==0){
      if (color1==white) color1=yellow;
      else if (color1==yellow) color1=white;
   }
   switch(what){
      case 'r': /*new random rule or rules*/
	 for (z=0;z<=poss;z++){
	    if (nhood_mixed)
	               fliptable=(signed short)pow(2,(double)nhoodm[z]);
	    for (zz=0;zz<=fliptable-1;zz++)
		  set_bit(carule[z],zz,myrand()%2);/*(myrand() % 100)/50)*/
	 }
	 /*reset flippos*/
	 if (direction=='f' && limitcheck==0 && !rulemix) bitflipcount=-1;
	 remember_flippos;
	 break;
      case '1':
	 for (z=0;z<=poss;z++){
	    if (nhood_mixed)
		   fliptable=(signed short)pow(2,(double)nhoodm[z]);
	    temp=myrand() % fliptable; /*random bit flip*/
	    set_bit(carule[z],temp,abs(get_bit(carule[z],temp)-1));
	 }
	 remember_flippos;
	 break;
       case 'w':   /*flip all 1s bit (white)*/
	 for (z=0;z<=poss;z++){
	    if (nhood_mixed)
		   fliptable=(signed short)pow(2,(double)nhoodm[z]);
	    temp=fliptable-1;
	    set_bit(carule[z],temp,abs(get_bit(carule[z],temp)-1));
	 }
	 break;
      case 'W':   /*force all 1s bit to 1 (white)*/
	 for (z=0;z<=poss;z++){
	    if (nhood_mixed)
		   fliptable=(signed short)pow(2,(double)nhoodm[z]);
	    temp=fliptable-1;
	    if (get_bit(carule[z],temp)==0) set_bit1(carule[z],temp);
	 }
	 break;
      case 'b':   /*flip all 0s bit (black)*/
	 for (z=0;z<=poss;z++){
	    set_bit(carule[z],0,abs(get_bit(carule[z],0)-1));
	 }
	 break;
      case 'B':   /*force all 0s bit to 0 (black)*/
	 for (z=0;z<=poss;z++){
	    if (get_bit(carule[z],0)==1) set_bit0(carule[z],0);
	 }
	 break;
      case 'Z':   /*higher z, not done if rulemix*/
	 counter=0;
	 ztemp=zparam[0];
	 changebit1:
	 counter+=1;
	 temp= myrand() % fliptable; /*random bit flip*/
	 set_bit(carule[0],temp,abs(get_bit(carule[0],temp)-1));
	 z_parameter_all(nhood,1,carule[0]);
	 if (zparam[0]<ztemp){
	    /*flip back*/
	    set_bit(carule[0],temp,abs(get_bit(carule[0],temp)-1));
	    /*flip another*/
	    if (counter<200) goto changebit1;
	 }
	 remember_flippos;
	 break;
      case 'z':   /*lower z, not done if rulemix*/
	 counter=0;
	 ztemp=zparam[0];
	 changebit2:
	 counter+=1;
	 temp= myrand() % fliptable; /*random bit flip*/
	 set_bit(carule[0],temp,abs(get_bit(carule[0],temp)-1));
	 z_parameter_all(nhood,1,carule[0]);
	 if (zparam[0]>ztemp){
	    /*flip back*/
	    set_bit(carule[0],temp,abs(get_bit(carule[0],temp)-1));
	    /*flip another*/
	    if (counter<200) goto changebit2;
	 }
	 remember_flippos;
	 break;
   }
   if (direction=='f' && limitcheck==0 && !rulemix){
      tempx=getx;
      tempy=gety;
      z_parameter_all(nhood,0,carule[0]);
      draw_prompt_box(1);

      if (what=='1'){
	sprintf(textb[0],"bit-flip at pos %d, flip=%d, ",
				          temp,bitflipcount);
	outtext(textb[0]);
      }
      sprintf(textb[0],"Z=%g ",zparam[0]);
      outtext(textb[0]);
      if (nhood<=3){
	 tablemax= (signed short)pow(2,(double)nhood)-1;
	 sprintf(textb[0],"rule%d=%lu,",nhood,dec_equiv(carule[0],tablemax));
	 outtext(textb[0]);
      }

      if (nhood<=5){
	 outtext("hex=");
	 print_current_bitstring_hexbytes(0,carule[0],nhood,Maxx,white,0);
      }
      moveto(tempx,tempy);
      setcolor(color1);
   }
   return(color1);
}

/*******************************************************/
unsigned char bit_flipback(unsigned char color1){
 signed short tempx,tempy,tablemax;

   if (bitflipcount>=1 && direction=='f' && limitcheck==0 && !rulemix) {
      if (ncolor==0){
	 if (color1==white) color1=yellow;
	 else if (color1==yellow) color1=white;
      }
      set_bit(carule[0],flippos[bitflipcount],abs(get_bit(carule[0],
				     flippos[bitflipcount])-1 ));
      bitflipcount-=1;
      tempx=getx;
      tempy=gety;
      z_parameter_all(nhood,0,carule[0]);
      draw_prompt_box(1);
      sprintf(textb[0],"flip back at pos %d, flip=%d, Z=%g",
			   flippos[bitflipcount],bitflipcount,zparam[0]);
      outtext(textb[0]);
      if (nhood<=3){
	 tablemax= (signed short)pow(2,(double)nhood)-1;
	 sprintf(textb[0],",rule%d=%lu",nhood,dec_equiv(carule[0],tablemax));
	 outtext(textb[0]);
      }
      if (nhood<=5){
	 outtext(",hex=");
	 print_current_bitstring_hexbytes(0,carule[0],nhood,Maxx,white,0);
      }
      moveto(tempx,tempy);
      setcolor(color1);
      /*re-allocate mem*/
      if (bitflipcount>0){
	 sprintf(textb[0],"flippos");
	 if( (flippos =(signed short*) realloc
		(flippos,sizeof(signed short)*(bitflipcount+1)))
					==NULL) outof_memory(textb[0]);
      }
   }
   return(color1);
}
/****************** turn vga x coord to general coord******************/
#if __BORC__||__WATCOM__
signed short vgax(signed short xcoord){
 signed short genx;

   genx=(signed short) (xcoord *((float)(getmaxx()+1)/640));
   return(genx);
}
#endif
/********* turn vga x coord to general coord*************/
#if __BORC__||__WATCOM__
signed short vgay(signed short ycoord){
 signed short geny;

   geny=(signed short) (ycoord *((float)(getmaxy()+1)/480));
   return(geny);
}
#endif
/********************************************************/
char final_quit(void){

   if (is[0]=='q'){
      if (nowscrolling==1){
	 memory_box(1);
	 freeimage(stpimage);
	 nowscrolling=0;
      }
      memory_box(1);
      outof_memory("?");
   }
   return(1);
}

/******************************************************/
void myouttext(char *string){ /*more acurate string length, borlandc*/
#if __BORC__
 signed short textx,texty;
      textx=getx,texty=gety;
      outtext(string);
      moveto(textx+(signed short)((float)
	 strlen(string)*(float)CWidth*.99 ),texty);
#elif __WATCOM__||__UNIX__
      outtext(string);
#endif
}

/******************************************************/
void outof_memory(char *what){
   signed short tempx,tempy,temp;
   unsigned char tempcolor;

   setcolor(white);

   tempx=getx;
   tempy=gety;
  start:
   temp=CWidth*52;
   draw_box(-1,2,2,temp,CHeight*3+vgay(6),1,0);
   sprintf(textb[1]," not enough memory for %s", what);
   sprintf(textb[2]," image:print/save-p/s, options-o");
   sprintf(textb[3]," return to Exit");

   moveto(3,3);
   outtext(textb[1]);
   moveto(3,gety+CHeight);
   myouttext(textb[2]);
   moveto(3,gety+CHeight);
   myouttext(textb[3]);
   memory_box(1);
#  if __BORC__||__WATCOM__
      is[0]=getch();
#  elif __UNIX__
      /*if (XQLength(D)!=0) is[0]=keycheck(0);*/
      input_string(1,0);
 #  endif
   switch (is[0]){
      case 'p':
	 if (!stp){
	    tempcolor=getcolor();
	    setcolor(red);
	    rectangle(0,0,getmaxx(),getmaxy());
	    setcolor(tempcolor);
	 }
#        if __BORC__||__WATCOM__
	    printimage('L',0,0,0,0,getmaxx(),getmaxy());
#        elif __UNIX__
            printimage();
#        endif
	 goto start;
      case 's':
	 save_screen();
	 goto start;
      case 'o':
	 if (nhood && !rulemix){
	    print_rule_in_box(2,carule[0]);
	    if (rulemix==0){
	       /*show Z parameter*/
	       z_parameter_all(nhood,0,carule[0]);
	       show_rule_bottom(nhood,0,carule[0],0);
	    }
	 }
	 break;
   }
   moveto(tempx,tempy);
   exit(1);  /* terminate program if out of memory */
}

/********** calculate canalizing inputs, Feb 95 *********************/
char canalyzing(char nhoodz,char showz,char* thisrule){

 char binv,
      thiscanal,
      output;
 signed short z,zz,
	      firstcount,
	      tablemax,
	      tempx,tempy;

   /*
   nm[nhood index][rule table index]|allocated and freed in main
   canal[nhood index]               |free_mem_nhood_matrix(char thisnhood)
   */
   canaltotal=0;
   tablemax=(signed short)pow(2,(double)nhoodz)-1;
   for (z=0;z<=1;z++) canal[z]=0;/*sell all bits in 2 bytes to 0*/

   for (z=0;z<=nhoodz-1;z++){
      for (binv=0;binv<=1;binv++){
	 firstcount=tablemax;
	 thiscanal=1;
	 for (zz=0;zz<=tablemax;zz++){
	    if (get_bit(nm[z],zz)==binv){   /*first binv found*/
	       if (zz<firstcount){
		  output=get_bit(thisrule,zz); /*note output*/
		  firstcount=zz;               /*note rule table index*/
	       }
	       else if (get_bit(thisrule,zz)!=output){
		  thiscanal=0;
		  break;
	       }
	    }
	 }
	 if (thiscanal){
	    set_bit1(canal,z);/*set bit to 1*/
	    canaltotal+=1;
	    break;
	 }
      }
   }
   if (showz){
      tempx=getx;
      tempy=gety;
      draw_prompt_box(1);
      sprintf(textb[0],"C=%d/%d",canaltotal,nhoodz);
      myouttext(textb[0]);
      if (canaltotal && nhoodz>1){
	 myouttext("=");
	 for (z=nhoodz-1;z>=0;z--){
	    if (get_bit(canal,z)==1){
	       sprintf(textb[0],"%d",z);
	       myouttext(textb[0]);
	    }
	    else myouttext("*");
	 }
      }
      moveto(tempx,tempy);
   }
   return(output);
}

/***************** Z param for nhoods 1-9, June 93 *********************/
void z_parameter_all(char nhoodz,char showz,char* thisrule){
 float *ln,*notln,temp,onecount;
 signed short *ncount,
     tuple,tup,not,tablemax,tablebytes,i,x,y,z,
     revtable,q,sod,tempx,tempy;
 char *temprule,
      *revrule; /*for re-aranging bits from right to left <--*/

  tempx=getx;
  tempy=gety;
  tablemax=(signed short)pow(2,(double)nhoodz)-1;
  tablebytes=(signed short)ceil(((double)tablemax+1)/8);
  sprintf(textb[0],"ln");
  if ((ln=(float*)calloc(nhoodz+1,sizeof(float)))==NULL)
						outof_memory(textb[0]);
  sprintf(textb[0],"notln");
  if ((notln=(float*)calloc(nhoodz+2,sizeof(float)))==NULL)
						outof_memory(textb[0]);
  sprintf(textb[0],"ncount");
  if ((ncount=(signed short*)calloc(nhoodz+1,sizeof(signed short)))==NULL)
						outof_memory(textb[0]);
  /*to hold rule for standard left-> right algorithm*/
  sprintf(textb[0],"temprule");
  if ((temprule=(char *)calloc(tablebytes,sizeof(char)))==NULL)
						outof_memory(textb[0]);

  /*re-arange rule table for zparam right to left <--
  by positioning acc to reflected nhoods, this allows calc of
  Z-right by same method as Z-left, ie take the nhood=3 rule table...

  left->right

  7  6  5  4  3  2  1  0   rule table index= dec nhoods
  :  :  :  :  :  :  :  :

  1  1  1  1  0  0  0  0 ..2  nhood index
  1  1  0  0  1  1  0  0 ..1
  1  0  1  0  1  0  1  0 ..0

  *  *  *  *  *  *  *  * ..outputs
  _  _  _  _  _  _  _  _
  \__/  \__/  \__/  \__/ ..deterministic permutation templates
  ____  ____  ____  ____
    \____/      \____/   ..ignore 0
  __________  __________
       \__________/      ..ignore 0,1


  left<-right

  7  6  5  4  3  2  1  0   same rule table index
  7  3  5  1  6  2  4  0   reflected nhoods
  :  :  :  :  :  :  :  :

  1  0  1  0  1  0  1  0 ..2  nhood index
  1  1  0  1  1  1  0  0 ..1
  1  1  1  1  0  0  0  0 ..0

  *  *  *  *  *  *  *  * ..outputs
  _  _  _  _  _  _  _  _
  \__/  \__/  \__/  \__/ ..deterministic permutation templates
  ____  ____  ____  ____
    \____/      \____/   ..ignore 2
  __________  __________
       \__________/      ..ignore 2,1

  */
  if ((revrule=(char *)calloc(tablebytes,sizeof(char)))==NULL)
						outof_memory(textb[0]);
  for (i=tablemax;i>=0;i--){
     revtable=0;
     sod=i;
     for (q=nhoodz-1;q>=0;q--){
	if (sod/(signed short)pow(2,(float)q)==1){
	   revtable+=(signed short)pow(2,(float)(nhoodz-1-q));
	   sod-=(signed short)pow(2,(float)q);
	}
     }
     set_bit(revrule,i,get_bit(thisrule,revtable));
  }
  setcolor(lightred);
  notln[nhoodz+1]=1;
  /*z=1..left->right, z=2 equivelent to left<-right*/
  for (z=1;z<=2;z++){
     /*print details*/
     /*if (z==2) moveto(vgax(50),gety+CHeight);
     sprintf(textb[0],"z%d: ",z);
     outtext(textb[0]);*/
     if (z==1) memcpy(temprule,thisrule,tablebytes);
     if (z==2) memcpy(temprule,revrule,tablebytes);
     tuple=2;/*size of template 2,4,8,16,....*/
     /*count template matches*/
     for (tup=1;tuple<=(tablemax+1)/2;tup++){
	tuple=(signed short)pow(2,(double)tup);
	/*for template size 4,8,16,...*/
	for (x=0;x<=tablemax+1-tuple;x+=tuple) {
	   if (tup>1 && nhoodz>2){
	      for (y=1;y<=(tuple/2)-1;y++){
		 if (get_bit(temprule,x)!=get_bit(temprule,x+y)) goto skip1;
		 if (get_bit(temprule,x+tuple/2)!=
				get_bit(temprule,x+(tuple/2)+y)) goto skip1;
	      }
	   }
	   /*for template size 2*/
	   if (get_bit(temprule,x)==get_bit(temprule,x+tuple/2)) goto skip1;
	   /*count of template matches*/
	   ncount[nhoodz-(tup-1)]+=1;
	   skip1:;
	}
	/*print details*/
	/*sprintf(textb[0],"n%d=",nhoodz-(tup-1));
	outtext(textb[0]);
	if (getx>Maxx-30) moveto(vgax(50),gety+CHeight);*/

	/*prob det = (count/max count) * not prob before*/
	ln[nhoodz-(tup-1)]=((float)ncount[nhoodz-(tup-1)]
		       /((tablemax+1)/tuple))*notln[nhoodz-(tup-2)];
	/*print details*/
	/*sprintf(textb[0],"%d/%d=%.3g,",ncount[nhoodz-(tup-1)],
			   (tablemax+1)/tuple,ln[nhoodz-(tup-1)]);
	outtext(textb[0]);
	if (getx>Maxx-30) moveto(vgax(50),gety+CHeight);*/

	/*calc not prob*/
	temp=0;
	for (not=1;not<=tup;not++){
	   temp+=ln[nhoodz-(not-1)];
	}
	notln[nhoodz-(tup-1)]=1-temp;

	/*print details*/
	/*sprintf(textb[0],"not%d=%.3g;",tup,notln[nhoodz-(tup-1)]);
	outtext(textb[0]);
	if (getx>Maxx-30) moveto(vgax(50),gety+CHeight);*/

     }
     zparam[z]=0;
     for (i=nhoodz;i>=1;i--) zparam[z]+=ln[i];
     for (i=nhoodz;i>=1;i--){
	ncount[i]=0;
	ln[i]=0;
	notln[i]=0;
     }
  }
  /*print details*/
  if (zparam[1]>zparam[2]) zparam[0]=zparam[1];
  else zparam[0]=zparam[2];
  onecount=0;
  for (x=0; x<=tablemax; x++) {
	if (get_bit(thisrule,x)==1) onecount=onecount+1;
  }
  if (onecount<=(tablemax+1)/2) lratio = onecount/((tablemax+1)/2);
  else lratio=(tablemax+1-onecount)/((tablemax+1)/2);
  lambda=onecount/(tablemax+1);
  /*calculate canalyzing inputs*/
  canalyzing(nhoodz,0,thisrule);
  if (showz){
	draw_box(-1,Maxx/2,vgay(27),Maxx-2,vgay(50),1,0);
	moveto(Maxx/2+vgax(3),vgay(29));
	/*show canalyzing inputs */
	sprintf(textb[0],"C=%d/%d",canaltotal,nhoodz);
	myouttext(textb[0]);
	if (canaltotal && nhoodz>1){
	   myouttext("=");
	   for (z=nhoodz-1;z>=0;z--){
	      if (get_bit(canal,z)==1){
		 sprintf(textb[0],"%d",z);
		 myouttext(textb[0]);
	      }
	      else myouttext("*");
	   }
	}
	myouttext("  ");

	/*show Z and lambda*/
	sprintf(textb[0],"z->=%g z<-=%g",zparam[1],zparam[2]);
	sprintf(textb[1],"lda=%g",lambda);
	sprintf(textb[2]," lda-ratio=%g P=%g z-param=%g",
			    lratio,.5+(1.0-lratio)/2,zparam[0]);

	outtext(textb[0]);
	moveto(Maxx/2+vgax(3),gety+CHeight);
	outtext(textb[1]);
	outtext(textb[2]);
  }
  setcolor(white);
  free(ln);
  free(notln);
  free(ncount);
  free(temprule);
  free(revrule);
  moveto(tempx,tempy);
}

/***** set one bit in long char array at position pos, 5 Aug 1993 *******/
void set_bitlong(register char *array,
       register unsigned long pos,register char bit){

   if (bit) array[pos/8] |= 1<<pos%8;
   else array[pos/8] &= ~(1<<pos%8);
   /*
   if (bit) array[pos>>3] |= 1<<(pos&7);
   else array[pos>>3] &= ~(1<<(pos&7));
   */
}

/**** get one bit from long char array at position pos, 5 Aug 1993 ******/
char get_bitlong(register char *array,register unsigned long pos){

   return((array[pos/8]>>pos%8) & 1);
   /*
   return((array[pos>>3]>>(pos&7)) & 1);
   */
}

/***** rotate bytesL bits in char array by rotinterval, 13 May 1993 *****/
char* rotate_array(char nhoodz,char *array, char direction,
			 char isrule, signed short rotinterval){
 signed short sizeA,bytesA,z,z1;
 char *lastbit,endbit;

     if (!isrule){
	sizeA=lineL;
	bytesA=bytesL;

     }
     else {
	if (isrule==1){
	   sizeA=(signed short)pow(2,(double)nhoodz);
	   bytesA=(signed short)ceil(pow(2,(double)nhoodz)/8);
	}
	else{ /*for totalistic code, isrule=2*/
	   sizeA=nhoodz+1;
	   bytesA=(signed short)ceil((double)(nhoodz+1)/8);
	}
     }
     /*
     moveto(memory_box(0)+2,2);
     sprintf(textb[0],"ir=%d sA=%d bA=%d",isrule,sizeA,bytesA);
     outtext(textb[0]);
     getch();
     */

     sprintf(textb[0],"lastbit");
     if ((lastbit=(char*)calloc(bytesA,sizeof(char)))
				    ==NULL) outof_memory(textb[0]);

	  /*   very
	     L,lastbit       lastbit  0
	       |      |        |      |
	     --------|--------|--------|--------  ......array
		    3        2        1        0  ......bytesL

	       <--rotate 1 bit * rotinterval

	       on each rotation save last bit in each byte,
	       (or very last bit) in lastbit[]. Put this bit
	       at the start of the next byte (very last bit
	       at the start of first byte).                   */


     for (z1=1;z1<=rotinterval;z1++){
	switch(direction){
	   case 'l':
	      lastbit[bytesA-1]=get_bit(array,sizeA-1); /*save very last bit*/
	      /*set very last bit to 0, as it will be << */
	      set_bit0(array,sizeA-1);
	      /*save last bit in each byte*/
	      for (z=bytesA-2;z>=0;z--) lastbit[z]= array[z]>>7;
	      for (z=0;z<=bytesA-1;z++){
		 array[z]=array[z] << 1;  /*shift each byte 1 to left*/
		 /*put very last bit at start*/
		 if (z==0){
		    if (lastbit[bytesA-1]) array[z]+=1;
		 }
		 /*put last bit at start of next byte*/
		 else if (lastbit[z-1]) array[z]+=1;
	      }
	      break;

	   case 'r':
	   /*rotate right, endbit=right*/
	   endbit=get_bit(array,0);
	   for (z=0;z<=sizeA-2;z++){
	      set_bit(array,z,get_bit(array,z+1));
	   }
	   set_bit(array,sizeA-1,endbit);
	   break;
	}
     }
     free(lastbit);
     return(array);
}

/***** rotate bytesL bits in char array by rotinterval, 13 May 1993 *****/
char* rotate_array_2d(char *array,
			 char direction,signed short rotinterval){

 signed short z1,ii,jj;
 unsigned short ipos,jpos;
 char endbit;

   for (z1=1;z1<=rotinterval;z1++){
      switch(direction){
	case 'l':
	   /*rotate left, endbit=left*/
	   for (jj=j2d-1;jj>=0;jj--){
	      endbit=get_bit(array,i2d-1+i2d*jj);
	      for (ii=i2d-1;ii>=1;ii--){
		  ipos=ii+i2d*jj;
		  set_bit(array,ipos,get_bit(array,ipos-1));
	      }
	      set_bit(array,i2d*jj,endbit);
	   }
	   break;
	case 'r':
	   /*rotate right, endbit=right*/
	   for (jj=j2d-1;jj>=0;jj--){
	      endbit=get_bit(array,i2d*jj);
	      for (ii=0;ii<=i2d-2;ii++){
		  ipos=ii+i2d*jj;
		  set_bit(array,ipos,get_bit(array,ipos+1));
	      }
	      set_bit(array,i2d-1+i2d*jj,endbit);
	   }
	   break;
	case 'u':
	   /*rotate up, endbit=top*/
	   for (ii=i2d-1;ii>=0;ii--){
	      endbit=get_bit(array,ii+i2d*(j2d-1));
	      for (jj=j2d-1;jj>=1;jj--){
		 jpos=ii+i2d*jj;
		 set_bit(array,jpos,get_bit(array,jpos-i2d));
	      }
	      set_bit(array,ii,endbit);
	   }
	   break;
	case 'd':
	   /*rotate down, endbit=bottom*/
	   for (ii=i2d-1;ii>=0;ii--){
	      endbit=get_bit(array,ii);
	      for (jj=0;jj<=j2d-2;jj++){
		 jpos=ii+i2d*jj;
		 set_bit(array,jpos,get_bit(array,jpos+i2d));

	      }
	      set_bit(array,ii+i2d*(j2d-1),endbit);
	   }
	   break;
      }
   }
   return(array);
}

/********* rotation equivelents in attractor cycle, 13 May 93 ************/
signed short rot_cycle_equiv(register char *array){

 signed short z,z0,repseg;

 /* 	given 1 cycle state and period.
	computes 1. segment repeats.
		 2. equivalent cycle states.
		 3. no of equivalent basins=repseg/cyclematch */

   /*length of repeating segments in circular bit string*/
   repseg=repeating_seg(array);

   /*check no of occurances of rotation equivalents in cycle*/
   cyclematch=1;
   memcpy(rot,array,bytesL);
   for (z=2;z<=attperiod;z++){
      for (z0=1;z0<=repseg;z0++){
	 if (z0!=1){ /*miss out first=same*/
	    /*if repeat found*/
	    if (memcmp(att[z],rot,bytesL)==0) cyclematch+=1;
	 }
	 rotate_array(nhood,rot,'l',0,1);
      }
   }
   return(cyclematch);
}

/********* rotation equivelents in 2-d attractor cycle, Oct 1994 ************/
char rot_cycle_equiv_2d(register char *array){

 signed short z,z0,diag;
 char hv_rot_equal=0;

   repeating_seg_2d(array);
   if (/*i2d==j2d &&*/ repseg_2d[0]>1 && repseg_2d[1]>1)
				    hv_rot_equal=trans_sym_2d(array);
   /*
   if (repseg_2d[0]>1 && repseg_2d[1]>1
		   && (repseg_2d[0]==i2d || repseg_2d[1]==j2d))
				    hv_rot_equal=trans_sym_2d(array);
   */
   cyclematch_2d[0]=1;/*horizontal rotations*/
   cyclematch_2d[1]=1;/*vertical rotations*/


   memcpy(rot,array,bytesL);
   for (z=2;z<=attperiod;z++){
      for (z0=1;z0<=repseg_2d[0];z0++){
	 if (z0!=1){ /*miss out first=same*/
	    /*if repeat found */
	    if (memcmp(att[z],rot,bytesL)==0) cyclematch_2d[0]+=1;
	 }
	 rotate_array_2d(rot,'l',1);
     }
   }

   memcpy(rot,array,bytesL);
   for (z=2;z<=attperiod;z++){
      for (z0=1;z0<=repseg_2d[1];z0++){
	 if (z0!=1){ /*miss out first=same*/
	    /*if repeat found*/
	    if (memcmp(att[z],rot,bytesL)==0) cyclematch_2d[1]+=1;
	 }
	 rotate_array_2d(rot,'u',1);
      }
   }

   /*if square grid, check diagonal pos and neg, ie / and \ */
   cyclematch_2d_diag[0]=0;
   cyclematch_2d_diag[1]=0;

   if (hv_rot_equal==0 && i2d==j2d
    && repseg_2d[0]>1 && repseg_2d[0]==repseg_2d[1]
     && !(cyclematch_2d[0]==(unsigned short)repseg_2d[0] 
        || cyclematch_2d[1]==(unsigned short)repseg_2d[1])){

      for (diag=0;diag<=1;diag++){
	 memcpy(rot,array,bytesL);
	 cyclematch_2d_diag[diag]=1;
	 for (z=2;z<=attperiod;z++){
	    for (z0=1;z0<=repseg_2d[0];z0++){
	       /*
	       memory_box(0);
	       moveto((signed short)((float)Maxx)/3+2,4);
	       print_current_state_twod(att[z],white);
	       moveto(getx+15,4);
	       print_current_state_twod(rot,white);
	       */
	       if (z0!=1){ /*miss out first=same*/
		  /*if repeat found*/
		  if (memcmp(att[z],rot,bytesL)==0)

		  cyclematch_2d_diag[diag]+=1;
		  /*
		  sprintf(textb[0],"dg[%d]=%d",
				  diag,cyclematch_2d_diag[diag]);

		  moveto(getx+15, 2);
		  outtext(textb[0]);
		  */
	       }
	       /*getch();*/

	       if (diag==0) rotate_array_2d(rot,'r',1);
	       else rotate_array_2d(rot,'l',1);
	       rotate_array_2d(rot,'u',1);
	    }
	 }
       }
       if (cyclematch_2d_diag[0]!=(unsigned short)repseg_2d[0]) 
                                           cyclematch_2d_diag[0]=0;
       if (cyclematch_2d_diag[1]!=(unsigned short)repseg_2d[0]) 
                                           cyclematch_2d_diag[1]=0;
   }
   return(hv_rot_equal);
}

/************ computes segment repeats in state, 13 May 93 *************/
signed short repeating_seg(register char *array){

 unsigned short z,

   rotmatch=0,/*degree of rot sym in bit hoop, max=lineL, min=1*/
   repseg=0;/*length of repeating segments in bit hoop (lineL/rotmatch)*/

   memcpy(rot,array,bytesL);
   rotmatch=1;
   for (z=0;z<=L;z++){
      if (z!=0){  /*miss out first=same*/
	 /*if repeat found*/
	 if (memcmp(rot,array,bytesL)==0) rotmatch+=1;
      }
      rotate_array(nhood,rot,'l',0,1);
   }
   repseg=lineL/rotmatch; /*min length of repeating segments         */
			  /*all 0s,1s, ..repseg=1,  01,01..repseg=2  */
			  /*nomatch,..repseg=L, rotmatch=1           */
   return(repseg);
}

/********* rotation equivelents in 2-d attractor cycle, Oct 1994 ************/
void repeating_seg_2d(register char *array){

 signed short z,
	      rotmatch_2d;/*degree of rot sym max=i2d or j2d min=1*/

   memcpy(rot,array,bytesL);

   rotmatch_2d=1;
   for (z=0;z<=i2d-1;z++){
      if (z!=0){  /*miss out first=same*/
	 /*if repeat found*/
	 if (memcmp(rot,array,bytesL)==0) rotmatch_2d+=1;
      }
      rotate_array_2d(rot,'l',1);
   }                             /*min width of trans req to retun to start*/
   repseg_2d[0]=i2d/rotmatch_2d; /*usualy=min number of repeating columns*/
				 /*nomatch,..repseg_2d[0]=i2d, all =1*/
   rotmatch_2d=1;
   for (z=0;z<=j2d-1;z++){
      if (z!=0){  /*miss out first=same*/
	 /*if repeat found*/
	 if (memcmp(rot,array,bytesL)==0) rotmatch_2d+=1;
      }
      rotate_array_2d(rot,'u',1);
   }                             /*min height of trans req to retun to start*/
   repseg_2d[1]=j2d/rotmatch_2d; /*usualy=min number of repeating rows*/
				 /*nomatch,..repseg_2d[1]=j2d, all same=1*/
}

/********* 2d, check if horiz=vert translation, Oct 1994 ************/
char trans_sym_2d(register char *array){

 char *rot1,*rot2,hv_rot_equal=0;

   /*if i2d=j2d, check if horiz=vert translation, ie up=right or left*/
   sprintf(textb[0],"rot1,2");
   if ((rot1=(char *)calloc(bytesL,sizeof(char)))
					    ==NULL) outof_memory(textb[0]);
   if ((rot2=(char *)calloc(bytesL,sizeof(char)))
					    ==NULL) outof_memory(textb[0]);
   memcpy(rot,array,bytesL);
   memcpy(rot1,array,bytesL);
   memcpy(rot2,array,bytesL);
				 /*     o     */
   rotate_array_2d(rot,'u',1);   /*     o     */
   rotate_array_2d(rot1,'l',1);  /*     *     */
   rotate_array_2d(rot2,'r',1);  /* ooo*o*ooo */

   if ((memcmp(rot,rot1,bytesL)==0 || memcmp(rot,rot2,bytesL)==0)){
      repseg_2d[0]=1;
      hv_rot_equal=1;
   }

   else if (i2d>3 && i2d%2==0){
      /*translate one more, ie 2 cells*/  /*     o     */
      rotate_array_2d(rot,'u',1);         /*     *     */
      rotate_array_2d(rot1,'l',1);        /*     o     */
      rotate_array_2d(rot2,'r',1);        /*  o*ooo*o  */
      if ((memcmp(rot,rot1,bytesL)==0 ||
		       memcmp(rot,rot2,bytesL)==0)){
	 repseg_2d[0]=2;
	 hv_rot_equal=1;
      }
   }
   /*even arrays only from now on*/
   if (hv_rot_equal==1 || (i2d%2!=0 || i2d%2!=0)) goto end;

   if (j2d>3 && repseg_2d[1]==j2d){
	 memcpy(rot1,array,bytesL); /*restor arrays*/
	 memcpy(rot2,array,bytesL);
	 rotate_array_2d(rot1,'r',1);
	 rotate_array_2d(rot2,'u',2);
						 /*  o    */
	 if (memcmp(rot1,rot2,bytesL)==0){       /*  *    */
	    repseg_2d[0]=1;                      /*  o    */
	    hv_rot_equal=1;                      /*  o*oo */
	    goto end;
	 }
   }
   if (i2d>3 && repseg_2d[0]==i2d){
	    memcpy(rot1,array,bytesL); /*restor arrays*/
	    memcpy(rot2,array,bytesL);
	    rotate_array_2d(rot1,'l',2);
	    rotate_array_2d(rot2,'u',1);		/*    o	 */
	    if (memcmp(rot1,rot2,bytesL)==0){           /*    o  */
	       repseg_2d[1]=1;                          /*    *  */
	       hv_rot_equal=1;                          /* o*oo  */
	    }
   }
  end:
   free(rot1);
   free(rot2);
   return(hv_rot_equal);
}

