/************** include/define 13 May 1993 ********************/

#include "edecfunc.h"

/*****************  print save box, Aug 93 **********************/
void finish_options_box(char alloptions){
 signed short temp;

   draw_bottom_title();
   if (alloptions==0)
     sprintf(textb[0],"image:print/save/load-p/s/l");
   else
     sprintf(textb[0],"graphics-g image:print/save/load-p/s/l options-o");
   temp=textwidth(textb[0]);
#  if __BORC__||__WATCOM__
      draw_box(1,2,2,temp+CWidth*2,CHeight*3+vgay(8),1,0);
#  elif __UNIX__
      draw_box(1,2,2,temp,CHeight*3+vgay(8),1,0);
#  endif
   if ((limitcheck>0 && direction=='f')){  /*if basin or field*/
      if (basinfield) sprintf(textb[1],
	     "toggle: field->single-t STP-P");
      else sprintf(textb[1],
	    "toggle: single->field-t STP-P Seed-S");
   }
   else if (direction=='b') sprintf(textb[1],
      "toggle: single->field-t STP-P Seed-S");/*subtree*/
   else sprintf(textb[1],"Seed-S");/*forwards only*/

   if (!loc_twod_fonly && alloptions) sprintf(textb[2],
		"network:view/revise/learn-n back-q cont-ret:");

   else sprintf(textb[2],"back-q cont-ret:");

   moveto(vgax(6),vgay(3));
   outtext(textb[0]);
   moveto(vgax(6),gety+CHeight);
   if (alloptions){
      outtext(textb[1]);
      moveto(vgax(6),gety+CHeight);
   }
   myouttext(textb[2]);
   input_string(1,0);
}

/********** memory box - print bytes remaining in far core ************/
signed short memory_box(char showmem){
 signed short tempx,tempy,leftboxx,rightboxx,boxy;

# if __UNIX__
     if (showmem==1) return(0); /*xwindows*/
# endif
  tempx=getx;
  tempy=gety;
  leftboxx=(signed short)((float)Maxx)/3;
  rightboxx=((signed short)((float)Maxx)/2)-3;
  boxy=2;
  /*erase box*/
  setviewport(leftboxx,boxy,rightboxx,boxy+CHeight+vgay(6),1);
  clearviewport();
  setviewport(0, 0, Maxx, Maxy, 0);
  setcolor(lightred);
  rectangle(leftboxx,boxy,rightboxx,boxy+CHeight+vgay(6));

  moveto(leftboxx+3,boxy+1);

  if (showmem==1){
#    if __BORC__
	sprintf(textb[0],"       fheap=%lu",farcoreleft());
#    elif __WATCOM__
	_heapshrink();
	sprintf(textb[0],"        mem=%lu",(long)_memavl()+get_memory());
#    endif
     setcolor(white);
     myouttext(textb[0]);
  }
  moveto(tempx,tempy);
  setcolor(white);
  return(leftboxx);
}

/********************** draw bottom title, Jan 94 **********************/
void draw_bottom_title(void){
#if __BORC__||__WATCOM__
# if __WATCOM__
  signed short fid;
  unsigned long imsize;
  char *buf;
  
# endif

	setviewport(0,0,Maxx,getmaxy(),0);
	setfillstyle(SOLID_FILL,black);
	bar3d(0,getmaxy()-vgay(13),Maxx,getmaxy(),0,0);
	setfillstyle(CLOSE_DOT_FILL,darkgray);
	bar3d(0,getmaxy()-vgay(13),Maxx,getmaxy(),0,0);
	setcolor(white);
	line(0,getmaxy()-vgay(13),Maxx,getmaxy()-vgay(13));
	moveto(3,getmaxy()-vgay(12));
	setcolor(yellow);
#       if __BORC__
	  myouttext(
	   "DISCRETE DYNAMICS LAB copyright c Andrew Wuensche 1993-96");
	  circle(vgax(161),getmaxy()-vgay(6),vgax(5));

#       elif __WATCOM__
	  //load image from file
	  if (first_title==1){
	     //SVGA 1024x768
	     if (hires){
		if (bground=='w') filename="dd_wh.map";
		else filename="dd_bh.map"; //if (bground=='b')
	     }
	     //not hires VGA 640x480
	     else {
		if (bground=='w') filename="dd_wl.map";
		else filename="dd_bl.map"; //if (bground=='b')
	     }
	     title_file_found=0;
	     /*load image from file and put in bottom title*/
	     if ((fid=open(filename,O_RDWR|O_BINARY))!=-1){

		imsize=(unsigned long)filelength(fid);
		if ((buf=(char *)calloc(imsize,sizeof(char)))
					==NULL) outof_memory(textb[0]);
		if ((title_image = malloc(imsize*sizeof(char))) == NULL)
				outof_memory("title_image");
		read(fid,buf,imsize);
		memcpy(title_image,buf,imsize);
		title_file_found=1;
		first_title=0;
		close(fid);
		free(buf);
		free(title_image);
	     }
	  }

	  if (title_file_found)
	       putimage(1,getmaxy()-vgay(12),title_image,COPY_PUT);
	  else{ //if file not found, write the bottom title
	     if (info.pixheight>10){
		_outgtext("DISCRETE DYNAMICS LAB");
		_outgtext(" copyright  c  Andrew Wuensche 1993-96");
		//watcom font, watcom gtext x=166 r=5, bor x=161 r=5
		if (!hires) circle(vgax(171),getmaxy()-vgay(6),vgax(4));
		else circle(vgax(150),getmaxy()-vgay(6),vgax(4));
	     }
	     else{
		myouttext(
		"DISCRETE DYNAMICS LAB copyright c Andrew Wuensche 1993-96");
		circle(vgax(166),getmaxy()-vgay(6),vgax(5));
	     }
	  }
	  /******save title to file********/
	  /*
	  if (info.pixheight>10){
	     _outgtext("DISCRETE DYNAMICS LAB");
	     _outgtext(" copyright  c  Andrew Wuensche 1993-96");
	     //watcom font, watcom gtext x=166 r=5, bor x=161 r=5
	     if (!hires) circle(vgax(171),getmaxy()-vgay(6),vgax(4));
	     else circle(vgax(150),getmaxy()-vgay(6),vgax(4));
	  }
	  else{
	     myouttext(
	     "DISCRETE DYNAMICS LAB copyright c Andrew Wuensche 1993-96");
	     circle(vgax(166),getmaxy()-vgay(6),vgax(5));
	  }

	  input_string(1,0);

	  imsize=(unsigned long)
		imagesize(1,getmaxy()-vgay(12),Maxx/2,getmaxy()-1);
	  if ((title_image = malloc(imsize*sizeof(char))) == NULL)
				outof_memory("title_image");

	  getimage(1,getmaxy()-vgay(12),Maxx/2,getmaxy()-1,title_image);

	  if ((buf=(char *)calloc(imsize,sizeof(char)))
					==NULL) outof_memory(textb[0]);
	  memcpy(buf,title_image,imsize);
	  if ((fid=open(filename,
		O_RDWR|O_CREAT| O_APPEND|O_BINARY,
				S_IREAD|S_IWRITE))==-1){
	    sprintf(textb[0],"%s, RETURN-continue",sys_errlist[errno]);
	    outtext(textb[0]);
	  }
	  write(fid, buf, imsize);
	  close(fid);
	  free(buf);
	  free(title_image);
	  */

	  /********************************/
#       endif
	moveto(Maxx/2,gety);
	setcolor(lightred);
	outtext("  backtrack/interrupt-q, print screen-Home");
	setcolor(white);
	setfillstyle(SOLID_FILL,black);
	setviewport(0,0,Maxx,Maxy,1);
#   endif
    /******************** UNIX code ********************/
#   if __UNIX__
    signed short tempx,tempy;
  
        tempx=getx;
        tempy=gety;
               
        setviewport(0,0,Maxx,WinMaxy,0);	
        /*first delete the box*/
        setfillstyle(SOLID_FILL,black);
        bar(0,Maxy+1,Maxx,WinMaxy);
	setcolor(lightred);
        /*line(0,Maxy+1,Maxx,Maxy+1);*/
        rectangle(0,Maxy+1,Maxx,WinMaxy);
        moveto(vgax(3),WinMaxy-vgay(12));
	setcolor(yellow);
	        
        XSetFont(D,Gc,italicfont->fid);
        outtext("DDLab copyright ");  
        circle(getx+2,gety+CHeight*.6,CWidth*.8);
        outtext("c");         
	outtext("  Andrew Wuensche 1993-96");
        
        /*restor default font*/  
        XSetFont(D,Gc,propfont->fid);    
        setcolor(lightred);
	outtext("  backtrack/interrupt-q, print screen-@");	
        setcolor(white);
	setviewport(0,0,Maxx,Maxy,1);                
        moveto(tempx,tempy);
#   endif
}

/********************** draw prompt box, May 93 **********************/
signed short draw_prompt_box(char lines){       /*number of text lines*/
 signed short boxx,boxy;   			/*position of dialogue box*/
 signed short tempfill,tempcolor;
					  /*_____________            */
					  /*|     |_____|<--box      */
    boxx=Maxx/2;                          /*|		|            */
    boxy=2;                               /*|           |            */
					  /*|		|            */
					  /*|		|            */
					  /*|		|            */
					  /*-------------            */

#   if __BORC__||__WATCOM__
       setcolor(lightred);
       /*erase box*/
       setfillstyle(SOLID_FILL,black);
       bar(boxx,boxy,Maxx-2,boxy+CHeight*lines+vgay(6));
       /*draw box*/
       rectangle(boxx,boxy,Maxx-2,boxy+CHeight*lines+vgay(6));
       moveto(boxx+3,boxy+1);
       setcolor(white);
       return(boxx+3);

#   elif __UNIX__
       tempcolor=nowcolor;
       tempfill=fillcolor;
       /*erase box*/
       setfillstyle(SOLID_FILL,black);
       bar(boxx,boxy,Maxx-2,boxy+CHeight*lines+vgay(6));
       /*draw box*/
       setcolor(red);
       rectangle(boxx,boxy,Maxx-2,boxy+CHeight*lines+vgay(6));
       moveto(boxx+3,boxy+3);
       setcolor(tempcolor);
       setfillstyle(SOLID_FILL,tempfill);
       return(boxx+3);
#   endif
}

/************** get image covered by prompt_box, Sept 93 *******************/
void get_prompt_box(char bufno, char lines){ /*number of text lines*/
 signed short boxx,boxy;   		    /*position of dialogue box*/
#if __BORC__||__WATCOM__
   unsigned long imsize;
#endif					  /*_____________            */
					  /*|     |_____|<--box      */
   boxx=Maxx/2;                           /*|		|            */
   boxy=2;                                /*|           |            */
					  /*|		|            */
					  /*|		|            */
					  /*|		|            */
					  /*-------------            */

   /*get image covered by box, alternative buffers availabe 0-9
     dont do this if buffno=-1*/
   if (bufno>=0 && bufno<10){
#     if __BORC__||__WATCOM__
         imsize=imagesize(boxx,boxy,Maxx-2,boxy+CHeight*lines+vgay(6));
         if ((boximage_prompt[bufno]=malloc(imsize))==NULL){
		    sprintf(textb[0],"boximage_prompt[%d]",bufno);
		    outof_memory(textb[0]);
         }
#     endif
      getimage (boxx,boxy,Maxx-2,boxy+CHeight*lines+vgay(6),
					boximage_prompt[bufno]);
   }
}

/******************* erase prompt box, May 93 *************************/
void erase_prompt_box(char lines){
 signed short boxx,boxy;   /*position of dialogue box*/

#if __UNIX__
   signed short tempfill;
#endif
					  /*_____________            */
					  /*|     |_____|<--box      */
     boxx=Maxx/2;                         /*|		|            */
     boxy=2;                              /*|           |            */
					  /*|		|            */
     		                          /*|		|            */
	                                  /*|		|            */
					  /*-------------            */

#    if __BORC__||__WATCOM__
        /*erase box*/
        setfillstyle(SOLID_FILL,black);
        bar(boxx,boxy,Maxx-2,boxy+CHeight*lines+vgay(6));
#    elif __UNIX__
        /*erase box*/     
        tempfill=fillcolor;
        setfillstyle(SOLID_FILL,black);
        bar(boxx,boxy,Maxx-2,boxy+CHeight*lines+vgay(6));       
        setfillstyle(SOLID_FILL,tempfill);
#    endif
}

/********************** draw hint box, June 94 **********************/
void draw_hint_box(char savehintbox,char* thistext,signed short startx){
 signed short tempx,tempy;
 unsigned char tempcolor;
 char bufno=-1;

  if (savehintbox) bufno=19;
  tempx=getx;
  tempy=gety;
  tempcolor=getcolor();
  setcolor(white);
  setviewport(0, 0, getmaxx(),getmaxy(),0);
  if (savehintbox)
     draw_box(bufno,vgax(startx),getmaxy()-vgay(13),getmaxx()-1,getmaxy(),1,0);
  else{
     setfillstyle(SOLID_FILL,black);
     bar(vgax(startx+1),getmaxy()-vgay(12),getmaxx()-2,getmaxy()-1);
  }
  setviewport(0, 0, getmaxx(),getmaxy(),0);
  moveto(vgax(startx+7),getmaxy()-vgay(12));
  outtext(thistext);
  setviewport(0, 0, Maxx, Maxy, 0);
  moveto(tempx,tempy);
  setcolor(tempcolor);
}

/********************** erase hint box, June 94 **********************/
void erase_hint_box(){

   putimage(vgax(500),getmaxy()-vgay(13),boximage[19],COPY_PUT);
   freeimage(boximage[19]);
}

/********************** draw box, July 93 **********************/
void draw_box(char bufno,signed short xtopleft,signed short ytopleft,
		signed short xbotright,signed short ybotright,
				 char outline,signed short bcolor){
#if __BORC__||__WATCOM__
   unsigned long imsize;
#endif
 signed short boxx,boxy,   /*position of dialogue box*/    
     boxwidth,boxdepth,
     tempcolor;
					  /*_____________            */
					  /*|           |            */
   boxx=xtopleft;                         /*| ______    |            */
   boxy=ytopleft ;                        /*| |     |<--box          */
   boxwidth=xbotright-xtopleft;	          /*| ------    |            */
   boxdepth=ybotright-ytopleft;	          /*|		|            */
					  /*|		|            */
					  /*-------------            */
   tempcolor=getcolor();
   setviewport(0, 0, getmaxx(), getmaxy(), 0);
   /*get image covered by box, alternative buffers availabe 0-19
     dont do this if buffno=-1*/
   if (bufno>=0 && bufno<=19){
      
#     if __BORC__||__WATCOM__
         imsize=imagesize(boxx,boxy,xbotright+1,ybotright+1);
         if ((boximage[bufno]=malloc(imsize))==NULL){
	    sprintf(textb[0],"boximage[%d]",bufno);
	    outof_memory(textb[0]);
         } 
#     endif
      getimage(boxx,boxy,xbotright+1,ybotright+1,boximage[bufno]);
   }

   /*inside of box, if bcolor=-1 dont alter*/
   
   /*erase inside box, or color*/
   if (bcolor==0){
	 setviewport(boxx, boxy, boxx+boxwidth, boxy+boxdepth, 1);
	 clearviewport();
	 setviewport(0, 0, getmaxx(), getmaxy(), 0);
   }
   else{
	 setfillstyle(SOLID_FILL,bcolor);
	 bar(boxx,boxy,boxx+boxwidth,boxy+boxdepth);
   }
   
   if (outline==1){
	setcolor(lightred);
	/*draw box*/
	rectangle(boxx,boxy,boxx+boxwidth,boxy+boxdepth);
   }
   setcolor(tempcolor);
   setviewport(0, 0, Maxx, Maxy, 0);
   moveto(boxx+vgax(3),boxy+1);
}

/******************* erase box, July 93 *************************/
void erase_box(signed short xtopleft,signed short ytopleft,
		signed short xbotright,signed short ybotright){
 signed short boxx,boxy;   /*position of dialogue box*/
 signed short boxwidth,boxdepth;
 signed short tempx,tempy;

	tempx=getx;			  /*_____________            */
	tempy=gety;			  /*|           |            */
	boxx=xtopleft;                    /*| ______    |            */
	boxy=ytopleft;                    /*| |     |<--box          */
	boxwidth=xbotright-xtopleft;	  /*| ------    |            */
	boxdepth=ybotright-ytopleft;	  /*|		|            */
					  /*|		|            */
					  /*-------------            */
	if (hires) setcolor(160);
	moveto(boxx,boxy);           /*erase box*/
	setfillstyle(SOLID_FILL,black);
#       if __BORC__||__WATCOM__
	   bar(boxx, boxy, boxx+boxwidth, boxy+boxdepth);
#       elif __UNIX__
           bar(boxx, boxy, boxx+boxwidth+1, boxy+boxdepth+1);
#       endif
	setcolor(white);
	moveto(tempx,tempy);
}

/**********draw rule bitstring and hex no in a box, July 93***************/
char print_rule_in_box(signed short ypos, char* thisrule){
 signed short xtopleft,ytopleft,xbotright,xxtext,
     ybotright,lineno,
     tablemax,tablebytes,codebytes,
     mtablemax,mtablebytes,mcodebytes,
     z,zz,
     prytopleft,prybotright,
     poss;

 unsigned short cellindex,maxloop;
 char *catemp,reset,*nhoodtemp,forward_only=0;

#define put_free_9_4 {\
	      putimage(xtopleft,prytopleft,boximage[4],COPY_PUT);\
	      freeimage(boximage[4]);\
	      if (!rulemix && forward_only){\
		 putimage(xtopleft,ytopleft,boximage[9],COPY_PUT);\
		 freeimage(boximage[9]);\
	      }\
	      if (!rulemix && !forward_only)\
			show_rule_bottom(nhoodm[0],1,carule[0],0);\
    }

    tablemax= (signed short)pow(2,(double)nhood)-1;
    tablebytes=(signed short)ceil(pow(2,(double)nhood)/8);
    codebytes=(signed short)ceil((double)(nhood+1)/8);
    if (limitcheck==0 && direction=='f') forward_only=1;


   start:
       xtopleft=(signed short)((float)Maxx)/2;
       ytopleft=ypos;
       xbotright=Maxx-2;
       xxtext=(xtopleft/CWidth+2);

    if (!rulemix && forward_only){
       if (nhood<=5) ybotright=ypos+CHeight*3.7;
       else if(nhood==6) ybotright=ypos+CHeight*4.5;
       else if(nhood==7) ybotright=ypos+CHeight*4.8;
       else if(nhood==8) ybotright=ypos+CHeight*6.5;
       else if (nhood==9) ybotright=ypos+CHeight*10.7;
       draw_box(9,xtopleft,ytopleft,xbotright,ybotright,1,0);

       moveto(xxtext*CWidth,ytopleft+4);
       print_layered_bitstring
		 (64,thisrule,(signed short)pow(2,(float)nhood)-1,4,1,0,1);
       if (nhood<6){
	  moverel(10,-3);
	  sprintf(textb[0],"%lu ",dec_equiv(thisrule,
				   (signed short)pow(2,(float)nhood)-1));
	  outtext(textb[0]);
       }
       else moveto(xxtext*CWidth,gety+3);
       lineno=print_current_bitstring_hexbytes
			    (1,thisrule,nhood,xbotright,white,4);
       if (lineno<0) lineno=0;
       moveto(xxtext*CWidth,gety+CHeight*(lineno+1)+1);
       sprintf(textb[0],"k%d-rule ",nhood);
       outtext(textb[0]);
       sprintf(textb[0],"ld=%.3g ld-r=%.3g zl=%.3g zr=%.3g Z=%g",
			     lambda,lratio,zparam[1],zparam[2],zparam[0]);
       myouttext(textb[0]);
       moveto(xxtext*CWidth,gety+CHeight);
       /*show canalyzing inputs*/
       sprintf(textb[0],"C=%d/%d",canaltotal,nhood);
       if (canaltotal && nhood>1){
	  memcpy(textb[0]+5," ",1);
	     for (z=nhood-1;z>=0;z--){
		if (get_bit(canal,z)==1){
		sprintf(textb[1],"%d",z);
		memcpy(textb[0]+6+nhood-1-z,textb[1],1);
	     }
	     else memcpy(textb[0]+6+nhood-1-z,"*",1);
	  }
       }
       memcpy(textb[0]+6+nhood,"\0",1);
       outtext(textb[0]);
       sprintf(textb[0],"  Size=%d",lineL);
       outtext(textb[0]);
       moveto(xxtext*CWidth,ybotright+3);
    }
    if (!rulemix && forward_only) prytopleft=gety;
    else prytopleft=2;
    /*space-time patterns only*/
    if (forward_only) prybotright=prytopleft+6*CHeight;
    else if (!basinfield) prybotright=prytopleft+5*CHeight;
    else prybotright=prytopleft+4*CHeight;

    draw_box(4,xtopleft,prytopleft,xbotright,prybotright,1,0);
    moveto(xxtext*CWidth,prytopleft+2);
    if (forward_only){/*space-time patterns only*/
       if (!rulemix) sprintf(textb[0],
	 "prt scrn with/out/justbox-p/P/B  save scrn-V load stats-E");
       else sprintf(textb[0],
	   "prt scrn with/out box-p/P  save scrn-V load stats-E");
       myouttext(textb[0]);
       moveto(xxtext*CWidth,gety+CHeight);
    }
    sprintf(textb[0],
      "rule: save-s load-l revise-v comp-c neg-n ref-r canalizing-C");
    myouttext(textb[0]);
    moveto(xxtext*CWidth,gety+CHeight);


    if (rulemix) sprintf(textb[0],"bitflip-1, flip ends-w/b");
    else sprintf(textb[0],
	  "bitflip/flipback-1/2, flip ends-w/b, Z:higher/lower-Z/z");
    outtext(textb[0]);
    moveto(xxtext*CWidth,gety+CHeight);

    if (forward_only){
       forward_only=1;
       sprintf(textb[0],
	  "seed: rev-e, rand/block-R/H/k, sing pos/neg-5/6, save/load-S/L");
       if (nonlocal) sprintf(textb[1],
	  "toggle wiring-7, start at top-t, goback-q, ret-cont:");
       else sprintf(textb[1],"start at top-t, goback-q, ret-cont:");
       outtext(textb[0]);
       moveto(xxtext*CWidth,gety+CHeight);
       myouttext(textb[1]);

    }
    else if (!basinfield){
       sprintf(textb[0],
	  "seed: rev-e, rand/block-4/k, sing pos/neg-5/6, save/load-S/L");
       sprintf(textb[1],"goback-q, ret-cont:");
       outtext(textb[0]);
       moveto(xxtext*CWidth,gety+CHeight);
       myouttext(textb[1]);
    }
    else{
       sprintf(textb[1],"goback-q, ret-cont:");
       myouttext(textb[1]);
    }

    input_string(1,0);
    switch(is[0]){
       /*show rule statistics*/
       case 'E':
	  load_rule_stats();
	  put_free_9_4;
	  goto start;
       /*change canalyzing*/
       case 'C':
	  if (rulemix) set_canalyzing_net(0);/*dont force null nhood->0*/
	  else set_canalyzing_rule(0); /*cellindex 0 */
	  was_changed=1;
	  put_free_9_4;
	  goto start;
       /*revise rule*/
       case 'v':
	  cellindex=0;
	  if (rulemix){
	     draw_box(3,xtopleft,prybotright+vgay(3),
		      xbotright,prybotright+vgay(16),1,0);
	     moveto(xtopleft+3,prybotright+vgay(5));
	     sprintf(textb[0],"enter cell index, %d-0:",lineL-1);
	     myouttext(textb[0]);
	     sprintf(textb[0],"%d",lineL-1);
	     input_string(strlen(textb[0]),0);

	     if (atoi(is) >=0 && atoi(is)<lineL) cellindex=atoi(is);
	  }
	  if (nhood_mixed){
	     mtablebytes=(signed short)ceil(pow(2,
				      (double)nhoodm[cellindex])/8);
	     mcodebytes=(signed short)ceil((double)(nhoodm[cellindex]+1)/8);
	     revise_rule_or_code(cellindex,mtablebytes,mcodebytes);
	  }
	  else revise_rule_or_code(cellindex,tablebytes,codebytes);

	  if (rulemix){
	     putimage (xtopleft,prybotright+vgay(3),boximage[3],COPY_PUT);
	     freeimage(boximage[3]);
	  }
	  was_changed=1;
	  put_free_9_4;
	  goto start;
       /*complementary transformation*/
       case 'c':
	  if (rulemix) maxloop=lineL-1;
	  else maxloop=0;

	  for (cellindex=0;cellindex<=maxloop;cellindex++){
	     if (nhood_mixed){
		mtablemax= (signed short)pow(2,(double)nhoodm[cellindex])-1;
		mtablebytes=(signed short)ceil(pow(2,
				      (double)nhoodm[cellindex])/8);
	     }
	     else{
		mtablemax=tablemax;
		mtablebytes=tablebytes;
	     }	    
	     if ((catemp=(char *)calloc(mtablebytes,sizeof(char)))
				    ==NULL) outof_memory("catemp");
	     for (z=0;z<=mtablemax;z++)
		   set_bit(catemp,z,abs(1-get_bit(carule[cellindex],z)));
	     memcpy(carule[cellindex],catemp,mtablebytes);
	     free(catemp);
	  }
	  put_free_9_4;
	  was_changed=1;
	  goto start;
       /*negative transformation*/
       case 'n':
	  if (rulemix) maxloop=lineL-1;
	  else maxloop=0;

	  for (cellindex=0;cellindex<=maxloop;cellindex++){
	     if (nhood_mixed){
		mtablemax= (signed short)pow(2,(double)nhoodm[cellindex])-1;
		mtablebytes=(signed short)ceil(pow(2,
				      (double)nhoodm[cellindex])/8);
	     }
	     else{
		mtablemax=tablemax;
		mtablebytes=tablebytes;
	     }
	     if ((catemp=(char *)calloc(mtablebytes,sizeof(char)))
				    ==NULL) outof_memory(catemp);
	     for (z=0;z<=mtablemax;z++)
	       set_bit(catemp,mtablemax-z,abs(1-get_bit(carule[cellindex],z)));
	     memcpy(carule[cellindex],catemp,mtablebytes);
	     free(catemp);
	  }
	  put_free_9_4;
	  was_changed=1;
	  goto start;
       /*reflection transformation*/
       case 'r':
	  if (rulemix) maxloop=lineL-1;
	  else maxloop=0;

	  for (cellindex=0;cellindex<=maxloop;cellindex++){
	     if (nhood_mixed){
		mtablemax= (signed short)pow(2,(double)nhoodm[cellindex])-1;
		mtablebytes=(signed short)ceil(pow(2,
				      (double)nhoodm[cellindex])/8);
	     }
	     else{
		mtablemax=tablemax;
		mtablebytes=tablebytes;
	     }
	     if ((catemp=(char *)calloc(mtablebytes,sizeof(char)))
				    ==NULL) outof_memory(catemp);
	     if ((nhoodtemp=(char *)calloc(2,sizeof(char)))
				    ==NULL) outof_memory(nhoodtemp);
	     /*swap outputs of pairs of (asymmetric) reflected nhoods*/
	     for (z=0;z<=mtablemax;z++){
		dec_to_bit_line(nhoodtemp,(unsigned long)z,nhoodm[cellindex]);
		/*reflect bits*/
		for (zz=0;zz<=(nhoodm[cellindex]-1);zz++)
		  set_bit(nhoodtemp,(nhoodm[cellindex]-1)-zz,get_bit(nm[zz],z));
		poss=(signed short) dec_equiv(nhoodtemp,nhoodm[cellindex]-1);
		set_bit(catemp,poss,get_bit(carule[cellindex],z));
	     }
	     memcpy(carule[cellindex],catemp,mtablebytes);
	     free(catemp);
	     free(nhoodtemp);
          }
	  put_free_9_4;
	  was_changed=1;
	  goto start;
       case 'e':
	  if (!basinfield){
	     moveto(vgax(200),vgay(315));
	     select_seed(bitseed,"SEED",1);
	     memcpy(A,bitseed,bytesL);
	     put_free_9_4;
	     goto start;
	  }
       case 'R':
	  if (!basinfield){
	     random_seed(white,rand_seed_percent);
	     memcpy(bitseed,A,bytesL);
	     put_free_9_4;
	     goto start;
	  }
	  break;
        case 'H':
	  if (!basinfield){
             draw_box(3,xtopleft,prybotright+vgay(3),
		      xbotright,prybotright+vgay(16),1,0);
	     moveto(xtopleft+3,prybotright+vgay(5));
	     sprintf(textb[0],
               "enter %% random Hamming change of current state (now %d):"
                                       ,rand_seed_percent);
	     myouttext(textb[0]);	     
	     input_string(3,0);

	     if (atoi(is) >=0 && atoi(is)<=100) rand_seed_percent=atoi(is);
             random_seed(white,rand_seed_percent);
             putimage (xtopleft,prybotright+vgay(3),boximage[3],COPY_PUT);
	     freeimage(boximage[3]);	     
	     put_free_9_4;
	     goto start;
	  }
	  break;
       case 'k':
	  if (!basinfield){
	     if (twod) random_block(i2d/5,white);
	     else random_block(lineL/5,white);
	     memcpy(bitseed,A,bytesL);
	     put_free_9_4;
	     goto start;
	  }
	  break;
       case '5':
	  if (!basinfield){
	     singleton_seed(white);
	     if (!forward_only) memcpy(bitseed,A,bytesL);
	     put_free_9_4;
	     goto start;
	  }
	  break;
       case '6':
	  if (!basinfield){
	     singleton_neg_seed(white);
	     if (!forward_only) memcpy(bitseed,A,bytesL);
	     put_free_9_4;
	     goto start;
	  }
	  break;
       /*save seed*/
       case 'S':
	  if (!basinfield){
	     load_save_wrs('s',bitseed,'s');
	     put_free_9_4;
	     goto start;
	  }
	  break;
       /*load seed*/
       case 'L':
	  if (!basinfield){
	     load_save_wrs('l',A,'s');
	     put_free_9_4;
	     goto start;
	  }
	  break;
       /*toggle local...nonlocal wiring*/
       case '7':
	  if (forward_only && !loc_twod_fonly && nonlocal)
	     wiring_madelocal=abs(wiring_madelocal-1);
	  break;
       /*print rule box only*/
       case 'B':
	  if (!rulemix && forward_only){
#            if __BORC__||__WATCOM__
		printimage('P',0,0,
			xtopleft,ytopleft,xbotright+1,ybotright);
#            elif __UNIX__
		printimage();
#            endif
	     put_free_9_4;
	     goto start;
	  }
	  goto start;
       /*print sceen with box*/
       case 'p':
	  if (forward_only){
	     putimage(xtopleft,prytopleft,boximage[4],COPY_PUT);
#            if __BORC__||__WATCOM__
		printimage('L',0,0,0,0,getmaxx(),getmaxy());
#            elif __UNIX__
		printimage();
#            endif
	     put_free_9_4;
	     goto start;
	  }
	  goto start;
       /*print sceen without box*/
       case 'P':
	  if (forward_only){
	     put_free_9_4;
#            if __BORC__||__WATCOM__
		printimage('L',0,0,0,0,getmaxx(),getmaxy());
#            elif __UNIX__
		printimage();
#            endif
	     goto start;
	  }
	  goto start;
       /*save screen image*/
       case 'V':
	 if (forward_only){
	    putimage(xtopleft,prytopleft,boximage[4],COPY_PUT);
	    save_screen();
	    put_free_9_4;
	    goto start;
	 }
	 goto start;
       /*save rule*/
       case 's':
	  put_free_9_4;
	  load_save_wrs('s',thisrule,0);
	  goto start;
       /*load rule*/
       case 'l':
	  put_free_9_4;
	  load_save_wrs('l',thisrule,0);
	  was_changed=1;
	  goto start;
       /*random bit flip - rule*/
       case '1':
	  bit_flip('1',0);
	  was_changed=1;
	  put_free_9_4;
	  goto start;
       /*restore bit flip - rule*/
       case '2':
	  if (!rulemix){
	     bit_flipback(0);
	     was_changed=1;
	     put_free_9_4;
	  }
	  goto start;
       /*flip for higher z*/
       case 'Z':
	  if (!rulemix){
	     bit_flip('Z',0);
	     was_changed=1;
	     put_free_9_4;
	  }
	  goto start;
       /*flip for lower z*/
       case 'z':
	  if (!rulemix){
	     bit_flip('z',0);
	     was_changed=1;
	     put_free_9_4;
	  }
	  goto start;
       /*flip nhood all 1s*/
       case 'w':
	  bit_flip('w',0);
	  was_changed=1;
	  put_free_9_4;
	  goto start;
       /*flip nhood all 0s*/
       case 'b':
	  bit_flip('b',0);
	  was_changed=1;
	  put_free_9_4;
	  goto start;
       /*continue space-time pattern from top*/
       case 't':
	  if (forward_only) reset=1;
	  break;
    }
    put_free_9_4;
    return(reset);
}

/********** show rule, lambda,Z eyc at bottom of screen, Aug 93 ***********/
void show_rule_bottom(char nhoodz,char printout,
			 char* thisrule,unsigned short cellindex){
 char temp;
 signed short tempx,tempy,rightx,leftx;

   if (nhoodz==9) temp=3;
   else temp=2;
   tempx=getx;
   tempy=gety;

   leftx=vgax(125);
   if ((nhoodz<=7 && (!totalistic && nhoodz<=4))
	      || exhaustive_testing==2) rightx=vgax(550);
   else rightx=Maxx;

   if (nhoodz>6 || exhaustive_testing==2)
      draw_box(-1,leftx,Maxy-(CHeight*temp)-2,rightx,Maxy,1,0);
   else{
      draw_box(-1,leftx,Maxy-(CHeight*temp)-2-4,rightx,Maxy,1,0);
      moveto(leftx+2,Maxy-(CHeight*temp)-2-2);
      print_layered_bitstring
	  (64,thisrule,(unsigned short)pow(2,(double)nhoodz)-1,4,1,0,1);
   }

   write_rule(nhoodz,printout,leftx+3,Maxy-(CHeight*temp)-2,
					     thisrule,cellindex);
   moveto(tempx,tempy);
}
/***write rule no (dec),hex,size,lambda,lambda ratio,Z-left,Z-right,Z*****/
		  /*********** July 93 *****************/
signed short write_rule(char nhoodz,char printout,signed short xrulestart,
      signed short yrulestart,char* thisrule,unsigned short cellindex){
 signed short lineno, rightmax;
 signed short tempx,tempy;
 char z;

   tempx=getx;
   tempy=gety;

   moveto(xrulestart,yrulestart);
   if (exhaustive_testing==2){
      sprintf(textb[0],"Random Map, Size=%d ",lineL);
      outtext(textb[0]);
      rightmax=getx;
      moveto(tempx,tempy);
      return(rightmax);
   }
   sprintf(textb[0],"k%d-rule",nhoodz);
   outtext(textb[0]);
   if ((pdata || filedata) && printout==1){
      if (pdata) print_out(textb[0]);
      if (filedata) save_data(textb[0]);
   }
   if (nhoodz<6){
      sprintf(textb[0],"(dec)%lu ",
	 dec_equiv(thisrule,(signed short)pow(2,(float)nhoodz)-1));
      outtext(textb[0]);
      if ((pdata || filedata) && printout==1){
	 if (pdata) print_out(textb[0]);
	 if (filedata) save_data(textb[0]);
      }
      moverel(3,0);
   }

   if (nhoodz>7) sprintf(textb[0],"(hex)\n");
   else sprintf(textb[0],"(hex)");
   outtext(textb[0]);
   if ((pdata || filedata) && printout==1){
      if (pdata) print_out(textb[0]);
      if (filedata) save_data(textb[0]);
   }
   if ((pdata || filedata) && printout==1)
	lineno=print_current_bitstring_hexbytes(1,thisrule,
					 nhoodz,Maxx,white,1);
   else lineno=print_current_bitstring_hexbytes(1,thisrule,
					 nhoodz,Maxx,white,0);
   if ((pdata || filedata)  && printout==1 && nhoodz<7){
      if (pdata) print_out("\n");
      if (filedata) save_data("\n");
   }
   rightmax=getx;
   if (lineno<=0) lineno+=1;
   moveto(xrulestart,gety+CHeight*(lineno+1));
   if (nhoodz==8) moverel(0,-CHeight);/* to fix bug ??*/
   /*totalistic code*/
   if (totalistic){
      if (nhoodz==9) moveto(xrulestart,gety-CHeight);
      sprintf(textb[0],"code=%d ",
	    (signed short)dec_equiv(cacode[cellindex],nhoodz));
      outtext(textb[0]);
      if (nhoodz==9) moveto(xrulestart,gety+CHeight);
      if ((pdata || filedata) && printout==1){
	 if (pdata) print_out(textb[0]);
	 if (filedata) save_data(textb[0]);
      }
      moveto(getx,gety+CHeight/2);
      print_bit_line(cacode[cellindex],nhoodz+1,lightred, 4, 2);
      moveto(getx+CWidth,gety-CHeight/2);
   }
   if (twod) sprintf(textb[0],"2-d %dx%d ",i2d,j2d);
   else sprintf(textb[0],"Size=%d ",lineL);
   outtext(textb[0]);
   if ((pdata || filedata) && printout==1){
      if (pdata) print_out(textb[0]);
      if (filedata) save_data(textb[0]);
   }
   sprintf(textb[0],"ld=%.3g ld-r=%.3g P=%.3g",
		     lambda,lratio,.5+(1.0-lratio)/2);
   sprintf(textb[1]," zl=%.3g zr=%.3g Z=%g ",
		     zparam[1],zparam[2],zparam[0]);

   outtext(textb[0]);
   myouttext(textb[1]);

   if (getx > rightmax) rightmax=getx; /*max x text position*/
   if ((pdata || filedata) && printout==1){
      if (pdata){
	 print_out(textb[0]);
	 print_out("\n");
	 print_out(textb[1]);
      }
      if (filedata){
	 save_data(textb[0]);
	 save_data("\n");
	 save_data(textb[1]);
      }
   }
   /*show canalyzing inputs*/
   sprintf(textb[0],"C=%d/%d",canaltotal,nhoodz);
   if (canaltotal && nhoodz>1){
      memcpy(textb[0]+5," ",1);
      for (z=nhoodz-1;z>=0;z--){
	 if (get_bit(canal,z)==1){
	     sprintf(textb[1],"%d",z);
	     memcpy(textb[0]+6+nhoodz-1-z,textb[1],1);
	 }
	 else memcpy(textb[0]+6+nhoodz-1-z,"*",1);

      }
   }
   memcpy(textb[0]+6+nhoodz,"\0",1);
   outtext(textb[0]);
   if ((pdata || filedata) && printout==1){
      if (pdata){
	 print_out(textb[0]);
	 print_out("\n");
      }
      if (filedata){
	 save_data(textb[0]);
	 save_data("\n");
      }
   }

   moveto(tempx,tempy);
   return(rightmax);
}
