/********************* GLOBAL DATA 2 (same for watcom) ***************/
#ifndef EXT
   #define EXT extern
#endif

EXT char
     *old_dir,
     *path,
     *filename,
     *filename_data,
     attrepeat, /*1 if pre_image on attractor cycle*/
     **att,     /*array of pointers to pointers to attractor states*/
     **preim0,     /*pointers to pointers to pre-images*/
     **preim1,     /*toggle 2 arrays this<-->next*/
     **textb, /*3 text buffers*/
     scale, 	/*size of ca cell in pixels*/
     textscale,    /*textheight in relation to ca scale*/
     sep,          /*=2 for 1 pix division between cells, 1 for no div*/
     *tickoff,	 /*tick off states in state-space for basin field*/
     gd_z_graph, /*to draw g-of-E density<->Z-parameter graph*/
     lambda_z_graph, /* to draw lambda ratio - Z graph*/
     *codetickoff, /*bitstring for code tickoff for equiv codes*/
     *tempcode, /*temp code table for transformations*/
     pre_fansize_freq_hist, /*to show pre-image frequency histogram*/
     show_maj; /*to show above, maj 0s or 1s..*/
#if __BORC__||__WATCOM__
EXT void
     *stpimage,          /*space-time pattern image buffer for scrolling*/
     **boximage,      /*pointer to image buffers for box*/
     **boximage_prompt, /*image buffer for prompt box*/
     *statblock;
#endif
EXT float
      *zparam, /*zparam[1]=z->, zparam[2]=z<-, zparam[0]=greatest*/
      lowlimZ,/*limit Z range for gd_z_graph nhood<=3 or totalistic*/
      highlimZ,
      lambda,lratio,
      *rad,     /*array of log2 levels*/
      startrad,   /*max radius of attractor cycle in pixels*/
      pstartrad, /* "    "           "       "   % half screen x axis*/
      xoffset,yoffset, 	   /*position of att cycle on screen, % off centre*/
      rightborder, /*if border smaller than this*xspacing, next row*/
      angle, 		/*centre line angle of fan relative to origin*/
      heading,          /*angle of pre-image node    "     "      "  */
      thisrad,          /*distance of given node from origin*/
      nextrad,          /*distance of fan nodes from origin*/
      spot,             /*radius of node spot*/
      firstxspacing,firstyspacing, /* remember initial co-ords*/
      xpspacing,ypspacing,/*spacing between basins, % half screen x-axis*/
      firstxspacing,firstyspacing, /* remember initial co-ords*/
      xpspacefact,ypspacefact,/* % increace in spacing for successive L*/
      xspacefact,yspacefact, /* factor ""        ""           ""  */
      /*factor to change size of default node number or string*/
      labelsizefactor;
EXT signed short

    rand_seed_percent, /*% change for random seed*/
    bitflipcount,    /*count of bits fipped*/
    *flippos,    /*position of flipped bits, up to 50*/
    lastlevel,
    cx,cy,     /*current plot co-ords*/
    ox,oy,  /*co-ords of current origin on or off standard screen*/
    fox,foy, /*initial co-ords for layout preview*/
    firstox,firstoy,  /*initial field co-ords*/
    xspacing,yspacing, /*spacing between basins, in pixels*/
    startxspacing,startyspacing, /*start spacing between basins, in pixels*/
    fieldno, /*count of fields for size range*/
    mut, /*mutant index+1*/
    startmut,endmut, /*start and end bitflip positions, countdown*/
    xx,yy,     /*co-ords of current image*/
    *xx0,*yy0, /*co-ords of next level*/
    *xx1,*yy1, /*or current level*/
    *cyclex,*cycley, /*co-ords of attractor cycle nodes*/
    *segx,*segy,     /*co-ords of fan segments, all 0s or 1s*/
    attindex, /*index of attractor cycle*/
    basinno, /*no of equivalent basins of one type*/
    basintypeno, /*no of non equivalent basin types*/
    barxl,baryt,barxr,baryb, /*for field progress bar*/
    gox,goy,    /*graph x,y origin*/
    graphspot,  /*rad o graph spot*/
    isexception; /*for checking exceptions in Raja's rule*/
EXT unsigned short
    limitcheck,   /*limit of steps checked for repeat*/
    maxinhist;   /*for in-degree histogram, over this limit last bin*/
EXT unsigned char
    linec,       /*color of line*/
    spotc;       /*color of node circle*/
EXT unsigned long
    segstates, /*count of of segmented states*/
    statespace,    /*size of state-space, 0..max*/
    tickspace,    /*size of tick off space, 0..2^18-1*/
    progbar, 	     /*no used states in field so far*/
    thisprogbar,
    sspace, /*state space tick off array*/
    *pre_fan_freq; /*array for pre_fan_frequency*/
EXT double
    lx,ly;   /*length of x,y axes*/
/************* random booean network variables*************/
/*************         random wiring      *****************/
EXT char *rule_all_0s,/*for cheching for same n-tupules in rbn pre-image algorithm*/
     *rule_all_1s,
     defaultwiring,  /*0-no defaults, 1-regular 1-d*/
     acceptallw,     /*=1, accept all wiring defaults*/
     twod,           /*2-D CA*/
     whatwire,       /*type of wiring..
			  hand wire=3
			  regular 2-D=2
			  regular 1-D=1
			  random=0       */
     nonlocal,   /*regular CA, nonlocal=0, else=1 */
     wiring_madelocal, /*to toggle random-local wiring*/
     compress_1d_local, /*if local treated as nonlocal*/
     fixmidwire, /*cell wired to itself =9
		    not  "      "       =8
			no restriction  =0  */
     distinct;   /*no duplicate wiring*/

EXT unsigned short
     **wiring,   /*wiring[cell poss][nhood index]=(wired to) cell poss*/
     *celloutfreq, /*no of output wires to each cell*/
     zonesize;   /*size of wiring zone, if no restriction = lineL*/
EXT signed short
     i2d,j2d;    /*size od 2d grid*/

/*computing pre-images for random wiring*/
EXT char
      ***PS,    /*[tog][Pscount][char array]....partial pre-image 0,1*/
      ***PSflag, /*parrallel array, flags if bit was set=1, empty=0*/
      *PStemp,
      *flagtemp,
      **nhoodE,   /*reduced effective nhood*/
      **skiptable;/*skip rule table entry because nhood reduced*/

EXT unsigned short
	  *PScount;  /*count of partial pre-images in toggled stacks*/

/*************         mixed rules      *****************/
EXT char
     rulemix,   /* =0 for onr rule only, =1 for rule mix*/
     nodiffrules, /*limited no of rule from wich rule choise is made*/
     loc_twod_fonly, /*dont wire up regular 2-d CA, dont allocate wiring mem,
			run forwards only and compute nhood*/
     regular2d; /*2d local nhood*/

/******************  learning algorithms  ***************/
EXT signed short
     notolearn; /*number of pre-images to learn*/
     /*target state, aspiring pre-images (hilight in basin)*/
EXT char
     *tar,**learn_pre,
     hilight_learn, /*to hilight target state, tar and pre in basin*/
     dont_save; /*omit option to save seed*/

/*********** statistics ***************/
EXT signed short
     statx,
     staty,
     oldstatx,
     oldstaty;/*position of point on statistics graph*/
EXT unsigned long
     totstatrules; /*total rules in statistical rule sample*/
